2011-06-04  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Disable WebProcess side display throttling when in a user scroll
        <rdar://problem/9517175>
        https://bugs.webkit.org/show_bug.cgi?id=62095

        Add the ability to disable WebProcess side display throttling that
        takes place in DrawingAreaImpl::displayTimerFired. Disable the throttling
        when in a user or animated scroll.

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::didStartRubberBandForFrame):
        (WebKit::WebChromeClient::didCompleteRubberBandForFrame):
        (WebKit::WebChromeClient::didStartAnimatedScroll):
        (WebKit::WebChromeClient::didCompleteAnimatedScroll):
        * WebProcess/WebPage/DrawingArea.h:
        (WebKit::DrawingArea::enableDisplayThrottling):
        (WebKit::DrawingArea::disableDisplayThrottling):
        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::DrawingAreaImpl):
        (WebKit::DrawingAreaImpl::enableDisplayThrottling):
        (WebKit::DrawingAreaImpl::disableDisplayThrottling):
        (WebKit::DrawingAreaImpl::displayTimerFired):
        * WebProcess/WebPage/DrawingAreaImpl.h:
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::wheelEvent):

2011-06-04  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        [Mac WebKit2] REGRESSION (r86692): Synchronous XMLHttpRequest hangs in credential shim (affects Netgear ReadyNAS admin page)
        https://bugs.webkit.org/show_bug.cgi?id=62094
        rdar://problem/9539204

        * WebKit2.xcodeproj/project.pbxproj: Added new source files.
        * WebProcess/mac/CoreIPCClientRunLoop.h: Added.
        * WebProcess/mac/CoreIPCClientRunLoop.mm: Added.
        (-[WKFunctionAdapter perform]): Added.
        (WebKit::createCoreIPCRunLoopModesArray): Added.
        (WebKit::coreIPCRunLoopModesArray): Added.
        (WebKit::callOnCoreIPCClientRunLoopAndWait): Added.

        * WebProcess/mac/KeychainItemShimMethods.mm:
        (WebKit::webFreeAttributeListContent): Use callOnCoreIPCClientRunLoopAndWait.
        (WebKit::webFreeKeychainItemContent): Ditto.
        (WebKit::webSecKeychainItemCopyContent): Ditto.
        (WebKit::webSecKeychainItemCreateFromContent): Ditto.
        (WebKit::webSecKeychainItemModifyContent): Ditto.
        * WebProcess/mac/SecItemShimMethods.mm:
        (WebKit::webSecItemCopyMatching): Ditto.
        (WebKit::webSecItemAdd): Ditto.
        (WebKit::webSecItemUpdate): Ditto.
        (WebKit::webSecItemDelete): Ditto.

2011-06-04  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        WebKit2 needs to know when a scroll is happening due to the ScrollAnimator
        https://bugs.webkit.org/show_bug.cgi?id=62093

        Stub out new ChromeClient functions regarding the start and end of ScrollAnimator
        animated scrolls, and update logic for rubber-band ending to check for main frame
        now that it is called for all frames.

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::didStartRubberBandForFrame):
        (WebKit::WebChromeClient::didCompleteRubberBandForFrame):
        (WebKit::WebChromeClient::didStartAnimatedScroll):
        (WebKit::WebChromeClient::didCompleteAnimatedScroll):
        * WebProcess/WebCoreSupport/WebChromeClient.h:

2011-06-03  Brady Eidson  <beidson@apple.com>

        Reviewed by Steve Falkenburg.

        <rdar://problem/9553645> and https://bugs.webkit.org/show_bug.cgi?id=62064
        WebBackForwardListItem::setBackForwardData actually appends data

        * Shared/WebBackForwardListItem.cpp:
        (WebKit::WebBackForwardListItem::setBackForwardData): Clear the Vector out before appending
          the replacement data.

2011-06-03  Anders Carlsson  <andersca@apple.com>

        Reviewed by Brady Eidson.

        Disable the sync message timeout for the Microsoft SharePoint plug-in
        https://bugs.webkit.org/show_bug.cgi?id=62043
        <rdar://problem/9536303>

        * WebProcess/Plugins/PluginProcessConnection.cpp:
        (WebKit::defaultSyncMessageTimeout):

2011-06-03  Andreas Kling  <kling@webkit.org>

        Reviewed by Benjamin Poulain.

        [Qt] TiledDrawingArea: Initialize tiles to transparent.

        * UIProcess/qt/TiledDrawingAreaTileQt.cpp:
        (WebKit::TiledDrawingAreaTile::incorporateUpdate): When constructing new
        back buffers, fill them with transparent pixels.

2011-06-03  No'am Rosenthal  <noam.rosenthal@nokia.com>

        Reviewed by Andreas Kling.

        [Qt][WK2] Make tiling on WebKit2 more responsive.
        https://bugs.webkit.org/show_bug.cgi?id=50064

        Instead of creating and destroying pixmaps, and copying them using QPixmap::copy()
        or relying on the implicit sharing functionality, we keep the QPixmaps alive
        and just make sure their content is synchronized.

        This seems to improve responsiveness noticably, as now the UI process doesn't deal
        with allocating/deallocating pixmaps, and the copies are done with the optimized
        path (QPainter) vs the unoptimized ones (QPixmap::copy().)

        * UIProcess/TiledDrawingAreaTile.h:
        * UIProcess/qt/TiledDrawingAreaTileQt.cpp:
        (WebKit::TiledDrawingAreaTile::TiledDrawingAreaTile):
        (WebKit::TiledDrawingAreaTile::isReadyToPaint):
        (WebKit::TiledDrawingAreaTile::hasReadyBackBuffer):
        (WebKit::TiledDrawingAreaTile::swapBackBufferToFront):
        (WebKit::TiledDrawingAreaTile::incorporateUpdate):

2011-06-03  Mikhail Naganov  <mnaganov@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: [Chromium] cpu-profiler-profiling layout test is flaky on Linux Debug.
        https://bugs.webkit.org/show_bug.cgi?id=61533

        Skip cpu-profiler-profiling in debug, implement a fast headless alternative.

        * WebProcess/InjectedBundle/API/c/WKBundleInspector.cpp:
        (WKBundleInspectorSetJavaScriptProfilingEnabled):
        * WebProcess/InjectedBundle/API/c/WKBundleInspector.h:
        * WebProcess/WebPage/WebInspector.cpp:
        (WebKit::WebInspector::setJavaScriptProfilingEnabled):
        * WebProcess/WebPage/WebInspector.h:

2011-06-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Mark Rowe.

        Assert when trying to unload a module that failed to load
        https://bugs.webkit.org/show_bug.cgi?id=61980

        Remove an invalid ASSERT; it's OK for m_bundle to be null if the bundle failed to load.

        * Platform/mac/ModuleMac.mm:
        (WebKit::Module::unload):

2011-06-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Simon Fraser.

        Add quirk for plug-ins that return a retained CALayer
        https://bugs.webkit.org/show_bug.cgi?id=61948
        <rdar://problem/9530390>

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::NetscapePluginModule::determineQuirks):
        Set the ReturnsRetainedCoreAnimationLayer quirk for Flash.

        * Shared/Plugins/PluginQuirks.h:
        Add ReturnsRetainedCoreAnimationLayer quirk.

        * WebProcess/Plugins/Netscape/NetscapeBrowserFuncs.cpp:
        (WebKit::NPN_GetValue):
        Handle WKNVExpectsNonretainedLayer by always returning true, and also
        call NetscapePlugin::setPluginReturnsNonretainedLayer(true) to add a way
        for plug-ins to opt into returning non-retained layers even if they have
        the quirk specified.

        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::NetscapePlugin):
        Initialize m_pluginReturnsNonretainedLayer to true.

        * WebProcess/Plugins/Netscape/NetscapePlugin.h:
        (WebKit::NetscapePlugin::setPluginReturnsNonretainedLayer):
        Add setter.

        * WebProcess/Plugins/Netscape/mac/NetscapePluginMac.mm:
        (WebKit::NetscapePlugin::platformPostInitialize):
        If m_pluginReturnsNonretainedLayer is false, adopt the layer.

2011-06-02  Brent Fulgham  <bfulgham@webkit.org>

        Unreviewed WinCairo build correction.

        * UIProcess/win/WebView.cpp: Don't include CG file header
        when building without CoreGraphics support.

2011-06-02  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Implement popup menus in Webkit2
        https://bugs.webkit.org/show_bug.cgi?id=61854

        * GNUmakefile.am: Add new files to compilation.
        * UIProcess/API/gtk/PageClientImpl.cpp:
        (WebKit::PageClientImpl::createPopupMenuProxy): Create a new
        WebPopupMenuProxy.
        * UIProcess/gtk/WebPopupMenuProxyGtk.cpp: Added.
        (WebKit::WebPopupMenuProxyGtk::WebPopupMenuProxyGtk):
        (WebKit::WebPopupMenuProxyGtk::~WebPopupMenuProxyGtk):
        (WebKit::WebPopupMenuProxyGtk::showPopupMenu):
        (WebKit::WebPopupMenuProxyGtk::hidePopupMenu):
        (WebKit::WebPopupMenuProxyGtk::shutdownRunLoop):
        (WebKit::WebPopupMenuProxyGtk::menuItemActivated):
        (WebKit::WebPopupMenuProxyGtk::menuUnmapped):
        * UIProcess/gtk/WebPopupMenuProxyGtk.h: Added.
        (WebKit::WebPopupMenuProxyGtk::create):
        (WebKit::WebPopupMenuProxyGtk::setActiveItem):

2011-06-01  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Non-users need access to the mds caches for SSL support.
        <rdar://problem/9471799>

        * WebProcess/com.apple.WebProcess.sb:

2011-06-01  Jer Noble  <jer.noble@apple.com>

        Reviewed by Maciej Stachowiak.

        Flash of old video frame at the end of full screen transition
        https://bugs.webkit.org/show_bug.cgi?id=61752

        Add a new method and message, DisposeOfLayerClient, which will invalidate and release
        the WKRemoteLayerClient used during the full-screen animation.  This ensures that 
        the root layer used for the full-screen animation will be in a clean state at the start
        of the next transition.

        * UIProcess/WebFullScreenManagerProxy.cpp:
        (WebKit::WebFullScreenManagerProxy::disposeOfLayerClient): Added.
        * UIProcess/WebFullScreenManagerProxy.h:
        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController exitCompositedModeRepaintCompleted]): Call disposeOfLayerClient.
        * WebProcess/FullScreen/WebFullScreenManager.h:
        (WebKit::WebFullScreenManager::disposeOfLayerClient): Added.
        * WebProcess/FullScreen/WebFullScreenManager.messages.in: Added DisposeOfLayerClient.
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.h:
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::disposeOfLayerClient): Added, invalidates and clears m_rootLayerClient.

2011-06-01  Adam Roben  <aroben@apple.com>

        Build fix after r87831

        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::enterAcceleratedCompositingMode):
        (WebKit::WebView::exitAcceleratedCompositingMode):
        Added some HAVE(WKQCA) guards.

2011-06-01  Adam Roben  <aroben@apple.com>

        Delete a bunch of dead code in DrawingAreaImpl

        LayerTreeHost::participatesInDisplay always returns false now, which means a bunch of code
        in DrawingAreaImpl no longer runs.

        Cleanup after fixing <http://webkit.org/b/58054>
        <rdar://problem/9249839> REGRESSION (WebKit2): Accelerated CSS animations have a lower
        framerate than in WebKit1

        Reviewed by Anders Carlsson.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::forceRepaint):
        (WebKit::DrawingAreaImpl::layerHostDidFlushLayers):
        (WebKit::DrawingAreaImpl::sendDidUpdateBackingStoreState):
        (WebKit::DrawingAreaImpl::didUpdate):
        (WebKit::DrawingAreaImpl::enterAcceleratedCompositingMode):
        (WebKit::DrawingAreaImpl::exitAcceleratedCompositingMode):
        (WebKit::DrawingAreaImpl::scheduleDisplay):
        (WebKit::DrawingAreaImpl::displayTimerFired):
        (WebKit::DrawingAreaImpl::display):
        * WebProcess/WebPage/DrawingAreaImpl.h:
        * WebProcess/WebPage/LayerTreeHost.h:
        Reverted r82959.

2011-06-01  Adam Roben  <aroben@apple.com>

        Render accelerated content into a web process-owned child HWND

        This allows us to use WKCACFView's far more efficient kWKCACFViewDrawingDestinationWindow
        mode, which gives us asynchronous rendering on a background thread and doesn't require us to
        read bits off the GPU back into system memory.

        A new class, WKCACFViewWindow, represents the child HWND. The child HWND is placed at the
        bottom of the z-order so it won't obscure any other child HWNDs (i.e., windowed plugins).
        The child HWND is made transparent to mouse events so that WKView will continue to receive
        mouse events even though it is obscured by the child HWND.

        There is now a bunch of dead code in DrawingAreaImpl to handle our old rendering model. I'll
        remove that in a future patch.

        Fixes <http://webkit.org/b/58054> <rdar://problem/9249839> REGRESSION (WebKit2): Accelerated
        CSS animations have a lower framerate than in WebKit1

        Reviewed by Anders Carlsson.

        * Shared/LayerTreeContext.h: Added HWND member on Windows.

        * Shared/win/CoalescedWindowGeometriesUpdater.cpp:
        (WebKit::CoalescedWindowGeometriesUpdater::updateGeometries):
        * Shared/win/CoalescedWindowGeometriesUpdater.h:
        Added new BringToTopOrNot argument. Allows the caller to specify that all windows being
        updated should also be brought to the top of the z-order.

        * Shared/win/LayerTreeContextWin.cpp:
        (WebKit::LayerTreeContext::LayerTreeContext):
        (WebKit::LayerTreeContext::~LayerTreeContext):
        (WebKit::LayerTreeContext::encode):
        (WebKit::LayerTreeContext::decode):
        (WebKit::LayerTreeContext::isEmpty):
        (WebKit::operator==):
        Implemented based on new window member.

        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::WebView): Initialize new member.
        (WebKit::WebView::onSizeEvent): Resize the layer host window to cover our entire view, if we
        have one.
        (WebKit::WebView::enterAcceleratedCompositingMode): Store, position, and show the layer host
        window.
        (WebKit::WebView::exitAcceleratedCompositingMode): Destroy the layer host window.
        (WebKit::WebView::updateChildWindowGeometries): Updated for change to
        CoalescedWindowGeometriesUpdater.

        * UIProcess/win/WebView.h: Added m_layerHostWindow member.

        * WebProcess/WebPage/LayerTreeHost.h: Added scheduleChildWindowGeometryUpdate.

        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.cpp:
        (WebKit::LayerTreeHostCAWin::supportsAcceleratedCompositing): Simplified by using
        WKCACFViewWindow.

        (WebKit::LayerTreeHostCAWin::LayerTreeHostCAWin): Removed initialization of a removed
        member.
        (WebKit::LayerTreeHostCAWin::platformInitialize): Changed to use WKCACFViewWindow,
        kWKCACFViewDrawingDestinationWindow, and to initialize the LayerTreeContext.
        (WebKit::LayerTreeHostCAWin::invalidate): Leak our window and tell it to clean up after
        itself. The UI process will take care of destroying the window when it finishes switching
        out of accelerated compositing mode. Removed a WKCACFViewUpdate call that is now handled by
        WKCACFViewWindow.
        (WebKit::LayerTreeHostCAWin::scheduleChildWindowGeometryUpdate): Added. Calls through to
        m_geometriesUpdater.
        (WebKit::LayerTreeHostCAWin::sizeDidChange): Updated to use WKCACFViewWindow.
        (WebKit::LayerTreeHostCAWin::contextDidChange): Update child window geometries now to keep
        them (almost) in sync with the accelerated content. <http://webkit.org/b/61867> covers the
        slight asynchrony that still exists.
        (WebKit::LayerTreeHostCAWin::setRootCompositingLayer): Don't flush any changes when we don't
        have a root layer. This prevents a flash of white when switching out of compositing mode.

        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.h: Added m_window and m_geometriesUpdater.
        Removed code related to the old, synchronous display model.

        * WebProcess/WebPage/ca/win/WKCACFViewWindow.cpp: Added.
        (WebKit::WKCACFViewWindow::WKCACFViewWindow): Initialize members and create our window.
        (WebKit::WKCACFViewWindow::~WKCACFViewWindow): Destroy our window if needed.
        (WebKit::WKCACFViewWindow::onCustomDestroy): Just call ::DestroyWindow.
        (WebKit::WKCACFViewWindow::onDestroy): Tell our view not to render into our window anymore.
        (WebKit::WKCACFViewWindow::onEraseBackground): Tell Windows not to erase us.
        (WebKit::WKCACFViewWindow::onNCDestroy): Clear out m_window since it's now pointing to a
        destroy window, and destroy ourselves if requested.
        (WebKit::WKCACFViewWindow::onPaint): Tell the view to draw, then clear our invalid region.
        (WebKit::WKCACFViewWindow::onPrintClient): Tell our view to draw into the given HDC.
        (WebKit::WKCACFViewWindow::registerClass): Register our class (duh).
        (WebKit::WKCACFViewWindow::staticWndProc): Get the WKCACFViewWindow pointer, or store the
        pointer if needed, then call through to wndProc.
        (WebKit::WKCACFViewWindow::wndProc): Call out to the appropriate handler function.

        * WebProcess/WebPage/ca/win/WKCACFViewWindow.h: Added.
        (WebKit::WKCACFViewWindow::setDeletesSelfWhenWindowDestroyed): Simple setter.
        (WebKit::WKCACFViewWindow::window): Simple getter.

        * WebProcess/WebPage/win/DrawingAreaImplWin.cpp:
        (WebKit::DrawingAreaImpl::scheduleChildWindowGeometryUpdate): Let the LayerTreeHost handle
        the geometry update, if we have one.

        * win/WebKit2.vcproj: Added WKCACFViewWindow files.

2011-06-01  Adam Roben  <aroben@apple.com>

        Route plugin window geometry updates through the DrawingArea

        This will allow the geometry updates to be handled by the LayerTreeHost in compositing mode
        in the future.

        More rep work for <http://webkit.org/b/58054> <rdar://problem/9249839> REGRESSION (WebKit2):
        Accelerated CSS animations have a lower framerate than in WebKit1

        Reviewed by Anders Carlsson.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::scheduleWindowedPluginGeometryUpdate): Tell the DrawingArea, not the
        WebPage, about the geometry update.

        * WebProcess/WebPage/DrawingArea.h:
        * WebProcess/WebPage/DrawingAreaImpl.h:
        * WebProcess/WebPage/win/DrawingAreaImplWin.cpp: Added.
        (WebKit::DrawingAreaImpl::scheduleChildWindowGeometryUpdate):
        Moved code here...

        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/win/WebPageWin.cpp:
        ...from here.

        * win/WebKit2.vcproj: Added DrawingAreaImplWin.cpp.

2011-06-01  Adam Roben  <aroben@apple.com>

        Move WebView's window geometry updating code to a new class

        This will allow us to share this code with LayerTreeHostCAWin.

        Prep work for <http://webkit.org/b/58054> <rdar://problem/9249839> REGRESSION (WebKit2):
        Accelerated CSS animations have a lower framerate than in WebKit1

        Reviewed by Anders Carlsson.

        * Shared/win/CoalescedWindowGeometriesUpdater.cpp: Added.
        (WebKit::CoalescedWindowGeometriesUpdater::CoalescedWindowGeometriesUpdater):
        (WebKit::CoalescedWindowGeometriesUpdater::~CoalescedWindowGeometriesUpdater):
        Simple constructor/destructor.

        (WebKit::CoalescedWindowGeometriesUpdater::addPendingUpdate):
        (WebKit::setWindowRegion):
        (WebKit::CoalescedWindowGeometriesUpdater::updateGeometries):
        * Shared/win/CoalescedWindowGeometriesUpdater.h: Added.
        Moved code here...

        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::scheduleChildWindowGeometryUpdate):
        (WebKit::WebView::updateChildWindowGeometries):
        * UIProcess/win/WebView.h:
        ...from here.

        * win/WebKit2.vcproj: Added new files.

2011-06-01  Adam Roben  <aroben@apple.com>

        Windows build fix after r87755

        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.cpp:
        (WebKit::LayerTreeHostCAWin::setLayerFlushSchedulingEnabled): Fixed
        typo.

2011-06-01  Oleg Romashin  <romaxa@gmail.com>

        Reviewed by Kenneth Rohde Christiansen.

        platformGeometryDidChange function definition was changed everywhere except Qt.
        This is fix for Qt WK2 plugins compilation
        https://bugs.webkit.org/show_bug.cgi?id=61832

        * PluginProcess/qt/PluginControllerProxyQt.cpp:
        (WebKit::PluginControllerProxy::platformGeometryDidChange):

2011-05-31  Jer Noble  <jer.noble@apple.com>

        Reviewed by Darin Adler.

        Flash of black at the end of full screen transition at apple.com product videos
        https://bugs.webkit.org/show_bug.cgi?id=61756

        The @"WebKitLayerHostChanged" notification is causing the QTMovie to tear down its layer
        (which is good) at the wrong time (which is bad).  Send this notification only after 
        the dragImage snapshot is taken.  This exposed another problem, that the snapshot has
        a white background.  Set the default background color and transparency for the view (making
        sure to reset them afterwards) to transparent.

        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::setRootFullScreenLayer):

2011-03-30  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Adam Roben.

        [GTK] [WebKit2] Implement a basic WebKitTestRunner
        https://bugs.webkit.org/show_bug.cgi?id=57068

        Added InjectedBundle support for GTK+.

        * WebProcess/InjectedBundle/InjectedBundle.h: Added typedef for GTK+.
        * WebProcess/InjectedBundle/gtk/InjectedBundleGtk.cpp: Added implementation.
        (WebKit::InjectedBundle::load): 
        (WebKit::InjectedBundle::activateMacFontAscentHack):
        * WebProcess/WebPage/gtk/WebPageGtk.cpp: Remove unnecessary method definition.

2011-05-31  Dan Bernstein  <mitz@apple.com>

        Reviewed by Simon Fraser.

        <rdar://problem/9523192> REGRESSION (5.0.5-ToT, WebKit2): Flash to white when navigating between pages on wsj.com, other sites (when navigating away from composited page)
        https://bugs.webkit.org/show_bug.cgi?id=61808

        WebKit1 has a mechanism to prevent the stale bits from the outgoing page from being erased
        until the incoming page has layout. Adapt this in WebKit2 to prevent the composited layer tree
        of the outgoing page from being torn down or updated until the incoming page has layout.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::dispatchDidFirstLayout): Unfreeze the layer tree state.
        (WebKit::WebFrameLoaderClient::frameLoadCompleted): Ditto.
        (WebKit::WebFrameLoaderClient::provisionalLoadStarted): Freeze the layer tree state.

        * WebProcess/WebPage/DrawingArea.h:
        (WebKit::DrawingArea::setLayerTreeStateIsFrozen): Added.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::DrawingAreaImpl): Initialize new member variables.
        (WebKit::DrawingAreaImpl::setLayerTreeStateIsFrozen): Added. When freezing, sets the flag and
        disables layer flush scheduling and exiting accelerated compositing mode. When unfreezing,
        clears the flag and exits compositing mode if needed.
        (WebKit::DrawingAreaImpl::setRootCompositingLayer): Reset m_wantsToExitAcceleratedCompositingMode.
        (WebKit::DrawingAreaImpl::enterAcceleratedCompositingMode): Ditto.
        (WebKit::DrawingAreaImpl::exitAcceleratedCompositingMode): Ditto.
        (WebKit::DrawingAreaImpl::exitAcceleratedCompositingModeSoon): If the layer tree state is frozen,
        bail out but set m_wantsToExitAcceleratedCompositingMode.

        * WebProcess/WebPage/DrawingAreaImpl.h:
        * WebProcess/WebPage/LayerTreeHost.h:

        * WebProcess/WebPage/ca/LayerTreeHostCA.cpp:
        (WebKit::LayerTreeHostCA::LayerTreeHostCA): Initialize m_layerFlushSchedulingEnabled.

        * WebProcess/WebPage/ca/LayerTreeHostCA.h:
        * WebProcess/WebPage/ca/mac/LayerTreeHostCAMac.h:

        * WebProcess/WebPage/ca/mac/LayerTreeHostCAMac.mm:
        (WebKit::LayerTreeHostCAMac::scheduleLayerFlush): Bail out if scheduling is not enabled.
        (WebKit::LayerTreeHostCAMac::setLayerFlushSchedulingEnabled): Added. Sets the flag. If disabling
        flushing, cancels the pending flush.
        (WebKit::LayerTreeHostCAMac::flushPendingLayerChangesRunLoopObserverCallback): Added an assertion.

        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.cpp:
        (WebKit::LayerTreeHostCAWin::scheduleLayerFlush): Bail out if scheduling is not enabled.
        (WebKit::LayerTreeHostCAWin::setLayerFlushSchedulingEnabled): Added. Sets the flag. If disabling
        flushing, cancels the pending flush.

        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.h:

2011-05-31  ChangeLog  <james.cooley@nokia.com>

        Reviewed by Andreas Kling.

        [Qt][WK2] Qt port needs test content for QWKHistory
        https://bugs.webkit.org/show_bug.cgi?id=57850

        Created data-driven QTestLib tests for existing QWKHistory APIs.

        This walks through loading four simple pages, navigating
        backwards and forwards.

        We check the results at each action by creating expected forward/back
        lists and comparing those lists in count and membership to those kept by
        WebKit and retrieved via the QWKHistory APIs.

        * UIProcess/API/qt/tests/html/a.htm: Added.
        * UIProcess/API/qt/tests/html/b.htm: Added.
        * UIProcess/API/qt/tests/html/c.htm: Added.
        * UIProcess/API/qt/tests/html/d.htm: Added.
        Four added simple pages

        * UIProcess/API/qt/tests/qwkhistory: Added.
        * UIProcess/API/qt/tests/qwkhistory/qwkhistory.pro: Added.
        Created qwkhistory folder and pro

        * UIProcess/API/qt/tests/qwkhistory/tst_qwkhistory.cpp: Added.
        (TestHistoryItem::title):
        (TestHistoryItem::url):
        (TestHistoryItem::TestHistoryItem):
        Utility class to hold expected url,title for test

        (tst_QWKHistory::initTestCase):
        (tst_QWKHistory::historyFBTest_data):
        (tst_QWKHistory::historyFBTest):
        init, data, and data-driven test case

        * UIProcess/API/qt/tests/tests.pro:
        Included qwkhistory in tests.pro

2011-05-30  No'am Rosenthal  <noam.rosenthal@nokia.com>

        Reviewed by Simon Hausmann.

        WebKit2: Enable serializing of data types needed for cross-process accelerated compositing
        https://bugs.webkit.org/show_bug.cgi?id=61694

        Create an ArgumentCoder for WebCore::Animation.

        * Scripts/webkit2/messages.py:
        * Shared/WebCoreArgumentCoders.h:

2011-05-30  No'am Rosenthal  <noam.rosenthal@nokia.com>

        Reviewed by Simon Hausmann.

        WebKit2: Enable serializing of data types needed for cross-process accelerated compositing
        https://bugs.webkit.org/show_bug.cgi?id=61694

        Add an ArgumentCoder for WebCore::TimingFunction. This serializer can create the appropriate
        TimingFunction subclass based on the type of timing function.

        * Scripts/webkit2/messages.py:
        * Shared/WebCoreArgumentCoders.h:

2011-05-30  No'am Rosenthal  <noam.rosenthal@nokia.com>

        Reviewed by Simon Hausmann.

        WebKit2: Enable serializing of data types needed for cross-process accelerated compositing
        https://bugs.webkit.org/show_bug.cgi?id=61694

        Add WebCore::Length and WebCore::TransformationMatrix to the types that use SimpleArgumentCoder.

        * Scripts/webkit2/messages.py:
        * Shared/WebCoreArgumentCoders.h:

2011-05-30  Anders Carlsson  <andersca@apple.com>

        Reviewed by Simon Fraser.

        Remove incorrect asserts from PluginProcessConnection
        https://bugs.webkit.org/show_bug.cgi?id=61731

        There might be pending incoming messages from a PluginProxy even though we've
        destroyed the plug-in and removed it from the m_plugins map, so remove the incorrect assertions.

        * WebProcess/Plugins/PluginProcessConnection.cpp:
        (WebKit::PluginProcessConnection::didReceiveMessage):
        (WebKit::PluginProcessConnection::didReceiveSyncMessage):

2011-05-30  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Initial tooltips implementation for WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=59318

        * UIProcess/API/gtk/PageClientImpl.cpp:
        (WebKit::PageClientImpl::toolTipChanged): Update view's tooltip
        text.
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseQueryTooltip): Implement GtkWidget::query-tooltip.
        (webkit_web_view_base_class_init): Override GtkWidget::query-tooltip.
        (webkitWebViewBaseSetTooltipText): Update tooltip text and trigger
        GtkWidget::query-tooltip.
        * UIProcess/API/gtk/WebKitWebViewBasePrivate.h:

2011-05-30  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Remove some unneeded header includes
        https://bugs.webkit.org/show_bug.cgi?id=60536

        * Platform/CoreIPC/Connection.cpp: Remove WebProcess.h.
        * Platform/CoreIPC/unix/ConnectionUnix.cpp: Remove
        ProcessLauncher.h and WebProcessProxy.h. Add <wtf/OwnArrayPtr.h>.
        * WebProcess/Plugins/Netscape/NPJSObject.cpp: Remove PluginView.h.

2011-05-29  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Race condition in full screen controller, which leads to problem when web process crashes
        https://bugs.webkit.org/show_bug.cgi?id=61707

        Second try at this. First try could lead to a WKView leak.

        * UIProcess/mac/WKFullScreenWindowController.h: Added _isExitingAcceleratedCompositingMode.
        Needed to track whether we have retained so we don't leak if the page goes away before
        we get the callback.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController exitAcceleratedCompositingMode]): Added code to set
        the new variable to YES.
        (-[WKFullScreenWindowController exitCompositedModeRepaintCompleted]): Added code to
        deal with the new boolean and to release.
        (exitCompositedModeRepaintCompleted): Removed the release that was here.
        (-[WKFullScreenWindowController close]): Added a call to exitCompositedModeRepaintCompleted
        here. We're as complete as we'll ever be when we're closed; we can't get the callback
        after that point.

2011-05-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        REGRESSION (r87637): nytimes.com freezes after going back to it
        <rdar://problem/9521928>

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::forceRepaint):
        Add call to setShouldNotifyAfterNextScheduledLayerFlush(false) to prevent a
        redundant call to layerHostDidFlushLayers which would cause the layer state
        to get out of sync with the UIProcess.

2011-05-29  Jer Noble  <jer.noble@apple.com>

        Reviewed by Simon Fraser.

        REGRESSION (r86924): webkitRequestFullScreen does not work properly (black screen, can’t interact)
        https://bugs.webkit.org/show_bug.cgi?id=61710

        When taking the documentElement full screen, we don't create a RenderFullScreen 
        object and thus never enter accelerated compositing mode for the animation. Tell
        the WKFullScreenWindowController to enter accelerated compositing mode anyway 
        (with an empty layer context) so as to fulfill its expectations and cause the 
        full screen animation to complete.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]): Added a 
            comment explaining when we expect the animation to complete.
        (-[WKFullScreenWindowController enterAcceleratedCompositingMode:WebKit::]):
            Remove an ASSERT which is no longer valid.
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::beginEnterFullScreenAnimation): Tell the UIProcess
            to enter then exit full-screen mode.
        (WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation): Ditto.

2011-05-29  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Race condition in full screen controller, which leads to problem when web process crashes
        https://bugs.webkit.org/show_bug.cgi?id=61707

        Saw this while debugging a crash. We don't have a way to make regression tests for this
        kind of issue at this time.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController exitAcceleratedCompositingMode]): Retain the controller
        here since we are keeping a pointer to it.
        (exitCompositedModeRepaintCompleted): Release the controller here.

2011-05-29  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        REGRESSION (87637): Entering WebKit Full Screen mode causes an assertion in DrawingAreaImpl::layerHostDidFlushLayers
        https://bugs.webkit.org/show_bug.cgi?id=61706
        <rdar://problem/9521970>

        If we've already let the UI process know that we're in compositing mode, we just need to force a repaint.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::forceRepaint):

2011-05-29  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=61700
        Need WebKit2 API to get the size of the render tree
        -and corresponding-
        <rdar://problem/9512733>

        * UIProcess/API/C/WKPage.cpp:
        (WKPageGetRenderTreeSize):
        * UIProcess/API/C/WKPage.h:
        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::renderTreeSize):
        (WebKit::WebPageProxy::setRenderTreeSize):
        * UIProcess/WebPageProxy.messages.in:
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::setRenderTreeSize):
        * WebProcess/WebCoreSupport/WebChromeClient.h:

2011-05-29  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson and Simon Fraser.

        <rdar://problem/9519453>
        When calling ForceRepaint on a page with accelerated compositing, we can get
        a race condition where the UI process paints the old content, resulting in showing
        the previous page. That happens because forceRepaint's callback waits for the next
        repaint to happen, but nothing notifies UI process that the page is in accelerated
        compositing mode.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::forceRepaint): Call layerHostDidFlushLayers instead of
        just calling forceRepaint on the layer tree host.

2011-05-28  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein, Maciej Stachowiak.

        Denying access to your keychain on login crashes WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=61695
        <rdar://problem/9520570>
        
        Fix two sources of crashes if you hit the Deny button when WebKit2 is
        doing HTTP authentication.
        
        First, SecKeychainItemRequestData::attributeList() failed to initialize the
        length and data members of SecKeychainAttributes in the list if there was no data.
        This caused invalid memory reads later.
        
        Second, returning a non-zero error from the SecKeychainItemCopyContent shim method
        would cause a later crash in a system framework, which is not set up to handle
        errors. Instead, we always return noErr, and allow the authentication to fail.
        
        Finally, paranoically initialize the SecKeychainItemContext in two places
        to avoid uninitialized data members, and initialize length and outData
        to 0 in secKeychainItemCopyContent() in case SecKeychainItemCopyContent()
        fails to set them on error.
        
        * Shared/mac/SecKeychainItemRequestData.cpp:
        (WebKit::SecKeychainItemRequestData::attributeList):
        * UIProcess/mac/WebProcessProxyMac.mm:
        (WebKit::WebProcessProxy::secKeychainItemCopyContent): 
        * WebProcess/mac/KeychainItemShimMethods.mm:
        (WebKit::webSecKeychainItemCopyContent):
        (WebKit::webSecKeychainItemCreateFromContent):

2011-05-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        REGRESSION (r86578): Flash content missing from mercurynews.com
        https://bugs.webkit.org/show_bug.cgi?id=61691
        <rdar://problem/9519893>

        If the plug-in doesn't have access to the toplevel URL, make sure to
        return *something* to the plug-in.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::tryToShortCircuitInvoke):

2011-05-28  Adam Barth  <abarth@webkit.org>

        Reviewed by Alexey Proskuryakov.

        Audit all uses of KURL::prettyURL
        https://bugs.webkit.org/show_bug.cgi?id=61201

        Update callers of prettyURL to just call string.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::createPlugin):
        * WebProcess/WebCoreSupport/qt/WebErrorsQt.cpp:
        (WebKit::cancelledError):
        (WebKit::blockedError):

2011-05-27  Stephanie Lewis  <slewis@apple.com>

        Unreviewed.

        Fix a typo in the order_file flag.

        * Configurations/Base.xcconfig:

2011-05-27  Stephanie Lewis  <slewis@apple.com>

        Rubber Stamped by Adam Roben.

        Add Order File.  Use -order_file flag since it can order more of the binary.

        * Configurations/Base.xcconfig:
        * mac/WebKit2.order: Added.

2011-05-27  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [CAIRO] Don't copy the surface before drawing it into the context in ShareableBitmap::paint()
        https://bugs.webkit.org/show_bug.cgi?id=60757

        cairo_image_surface_create_for_data() is already a shallow copy of
        the image, so we don't need to copy it again.

        * Shared/cairo/ShareableBitmapCairo.cpp:
        (WebKit::ShareableBitmap::paint):

2011-05-26  Jeff Miller  <jeffm@apple.com>

        Reviewed by Alexey Proskuryakov.

        Add a key handling logging channel for WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=61588
        
        Added a new LogKeyHandling channel, and logged some key events in WebPageProxy.
        I also fixed a misspelling of coalescing in a comment in WebPageProxy.cpp.

        * Platform/Logging.cpp:
        (WebKit::initializeLogChannelsIfNecessary): Initialize LogKeyHandling channel.
        * Platform/Logging.h: Added LogKeyHandling channel.

        * UIProcess/WebPageProxy.cpp: Fixed misspelling of coalescing in a comment.
        (WebKit::webKeyboardEventTypeString): Added to support logging.
        (WebKit::WebPageProxy::handleKeyboardEvent): Log the keyboard event.
        (WebKit::WebPageProxy::didReceiveEvent): Log the keyboard event.

2011-05-26  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Darin Adler.

        Safari's AXFocusedUIElement attribute returns WebArea object with AXSelectedTextMarkerRange of nil
        https://bugs.webkit.org/show_bug.cgi?id=61492

        The method for determining which WebPage is actually focused and foreground was faulty. More
        extensive checks are required to check which WebPage should be returned as the focusable one.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::windowIsFocused):

2011-05-26  Jon Lee  <jonlee@apple.com>

        Reviewed by Darin Adler.

        REGRESSION (5.0.5-Jazz): Transition to full screen video animates in wrong location when scrolled (61559)
        https://bugs.webkit.org/show_bug.cgi?id=61559
        <rdar://problem/9496054>

        The CALayer that gets animated has a position that is offset by the scroll position of the web view. To
        fix this, we set the destination location based on the rect of the full screen, and add a position
        animation which keeps the position of the layer centered. This prevents glitches if others
        are trying to change the layer position while the animation is running.

        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.h: Refactor the calculation of the CALayer windowed
        position into a private helper function, as well as the animation setup.
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::beginEnterFullScreenAnimation):
        (WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation):
        (WebKit::WebFullScreenManagerMac::animateFullScreen): Sets up the zoom animation, and the position offset
        animation.
        (WebKit::WebFullScreenManagerMac::windowedCGTransform): Calculates the placement of the windowed layer
        in screen coordinates.

2011-05-26  Qi Zhang  <qi.2.zhang@nokia.com>

        Reviewed by Andreas Kling.

        WebKitTestRunner needs layoutTestController.setAuthorAndUserStylesEnabled
        https://bugs.webkit.org/show_bug.cgi?id=42676

        Implemented layoutTestController.setAuthorAndUserStylesEnabled for WebKitTestRunner.

        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleSetAuthorAndUserStylesEnabled):
        * WebProcess/InjectedBundle/API/c/WKBundlePrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::setAuthorAndUserStylesEnabled):
        * WebProcess/InjectedBundle/InjectedBundle.h:

2011-05-25  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        WebKit2: Status bar, toolbar, and menu bar checks should be in the injected bundle
        https://bugs.webkit.org/show_bug.cgi?id=61474
        <rdar://problem/9468337>

        * WebProcess/InjectedBundle/API/c/WKBundlePage.h:
        * WebProcess/InjectedBundle/InjectedBundlePageUIClient.cpp:
        (WebKit::InjectedBundlePageUIClient::statusBarIsVisible): Call the function on the client
            if it exists.
        (WebKit::InjectedBundlePageUIClient::menuBarIsVisible): Ditto.
        (WebKit::InjectedBundlePageUIClient::toolbarsAreVisible): Ditto.
        * WebProcess/InjectedBundle/InjectedBundlePageUIClient.h:
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::statusbarVisible): Add a possible short-circuit in the injected bundle.
        (WebKit::WebChromeClient::menubarVisible): Ditto.
        (WebKit::WebChromeClient::toolbarsVisible): Ditto.

2011-05-26  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam Roben.

        WebKit2 bundle missing localization subdirectories
        https://bugs.webkit.org/show_bug.cgi?id=61512
        
        Better fix for this. We just need to specify CFBundleAllowMixedLocalizations.

        * win/WebKit2WebProcess.resources/English.lproj: Removed.
        * win/WebKit2WebProcess.resources/Info.plist:
        * win/WebKit2WebProcess.resources/da.lproj: Removed.
        * win/WebKit2WebProcess.resources/de.lproj: Removed.
        * win/WebKit2WebProcess.resources/es.lproj: Removed.
        * win/WebKit2WebProcess.resources/fi.lproj: Removed.
        * win/WebKit2WebProcess.resources/fr.lproj: Removed.
        * win/WebKit2WebProcess.resources/it.lproj: Removed.
        * win/WebKit2WebProcess.resources/ja.lproj: Removed.
        * win/WebKit2WebProcess.resources/ko.lproj: Removed.
        * win/WebKit2WebProcess.resources/nb.lproj: Removed.
        * win/WebKit2WebProcess.resources/nl.lproj: Removed.
        * win/WebKit2WebProcess.resources/pl.lproj: Removed.
        * win/WebKit2WebProcess.resources/pt.lproj: Removed.
        * win/WebKit2WebProcess.resources/pt_PT.lproj: Removed.
        * win/WebKit2WebProcess.resources/ru.lproj: Removed.
        * win/WebKit2WebProcess.resources/sv.lproj: Removed.
        * win/WebKit2WebProcess.resources/zh_CN.lproj: Removed.
        * win/WebKit2WebProcess.resources/zh_TW.lproj: Removed.

2011-05-26  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam Roben.

        WebKit2 bundle missing localization subdirectories
        https://bugs.webkit.org/show_bug.cgi?id=61512
        <rdar://problem/9498607>
        
        These lproj directories are intentionally left empty.
        Their presence indicates that this exe is localized to this
        set of languages.

        * win/WebKit2WebProcess.resources/English.lproj: Added.
        * win/WebKit2WebProcess.resources/da.lproj: Added.
        * win/WebKit2WebProcess.resources/de.lproj: Added.
        * win/WebKit2WebProcess.resources/es.lproj: Added.
        * win/WebKit2WebProcess.resources/fi.lproj: Added.
        * win/WebKit2WebProcess.resources/fr.lproj: Added.
        * win/WebKit2WebProcess.resources/it.lproj: Added.
        * win/WebKit2WebProcess.resources/ja.lproj: Added.
        * win/WebKit2WebProcess.resources/ko.lproj: Added.
        * win/WebKit2WebProcess.resources/nb.lproj: Added.
        * win/WebKit2WebProcess.resources/nl.lproj: Added.
        * win/WebKit2WebProcess.resources/pl.lproj: Added.
        * win/WebKit2WebProcess.resources/pt.lproj: Added.
        * win/WebKit2WebProcess.resources/pt_PT.lproj: Added.
        * win/WebKit2WebProcess.resources/ru.lproj: Added.
        * win/WebKit2WebProcess.resources/sv.lproj: Added.
        * win/WebKit2WebProcess.resources/zh_CN.lproj: Added.
        * win/WebKit2WebProcess.resources/zh_TW.lproj: Added.
        * win/WebKit2WebProcessPostBuild.cmd: Copy entire resources directory, exclude .svn directories.
        * win/xcopy.excludes: Added. Excludes .svn directories.

2011-05-25  Qi Zhang  <qi.2.zhang@nokia.com>

        Reviewed by Simon Hausmann.

        WebKitTestRunner needs layoutTestController.setPrivateBrowsingEnabled
        https://bugs.webkit.org/show_bug.cgi?id=42697

        Implemented layoutTestController.setPrivateBrowsingEnabled for WebKitTestRunner.

        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleSetPrivateBrowsingEnabled):
        * WebProcess/InjectedBundle/API/c/WKBundlePrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::setPrivateBrowsingEnabled):
        * WebProcess/InjectedBundle/InjectedBundle.h:

2011-05-25  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/9504058> Need some way to query user gesture state from injected bundle

        Add WKBundleIsProcessingUserGesture.

        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleIsPageBoxVisible):
        (WKBundleIsProcessingUserGesture):
        * WebProcess/InjectedBundle/API/c/WKBundlePrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::isProcessingUserGesture):
        * WebProcess/InjectedBundle/InjectedBundle.h:

2011-05-24  Jer Noble  <jer.noble@apple.com>

        Reviewed by Darin Adler.

        Video fails to play on Vimeo
        https://bugs.webkit.org/show_bug.cgi?id=61403

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface): Added support for wkAVAssetResolvedURL and
            wkQTMovieResolvedURL.

2011-05-25  Jon Honeycutt  <jhoneycutt@apple.com>

        REGRESSION (WebKit2): Crash in Flash on USA Today photo gallery
        https://bugs.webkit.org/show_bug.cgi?id=61428
        <rdar://problem/9457006>

        Reviewed by Adam Roben.

        The crash occurs when Flash posts a message to a window that it
        creates, and in processing the message, it calls NPN_Evaluate to
        evaluate JavaScript that removes the plug-in from the page. Flash then
        crashes when we return to Flash code.

        * Platform/WorkItem.h:
        (DerefWorkItem::DerefWorkItem):
        Initialize m_ptr.
        (DerefWorkItem::execute):
        Deref the object.
        (WorkItem::createDeref):
        Create and return a DerefWorkItem.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::unprotectPluginFromDestruction):
        If the PluginView has only one reference left, deref it asynchronously.

2011-05-25  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/9496795> REGRESSION (r86851): Plug-ins disappear when scrolled with non-1 page scale
        https://bugs.webkit.org/show_bug.cgi?id=61448

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::clipRectInWindowCoordinates): Correct for page scale
        after intersecting the two rectangles.

2011-05-24  Timothy Hatcher  <timothy@apple.com>

        Make the Web Inspector bring the right window to the front when docked.

        rdar://problem/9464685
        https://webkit.org/b/61420

        Reviewed by Brian Weinstein.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::platformBringToFront): Order front the parent window of the Inspector's WKView.
        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::platformBringToFront): Ditto.

2011-05-24  Keishi Hattori  <keishi@webkit.org>

        Reviewed by Kent Tamura.

        Disable textfield implementation of <input type=color>. Add INPUT_COLOR feature flag. Add input color sanitizer.
        https://bugs.webkit.org/show_bug.cgi?id=61273

        * Configurations/FeatureDefines.xcconfig: Added INPUT_COLOR feature flag.

2011-05-24  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dan Bernstein.

        Update the WebProcess sandbox exceptions to silence warnings for a file that is accessed uselessly
        https://bugs.webkit.org/show_bug.cgi?id=61349
        <rdar://problem/9476255>

        * WebProcess/com.apple.WebProcess.sb:

2011-05-24  Mark Rowe  <mrowe@apple.com>

        Fix the 32-bit build.

        Explicitly use uint32_t when encoding / decoding a type that is a typedef of OSType,
        as this is declared as different underlying types in 32- and 64-bit (unsigned long
        vs unsigned int).
        
        * Shared/mac/KeychainAttribute.cpp:
        (CoreIPC::encode):
        (CoreIPC::decode):

2011-05-24  Sam Weinig  <sam@webkit.org>

        Reviewed by Maciej Stachowiak.

        Enable coalesced wheel events
        <rdar://problem/9444786>

        * UIProcess/WebPageProxy.cpp:
        Flip the switch for coalescing wheel events rather than dropping them.

2011-05-24  Sam Weinig  <sam@webkit.org>

        Reviewed by Maciej Stachowiak.

        Additional sandbox extension required for quarantine database
        <rdar://problem/9397494>
        https://bugs.webkit.org/show_bug.cgi?id=61405

        * WebProcess/com.apple.WebProcess.sb:
        Add read-data access for ~/Library/Preferences.

2011-05-24  Michael Saboff  <msaboff@apple.com>

        Reviewed by Geoffrey Garen.

        Improve handling in WebCore of low memory situations
        https://bugs.webkit.org/show_bug.cgi?id=61222

        Added call to enable memory pressure handling for Mac case.

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::initializeWebProcess):
        * WebProcess/WebProcess.h:
        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::WebProcess::platformInitializeWebProcess):

2011-05-24  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin Adler.

        Part of <rdar://problem/9434311> and https://bugs.webkit.org/show_bug.cgi?id=61334
        Should shim a few SecKeychainItem* methods on SnowLeopard

        Initialize the KeychainItem shim on SnowLeopard:
        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::WebProcess::initializeShim):

        On SnowLeopard, shim the 4 SecKeychainItem methods:
        * WebProcess/mac/WebProcessShim.h:
        * WebProcess/mac/WebProcessShim.mm:
        (WebKit::shimSecKeychainItemCopyContent):
        (WebKit::shimSecKeychainItemCreateFromContent):
        (WebKit::shimSecKeychainItemModifyContent):
        (WebKit::shimSecKeychainItemFreeContent):
        (WebKit::WebKitWebProcessKeychainItemShimInitialize):

        * WebProcess/mac/KeychainItemShimMethods.h: Added.
        * WebProcess/mac/KeychainItemShimMethods.mm: Added.
        Manage a set of shim-controlled AttributeList data:
        (WebKit::shimManagedAttributeLists):
        (WebKit::freeAttributeListContents):
        (WebKit::allocateAttributeListContents):

        Manage a set of shim-controlled KeychainItem data:
        (WebKit::shimManagedKeychainItemContents):
        (WebKit::allocateKeychainItemContentData):

        Free any shim-controlled AttributeList or KeychainItem data:
        (WebKit::webFreeAttributeListContentOnMainThread):
        (WebKit::webFreeAttributeListContent):
        (WebKit::webFreeKeychainItemContentOnMainThread):
        (WebKit::webFreeKeychainItemContent):

        Marshall these 3 KeychainItem methods to the UIProcess:
        (WebKit::webSecKeychainItemCopyContentOnMainThread):
        (WebKit::webSecKeychainItemCopyContent):
        (WebKit::webSecKeychainItemCreateFromContentOnMainThread):
        (WebKit::webSecKeychainItemCreateFromContent):
        (WebKit::webSecKeychainItemModifyContentOnMainThread):
        (WebKit::webSecKeychainItemModifyContent):
        (WebKit::initializeKeychainItemShim):

        Container for an AttributeList entry that knows how to encode/decode:
        * Shared/mac/KeychainAttribute.cpp: Added.
        (WebKit::KeychainAttribute::KeychainAttribute):
        (CoreIPC::encode):
        (CoreIPC::decode):
        * Shared/mac/KeychainAttribute.h: Added.

        Container for the relevant arguments to the shimmed methods, to send to the UIProcess:
        * Shared/mac/SecKeychainItemRequestData.cpp: Added.
        (WebKit::SecKeychainItemRequestData::SecKeychainItemRequestData):
        (WebKit::SecKeychainItemRequestData::initializeWithAttributeList):
        (WebKit::SecKeychainItemRequestData::~SecKeychainItemRequestData):
        (WebKit::SecKeychainItemRequestData::attributeList):
        (WebKit::SecKeychainItemRequestData::encode):
        (WebKit::SecKeychainItemRequestData::decode):
        * Shared/mac/SecKeychainItemRequestData.h: Added.
        (WebKit::SecKeychainItemRequestData::keychainItem):
        (WebKit::SecKeychainItemRequestData::itemClass):
        (WebKit::SecKeychainItemRequestData::length):
        (WebKit::SecKeychainItemRequestData::data):

        Container for the possible output from the shimmed methods, to send back to the WebProcess:
        * Shared/mac/SecKeychainItemResponseData.cpp: Added.
        (WebKit::SecKeychainItemResponseData::SecKeychainItemResponseData):
        (WebKit::SecKeychainItemResponseData::encode):
        (WebKit::SecKeychainItemResponseData::decode):
        * Shared/mac/SecKeychainItemResponseData.h: Added.
        (WebKit::SecKeychainItemResponseData::itemClass):
        (WebKit::SecKeychainItemResponseData::data):
        (WebKit::SecKeychainItemResponseData::resultCode):
        (WebKit::SecKeychainItemResponseData::attributes):
        (WebKit::SecKeychainItemResponseData::keychainItem):

        Actually implement the calls to the SecKeychainItem* methods in the UIProcess:
        * UIProcess/WebProcessProxy.h:
        * UIProcess/WebProcessProxy.messages.in:
        * UIProcess/mac/WebProcessProxyMac.mm:
        (WebKit::WebProcessProxy::secKeychainItemCopyContent):
        (WebKit::WebProcessProxy::secKeychainItemCreateFromContent):
        (WebKit::WebProcessProxy::secKeychainItemModifyContent):

        * WebKit2.xcodeproj/project.pbxproj: Project file stuff
        * Configurations/Shim.xcconfig:

2011-05-24  Jay Civelli  <jcivelli@chromium.org>

        Rubberstamped by David Kilzer.

        Updated some files that I forgot in my previous MHTML CL.

       * Configurations/FeatureDefines.xcconfig:

2011-05-24  Sam Weinig  <sam@webkit.org>

        Clean up after Geoff and fix the WebKit2 build.

        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.h:

2011-05-24  Adam Roben  <aroben@apple.com>

        Invalidate JSNPObjects when they are finalized

        This will cause the underlying NPObject to be released at finalization time, rather than at
        destruction time (which is unpredictable and could occur after the plugin has been
        unloaded).

        Test: plugins/npobject-js-wrapper-destroyed-after-plugin-unload.html

        Fixes <http://webkit.org/b/61316> <rdar://problem/9489824> Crash in deallocateNPObject when
        reloading yahoo.com webarchive in WebKit2

        Reviewed by Oliver Hunt.

        * WebProcess/Plugins/Netscape/JSNPObject.cpp:
        (WebKit::JSNPObject::~JSNPObject): Assert that we've already been invalidated, rather than
        trying to perform invalidation now (when the plugin might already be unloaded).

        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.cpp:
        (WebKit::NPRuntimeObjectMap::getOrCreateJSObject):
        (WebKit::NPRuntimeObjectMap::invalidate):
        Updated for m_jsNPObjects type change.

        (WebKit::NPRuntimeObjectMap::finalize): Added. Invalidates the JSNPObject and removes it
        from the map.

        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.h: Now inherits from WeakHandleOwner.
        Changed m_jsNPObjects from a WeakGCMap to a HashMap of JSC::Weak objects so that we will be
        notified when the JSNPObjects are finalized.

2011-05-24  Qi Zhang  <qi.2.zhang@nokia.com>

        Reviewed by Adam Roben.

        WebKitTestRunner needs layoutTestController.setJavaScriptCanAccessClipboard
        https://bugs.webkit.org/show_bug.cgi?id=42669

        Fixes a typo issue for patch 94265.

        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleSetJavaScriptCanAccessClipboard):

2011-05-24  Sam Weinig  <sam@webkit.org>

        Reviewed by John Sullivan.

        WebKit tells client that the page has become unresponsive while the beforeUnloadConfirm dialog is up
        https://bugs.webkit.org/show_bug.cgi?id=61372

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::runBeforeUnloadConfirmPanel):
        Stop the unresponsiveness timer like we do for other client functions that spin a
        runloop.

2011-05-24  Andreas Kling  <kling@webkit.org>

        Reviewed by Simon Hausmann.

        [WK2] Change TiledDrawingArea to use ShareableBitmap instead of UpdateChunk.
        https://bugs.webkit.org/show_bug.cgi?id=61296

        Pass UpdateInfo containing ShareableBitmaps instead of UpdateChunk for tile updates.
        Only the bounds rect and bitmap handle in the UpdateInfo are used since none of the
        other parameters are needed for TiledDrawingArea.

        * Shared/ShareableBitmap.h:
        * Shared/qt/ShareableBitmapQt.cpp:
        (WebKit::ShareableBitmap::createQImage):
        (WebKit::ShareableBitmap::createGraphicsContext):
        (WebKit::ShareableBitmap::paint):
        * Shared/qt/UpdateChunk.cpp: Removed.
        * Shared/qt/UpdateChunk.h: Removed.
        * UIProcess/TiledDrawingAreaProxy.cpp:
        (WebKit::TiledDrawingAreaProxy::didReceiveMessage):
        (WebKit::TiledDrawingAreaProxy::waitUntilUpdatesComplete):
        * UIProcess/TiledDrawingAreaProxy.h:
        * UIProcess/TiledDrawingAreaTile.h:
        * UIProcess/qt/TiledDrawingAreaProxyQt.cpp:
        (WebKit::TiledDrawingAreaProxy::snapshotTaken):
        * UIProcess/qt/TiledDrawingAreaTileQt.cpp:
        (WebKit::TiledDrawingAreaTile::incorporateUpdate):
        * WebKit2.pro:
        * WebProcess/WebPage/TiledDrawingArea.cpp:
        (WebKit::TiledDrawingArea::updateTile):
        (WebKit::TiledDrawingArea::didReceiveMessage):
        * WebProcess/WebPage/TiledDrawingArea.h:
        * WebProcess/WebPage/qt/TiledDrawingAreaQt.cpp:
        (WebKit::TiledDrawingArea::paintIntoBitmap):

2011-05-24  Brady Eidson  <beidson@apple.com>

        Build fix after r87153

        * WebProcess/mac/SecItemShimMethods.mm: Don't compile this code on SnowLeopard.

2011-05-23  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig.

        Part of <rdar://problem/9434311> and https://bugs.webkit.org/show_bug.cgi?id=61334
        Should shim a few SecKeychainItem* methods on SnowLeopard

        In preparation for different WebProcess shims depending on platform, move the current
        shim to its own files.
        
        * WebKit2.xcodeproj/project.pbxproj:
        
        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::WebProcess::initializeShim): For non-SnowLeopard platforms, call initializeSecItemShim().
        
        * WebProcess/mac/SecItemShimMethods.h: Added.
        * WebProcess/mac/SecItemShimMethods.mm: Added. Actual webSecItem* methods moved from WebProcessMac.mm.
        (WebKit::webSecItemCopyMatchingMainThread):
        (WebKit::webSecItemCopyMatching):
        (WebKit::webSecItemAddOnMainThread):
        (WebKit::webSecItemAdd):
        (WebKit::webSecItemUpdateOnMainThread):
        (WebKit::webSecItemUpdate):
        (WebKit::webSecItemDeleteOnMainThread):
        (WebKit::webSecItemDelete):
        (WebKit::initializeSecItemShim): Initialize the callbacks via WebKitWebProcessSecItemShimInitialize

        * WebProcess/mac/WebProcessShim.h:
        * WebProcess/mac/WebProcessShim.mm: Wrap all the actual code here in a !BUILDING_ON_SNOW_LEOPARD block
        (WebKit::shimSecItemCopyMatching):
        (WebKit::shimSecItemAdd):
        (WebKit::shimSecItemUpdate):
        (WebKit::shimSecItemDelete):
        (WebKit::WebKitWebProcessSecItemShimInitialize):

2011-05-23  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Cap painting to 30fps on Windows
        https://bugs.webkit.org/show_bug.cgi?id=61337
        <rdar://problem/9213388>

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::displayTimerFired):

2011-05-23  Jeremy Noble  <jer.noble@apple.com>

        Reviewed by Darin Adler.

        REGRESSION (r86990:86992): World leak when all windows closed
        https://bugs.webkit.org/show_bug.cgi?id=61311

        Three interlocking problems:
        
        1) Calling [WKView fullScreenController] will create the controller if it doesn't all ready
        exist, so move the closing code into WKView, where we can bail early if there isn't a 
        controller.
        
        2) A retain-cycle exists between WKView and WKFullScreenWindowController.  Make sure to break
        the cycle explicitly by clearing the _fullScreenWindowController ivar when closing the
        controller.
        
        3) [NSWindowController close] was overridden without calling [super close].  Do that.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView closeFullScreenWindowController]): Moved here from WebFullScreenManagerProxyMac.mm.
        * UIProcess/API/mac/WKViewInternal.h:
        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController close]): Call [super close].
        * UIProcess/mac/WebFullScreenManagerProxyMac.mm:
        (WebKit::WebFullScreenManagerProxy::invalidate):

2011-05-20  Jer Noble  <jer.noble@apple.com>

        Reviewed by Darin Adler.

        Video looks squished when animating to full screen.
        https://bugs.webkit.org/show_bug.cgi?id=61220

        Instead of scaling between the client sizes of the full-screen element before and after 
        entering full-screen, scale between their content boxes.  The difference is that the client
        sizes can have different aspect ratios, and thus the animation can end up "squishing" the
        content at one end of the animation.  When animating between the two content box sizes, their
        aspect ratios (for the case of video) are equal, so the animation will appear to scale 
        smoothly between the two states without "squishing" the content.

        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::beginEnterFullScreenAnimation): Set the destination frame
            to be the content box of the current full screen element.
        (WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation): Ditto.

2011-05-23  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        Terminating a WebProcess should work even while a page is being closed
        <rdar://problem/8934632>
        https://bugs.webkit.org/show_bug.cgi?id=61299

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::terminateProcess):
        Change validity check to only check for process validity, since terminating the process of a page that
        is closed or is closing is acceptable behavior.

2011-05-23  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Darin Adler.

        [Windows] Initial Cookie Accept Policy not set on Deserialized Storage Session.
        https://bugs.webkit.org/show_bug.cgi?id=61255

        * WebProcess/win/WebProcessWin.cpp:
        (WebKit::WebProcess::platformInitializeWebProcess):
        Move the code to set the cookie policy before the early return that is taken when using the
        default storage session from the UI Process.
        Also, remove unnecessary #ifdefs (USE(CFURLSTORAGESESSIONS) is true if USE(CFNETWORK) is
        true) and add a comment explaining the early return.

2011-05-23  Qi Zhang  <qi.2.zhang@nokia.com>

        Reviewed by Darin Adler.

        WebKitTestRunner needs layoutTestController.setJavaScriptCanAccessClipboard
        https://bugs.webkit.org/show_bug.cgi?id=42669

        Implement setJavaScriptCanAccessClipboard in WebKitTestRunner.

        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleSetJavaScriptCanAccessClipboard):
        * WebProcess/InjectedBundle/API/c/WKBundlePrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::setJavaScriptCanAccessClipboard):
        * WebProcess/InjectedBundle/InjectedBundle.h:

2011-05-23  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt][WK2] Unreviewed trivial fix after r86990.

        * WebKit2.pro: Remove UIProcess/ChunkedUpdateDrawingAreaProxy.h.

2011-05-23  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix WebKit2 GTK build after r86990.

        * GNUmakefile.am: Remove UpdateChunk.cpp and UpdateChunk.h.

2011-05-21  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=61244
        <rdar://problem/9482856>
        Undo operations for a web page linger after page is destroyed

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::closePage):
        Clear editing commands before telling UI client to close the page (this must be done
        while the page is still in a window so its undo manager can be accessed, so waiting
        for WebPageProxy::close() is too late).

2011-05-22  Jeff Miller  <jeffm@apple.com>

        Reviewed by Darin Adler.

        Don't call WebKit::initializeLogChannelsIfNecessary if logging is disabled
        https://bugs.webkit.org/show_bug.cgi?id=61249

        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::WebContext): Check #if !LOG_DISABLED, not #ifndef NDEBUG, to decide whether to call WebKit::initializeLogChannelsIfNecessary().

2011-05-21  Nancy Piedra  <nancy.piedra@nokia.com>

        Reviewed by Andreas Kling.

        [Qt][Symbian] WKStringCopyQString function is not exported
        https://bugs.webkit.org/show_bug.cgi?id=59285

        A few functions were declared twice but without the export macro.
        On Symbian, the linking failed when trying to reference these functions.

        * UIProcess/API/qt/qgraphicswkview.h:

2011-05-21  Jeremy Noble  <jer.noble@apple.com>

        Reviewed by Eric Carlson.

        WebKit2: fix failing fullscreen/full-screen-remove* tests.
        https://bugs.webkit.org/show_bug.cgi?id=61027

        * WebProcess/InjectedBundle/InjectedBundlePageFullScreenClient.cpp:
        (WebKit::InjectedBundlePageFullScreenClient::exitFullScreenForElement): Call the 
            exit functions (was calling the enter functions).

2011-05-20  Jeremy Noble  <jer.noble@apple.com>

        Reviewed by Mark Rowe.

        Crash in WebFullScreenManager::didExitFullScreen when closing a window in Safari.
        https://bugs.webkit.org/show_bug.cgi?id=61228

        Do not attempt to exit full screen if we aren't in full screen to begin with, as the WebProcess
        won't be expecting will/didExitFullScreen notifications.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController close]):

2011-05-20  Andy Estes  <aestes@apple.com>

        Reviewed by Darin Adler.

        WebView loses firstResponder status when entering full-screen mode.
        https://bugs.webkit.org/show_bug.cgi?id=61153

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]): If
        the WebView was a descendant of the browser window's first responder
        when entering full-screen mode, set the full-screen window's first
        responder to that same NSResponder.
        (-[WKFullScreenWindowController beganExitFullScreenAnimation]): Do the
        reverse of what is done in finishedEnterFullScreenAnimation:.

2011-05-20  Jeremy Noble  <jer.noble@apple.com>

        Reviewed by Maciej Stachowiak.

        WebKit2: Exit full screen mode if the WebProcess crashes.
        https://bugs.webkit.org/show_bug.cgi?id=61151

        If the WebProcess crashes, exit full-screen mode to avoid getting stuck.  Move the
        WebFullScreenManagerProxy::invalidate() implementation into the platform-specific
        files, and have them close their respective platform's full-screen window.

        * UIProcess/WebFullScreenManagerProxy.cpp:
        * UIProcess/gtk/WebFullScreenManagerProxyGtk.cpp:
        (WebKit::WebFullScreenManagerProxy::invalidate): Added. Copied from main implementation.
        * UIProcess/mac/WKFullScreenWindowController.h:
        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController close]): Added.
        * UIProcess/mac/WebFullScreenManagerProxyMac.mm:
        (WebKit::WebFullScreenManagerProxy::invalidate): Added. 
        * UIProcess/win/WebFullScreenManagerProxyWin.cpp:
        (WebKit::WebFullScreenManagerProxy::invalidate): Added.

2011-05-20  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Remove the chunked update drawing area
        https://bugs.webkit.org/show_bug.cgi?id=61216

        The chunked update drawing area is no longer used in any port, so remove all traces of it.

        Qt still uses UpdateChunks for the tiled drawing area so keep the Shared/qt/UpdateChunk.* classes for now.

        * GNUmakefile.am:
        * Shared/DrawingAreaInfo.h:
        * Shared/gtk/UpdateChunk.cpp: Removed.
        * Shared/gtk/UpdateChunk.h: Removed.
        * Shared/mac/UpdateChunk.cpp: Removed.
        * Shared/mac/UpdateChunk.h: Removed.
        * Shared/win/UpdateChunk.cpp: Removed.
        * Shared/win/UpdateChunk.h: Removed.
        * UIProcess/ChunkedUpdateDrawingAreaProxy.cpp: Removed.
        * UIProcess/ChunkedUpdateDrawingAreaProxy.h: Removed.
        * UIProcess/gtk/ChunkedUpdateDrawingAreaProxyGtk.cpp: Removed.
        * UIProcess/mac/ChunkedUpdateDrawingAreaProxyMac.mm: Removed.
        * UIProcess/qt/ChunkedUpdateDrawingAreaProxyQt.cpp: Removed.
        * UIProcess/win/ChunkedUpdateDrawingAreaProxyWin.cpp: Removed.
        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::paint):
        (WebKit::WebView::createDrawingAreaProxy):
        (WebKit::WebView::enterAcceleratedCompositingMode):
        (WebKit::WebView::exitAcceleratedCompositingMode):
        * WebKit2.pro:
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/WebPage/ChunkedUpdateDrawingArea.cpp: Removed.
        * WebProcess/WebPage/ChunkedUpdateDrawingArea.h: Removed.
        * WebProcess/WebPage/DrawingArea.cpp:
        (WebKit::DrawingArea::create):
        * WebProcess/WebPage/mac/ChunkedUpdateDrawingAreaMac.cpp: Removed.
        * WebProcess/WebPage/qt/ChunkedUpdateDrawingAreaQt.cpp: Removed.
        * WebProcess/WebPage/win/ChunkedUpdateDrawingAreaWin.cpp: Removed.
        * win/WebKit2.vcproj:

2011-05-20  Matthew Delaney  <mdelaney@apple.com>

        Reviewed by Steve Falkenburg.

        Default min DOM Timer interval is not set soon enough for first page to pick it up in WK2
        https://bugs.webkit.org/show_bug.cgi?id=61215 

        * WebProcess/WebPage/WebPage.cpp: Simply moving the DOM min timer interval setting to before the first page creation.

2011-05-20  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Sam Weinig.

        numberOfActiveAnimations() can include animations from documents in the page cache
        https://bugs.webkit.org/show_bug.cgi?id=53641

        Pass the Frame's document as the one to count animations on.

        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::numberOfActiveAnimations):

2011-05-20  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Sam Weinig.

        WebKitTestRunner needs layoutTestController.pauseTransitionAtTimeOnElementWithId
        https://bugs.webkit.org/show_bug.cgi?id=42550
        
        Plumb through methods to pause a transition of a given property on an element.

        * WebProcess/InjectedBundle/API/c/WKBundleFrame.cpp:
        (WKBundleFramePauseAnimationOnElementWithId):
        (WKBundleFramePauseTransitionOnElementWithId):
        * WebProcess/InjectedBundle/API/c/WKBundleFramePrivate.h:
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::pauseTransitionOnElementWithId):
        * WebProcess/WebPage/WebFrame.h:

2011-05-20  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        WebKit2: Media files cannot be saved in the Application Cache due to a sandbox violation
        https://bugs.webkit.org/show_bug.cgi?id=61199

        Instead of using a sandbox extension to give permission to the application cache directory,
        initialize the sandbox with access to it like we do for other databases.

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode):
        (WebKit::WebProcessCreationParameters::decode):
        * Shared/WebProcessCreationParameters.h:
        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::ensureWebProcess):
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::initializeWebProcess):
        * WebProcess/com.apple.WebProcess.sb:
        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::initializeSandbox):

2011-05-20  Jer Noble  <jer.noble@apple.com>

        Reviewed by Maciej Stachowiak.

        Win: non-full-screen content is briefly seen when entering full-screen mode (and vice versa)
        https://bugs.webkit.org/show_bug.cgi?id=61108

        When the fullScreenController asks us to repaint, make an async repaint request, and when the
        callback is fired, notify the fullScreenController that repaint has completed.

        * UIProcess/win/WebView.cpp:
        (WebKit::fullScreenClientForceRepaintCompleted): Added.
        (WebKit::WebView::fullScreenClientForceRepaint): Added.
        * UIProcess/win/WebView.h:

2011-05-19  Adam Roben  <aroben@apple.com>

        Don't try to process DownloadProxy messages twice (and robustify code that runs if we do)

        Fixes <http://webkit.org/b/61142> <rdar://problem/9471680> REGRESSION (r86812): Crash
        (preceded by assertion) in fastMalloc when downloading a file

        Reviewed by Darin Adler.

        * Platform/CoreIPC/ArgumentDecoder.cpp:
        (CoreIPC::alignedBufferIsLargeEnoughToContain): Added. This helper function checks that the
        given buffer is large enough to hold |size| bytes (and correctly handles the case where
        we're already at the end or beyond the end of the buffer).

        (CoreIPC::ArgumentDecoder::alignBufferPosition):
        (CoreIPC::ArgumentDecoder::bufferIsLargeEnoughToContain):
        Replaced old code that was vulnerable to underflow with the new helper function.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::didReceiveSyncMessage): Added back an early return that was
        mistakenly removed in r86812 so that we don't mistakenly pass DownloadProxy messages on to
        a WebPageProxy after we've already handled them.

2011-05-19  Jer Noble  <jer.noble@apple.com>

        Reviewed by Maciej Stachowiak.

        WebKit2: Flashing when entering and exiting full screen mode
        https://bugs.webkit.org/show_bug.cgi?id=56957

        In the WKFullscreenWindowController, when exiting accelerated compositing mode, 
        force a repaint, and don't actually remove the animation layer until the repaint
        completes.  Also, move back to parenting the WebView in a layer-backed view, and
        work around the SnowLeopard bug which causes a crash in those situations.  We no
        longer need to do a bunch of work in finishedEnterFullScreenAnimation, because 
        the animation layer is "hiding" all the drawing happening in the webView underneath.

        In the WebFullScreenManagerMac, when asked to tear down the root layer, instead
        remove all its children, and set its contents to a flattened image of the full
        screen element and its children.  This helps patch over the time where everything 
        is re-rendering and helps give the appearance of continuousness in the animation.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]):
        (-[WKFullScreenWindowController beganExitFullScreenAnimation]):
        (-[WKFullScreenWindowController enterAcceleratedCompositingMode:WebKit::]):
        (-[WKFullScreenWindowController exitAcceleratedCompositingMode]):
        (-[WKFullScreenWindowController exitCompositedModeRepaintCompleted]):
        (exitCompositedModeRepaintCompleted):
        (-[WKFullScreenWindowController _page]):
        (-[WKFullScreenWindowController _manager]):
        (-[WKFullScreenWindow initWithContentRect:styleMask:backing:defer:]):
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::setRootFullScreenLayer):

2011-05-19  Anders Carlsson  <andersca@apple.com>

        Address a review comment by Sam Weinig.

        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::didUpdateHistoryTitle):

2011-05-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Hang UI appears when WebProcess isn't running
        https://bugs.webkit.org/show_bug.cgi?id=61147
        <rdar://problem/9413683>

        This fixes two bugs:

        1. The HistoryClient related message handlers in WebContext could get invoked for pages that have been closed,
           and thus didn't have any subframes. Since we have a MESSAGE_CHECK that checks that the frame exists, we'd
           mark the currently dispatched message as invalid, which would end up calling Connection::Client::didReceiveInvalidMessage.
           Fix this by checking that the page exists first.

        2. In the call to WebProcessProxy::didReceiveInvalidMessage we'd first invalidate the CoreIPC connection to make sure 
           that we won't get any further messages from this connection. We'd then go ahead and terminate the web process, 
           but because we've already invalidated the CoreIPC connection we would never get the Connection::Client::didClose
           callback that would call WebPageProxy::processDidCrash. Fix this by explicitly calling WebProcessProxy::didClose.
           Also, add logging when we receive an invalid message

        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::didNavigateWithNavigationData):
        (WebKit::WebContext::didPerformClientRedirect):
        (WebKit::WebContext::didPerformServerRedirect):
        (WebKit::WebContext::didUpdateHistoryTitle):
        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::didReceiveInvalidMessage):

2011-05-19  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        Crash when detaching Web Inspector when parent is in process of closing.
        https://bugs.webkit.org/show_bug.cgi?id=61141
        <rdar://problem/9470027>
        
        We were trying to send a WM_SIZE to a window that was in the process of closing. Switch
        to using PostMessage, so the window will finish closing, and then it won't need to
        process the WM_SIZE message anymore.

        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::platformAttach): Call PostMessage instead of SendMessage.
        (WebKit::WebInspectorProxy::platformDetach): Ditto.

2011-05-19  Robert Hogan  <robert@webkit.org>

        Reviewed by Andreas Kling.

        [Qt] Fix plugins/windowless_plugin_paint_test.html

        Call gdk_init_check before gdk_display_get_default().
        If we don't do this, gdk_display_get_default() will hang
        the next time it's called.

        * WebProcess/Plugins/Netscape/x11/NetscapePluginX11.cpp:
        (WebKit::getPluginDisplay):

2011-05-18  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Anders Carlsson.

        Plug-ins at YouTube, cnn.com, nytimes vanish when their top/left is scrolled out of view when zoomed
        https://bugs.webkit.org/show_bug.cgi?id=61101

        Scale both bounding boxes sent to m_plugin->geometryDidChange(), not just the frameRect. This fools
        the plugin into thinking it is drawing into an unscaled box with an unscaled view even when scaled.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::frame):Made this const so it can be used in clipRectInWindowCoordinates()
        (WebKit::PluginView::viewGeometryDidChange):Used IntRect::scale() rather than scaling by hand
        (WebKit::PluginView::clipRectInWindowCoordinates):Added scale of clipRect.
        * WebProcess/Plugins/PluginView.h:

2011-05-19  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Anders Carlsson.

        Fix build with ENABLE_PLUGIN_PROCESS=1 for non-mac platforms after r86578
        https://bugs.webkit.org/show_bug.cgi?id=61113

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::tryToShortCircuitInvoke):
        (WebKit::PluginControllerProxy::tryToShortCircuitEvaluate):

2011-05-19  Philippe Normand  <pnormand@igalia.com>

        Unreviewed, follow-up fix of the messages python unittests after r86812.

        [WebKit2] handleMessageDelayed leaks replyEncoder if decoding fails
        https://bugs.webkit.org/show_bug.cgi?id=60872

        * Scripts/webkit2/messages_unittest.py:

2011-05-18  Brady Eidson  <beidson@apple.com>

        As originally reviewed by Anders Carlsson.

        <rdar://problem/9457633> and https://bugs.webkit.org/show_bug.cgi?id=61009
        Processes spawned by SnowLeopard's WebProcess attempt to install WebKit2 shims.

        Restore r86797 to how it was supposed to be using the appropriate #ifdef,
        reverting the temporary r86814 in the process.

        The #ifdef is BUILDING_ON_SNOW_LEOPARD, not BUILDING_ON_SNOWLEOPARD!
        
        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::ProcessLauncher::launchProcess):
        * WebProcess/mac/WebProcessMainMac.mm:
        (WebKit::WebProcessMain):

2011-05-18  Brady Eidson  <beidson@apple.com>

        Fix the WK2 SnowLeopard layouttests (again) until I can explore on a SnowLeopard machine tomorrow.

        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::ProcessLauncher::launchProcess):
        * WebProcess/mac/WebProcessMainMac.mm:
        (WebKit::WebProcessMain):

2011-05-18  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        [WebKit2] handleMessageDelayed leaks replyEncoder if decoding fails
        https://bugs.webkit.org/show_bug.cgi?id=60872

        Eliminate the concept of SyncReplyMode and instead hand around ownership
        of the reply decoder using an OwnPtr.

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::dispatchSyncMessage): Eliminated comments that say
        the same things the code itself does. Removed code that handles the
        reply mode. Instead, pass the OwnPtr to the message handling function and
        make the call to sendSyncReply conditional on whether the reply encoder
        is still non-null.

        * Platform/CoreIPC/Connection.h: Removed SyncReplyMode. Made
        didReceiveSyncMessage return void, and take OwnPtr<ArgumentEncoder>& for
        the reply encoder.

        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC::handleMessageDelayed): Take an OwnPtr&. Replaced the call to
        adoptPtr with a call to release.

        * PluginProcess/PluginControllerProxy.h: Updated to take an OwnPtr& and
        not return SyncReplyMode.
        * PluginProcess/WebProcessConnection.cpp:
        (WebKit::WebProcessConnection::didReceiveSyncMessage): Ditto.
        * PluginProcess/WebProcessConnection.h: Ditto.

        * Scripts/webkit2/messages.py: Updated for changes to sync messages.
        Eliminated unneeded return types and use get() when apporopriate to call
        the handleMessage functions.

        * Scripts/webkit2/messages_unittest.py: Tried to update this too.
        I don't know how to run the test, though.

        * Shared/Plugins/NPObjectMessageReceiver.h: Updated to take an OwnPtr& and
        not return SyncReplyMode.
        * Shared/Plugins/NPRemoteObjectMap.cpp:
        (WebKit::NPRemoteObjectMap::didReceiveSyncMessage): Ditto.
        * Shared/Plugins/NPRemoteObjectMap.h: Ditto.
        * UIProcess/Downloads/DownloadProxy.h: Ditto.
        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::didReceiveSyncMessage): Ditto.
        * UIProcess/WebContext.h: Ditto.
        * UIProcess/WebFullScreenManagerProxy.cpp:
        (WebKit::WebFullScreenManagerProxy::didReceiveSyncMessage): Ditto.
        * UIProcess/WebFullScreenManagerProxy.h: Ditto.
        * UIProcess/WebIconDatabase.cpp:
        (WebKit::WebIconDatabase::didReceiveSyncMessage): Ditto.
        * UIProcess/WebIconDatabase.h: Ditto.
        * UIProcess/WebInspectorProxy.h: Ditto.
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didReceiveSyncMessage): Ditto.
        * UIProcess/WebPageProxy.h: Ditto.
        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::didReceiveSyncMessage): Ditto.
        * UIProcess/WebProcessProxy.h: Ditto.

        * WebProcess/Plugins/Netscape/JSNPObject.cpp: Added a missing include.

        * WebProcess/Plugins/PluginProcessConnection.cpp:
        (WebKit::PluginProcessConnection::didReceiveSyncMessage): Updated to take
        an OwnPtr& and not return SyncReplyMode.
        * WebProcess/Plugins/PluginProcessConnection.h: Ditto.
        * WebProcess/Plugins/PluginProxy.h: Ditto.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::didReceiveSyncMessage): Ditto.
        * WebProcess/WebPage/WebPage.h: Ditto.
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::didReceiveSyncMessage): Ditto.
        * WebProcess/WebProcess.h: Ditto.

2011-05-18  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Maciej Stachowiak.

        WK2: VoiceOver cannot move focus into a web area programmatically
        https://bugs.webkit.org/show_bug.cgi?id=60661

        Add a makeFirstResponder method that will bring focus to the widget view within the UI
        process.

        * UIProcess/API/mac/PageClientImpl.h:
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::makeFirstResponder):
        * UIProcess/PageClient.h:
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::makeFirstResponder):
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::makeFirstResponder):
        * WebProcess/WebCoreSupport/WebChromeClient.h:

2011-05-18  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/9457633> and https://bugs.webkit.org/show_bug.cgi?id=61009
        Processes spawned by SnowLeopard's WebProcess attempt to install WebKit2 shims.

        * Platform/unix/EnvironmentUtilities.cpp: Remove an unnecessary #include, as reviewed.

2011-05-17  Timothy Hatcher  <timothy@apple.com>

        Update the the context menu to reflect the system search provider on Mac.

        <rdar://problem/9198419>

        Reviewed by Sam Weinig.

        * WebProcess/WebCoreSupport/WebContextMenuClient.cpp:
        (WebKit::WebContextMenuClient::searchWithGoogle): Add a FIXME about using NSPerformService on Mac.
        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface): Added CopyDefaultSearchProviderDisplayName.

2011-05-18  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/9457633> and https://bugs.webkit.org/show_bug.cgi?id=61009
        Processes spawned by SnowLeopard's WebProcess attempt to install WebKit2 shims.

        If the WebProcess or PluginProcess forks, it shouldn't pass WebKit2 shims along to the new process
        in the DYLD_INSERT_LIBRARIES environment variable.

        Add Environment Utilities helper to strip unwanted values from an environment variable:
        * Platform/unix/EnvironmentUtilities.cpp: Added.
        (WebKit::EnvironmentUtilities::stripValuesEndingWithString):
        * Platform/unix/EnvironmentUtilities.h: Added.
        * WebKit2.xcodeproj/project.pbxproj:

        Strip PluginProcessShim.dylib from DYLD_INSERT_LIBRARIES:
        * PluginProcess/mac/PluginProcessMainMac.mm:
        (WebKit::PluginProcessMain):

        Strip WebProcessShim.dylib from DYLD_INSERT_LIBRARIES:
        * WebProcess/mac/WebProcessMainMac.mm:
        (WebKit::WebProcessMain):

        Unprotect SnowLeopard now that it will behave and not spawn processes trying to use WebKit2 shims:
        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::ProcessLauncher::launchProcess):

2011-05-18  Jon Lee  <jonlee@apple.com>

        Reviewed by Simon Fraser.

        Crash in injected bundle client
        https://bugs.webkit.org/show_bug.cgi?id=61086

        * WebProcess/InjectedBundle/InjectedBundlePageUIClient.cpp:
        (WebKit::InjectedBundlePageUIClient::shouldRubberBandInDirection): Check for existence of method in client prior to calling.

2011-05-18  Andreas Kling  <kling@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt][WK2] Remove usage of ChunkedUpdateDrawingArea.
        https://bugs.webkit.org/show_bug.cgi?id=60901

        To prepare for the eventual removal of the ChunkedUpdateDrawingArea,
        make QGraphicsWKView's "Simple" backing store type map to DrawingAreaImpl.

        * UIProcess/API/qt/qgraphicswkview.cpp:
        * UIProcess/API/qt/qgraphicswkview.h:
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPagePrivate::createDrawingAreaProxy):

2011-05-18  Andreas Kling  <kling@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt][WK2] Don't lie about supporting accelerated compositing.
        https://bugs.webkit.org/show_bug.cgi?id=61054

        Until we have an implementation of LayerTreeHost, we shouldn't lie about it.

        * WebKit2.pro:
        * WebProcess/WebPage/LayerTreeHost.h:
        * WebProcess/WebPage/qt/LayerTreeHostQt.cpp: Added.
        (WebKit::LayerTreeHost::supportsAcceleratedCompositing):

2011-05-17  Jeremy Noble  <jer.noble@apple.com>

        Reviewed by Darin Adler.

        Exiting full screen will leave up invisible full-screen window, blocking all mouse clicks.
        https://bugs.webkit.org/show_bug.cgi?id=60982

        The GraphicsLayer tree has unparented m_fullScreenRootLayer behind our backs, replacing the 
        tiled layer with a normal one.  Instead of holding on to a specific layer, assume that the 
        w_rootLayer will only have 0 or 1 children, and if a child is present, then that is our full-
        screen layer.

        Additionally, check to see if the animating layer's presentationLayer is nil
        before calling it; asking a nil object for a CATransform3D will give back a struct full of 
        garbage.

        In WKFullScreenWindowController, when the exit animation completes, ignore the "completed"
        parameter.  This eliminates the possibility that the full screen window will end up left
        on top of the screen if the animation is cancelled and a enter full screen animation isn't
        forthcoming.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController finishedExitFullScreenAnimation:]):
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.h:
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::setRootFullScreenLayer):
        (WebKit::WebFullScreenManagerMac::beginEnterFullScreenAnimation):
        (WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation):

2011-05-17  Dan Bernstein  <mitz@apple.com>

        Reviewed by Alice Liu.

        <rdar://problem/9458300> REGRESSION (r86724): Repro crash loading any webpage in WebKit2 on SnowLeopard
        https://bugs.webkit.org/show_bug.cgi?id=61022

        * WebProcess/mac/WebProcessMainMac.mm:
        (WebKit::WebProcessMain): As long as we are not loading the shim on Snow Leopard, we should not
        try to initialize it.

2011-05-17  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=60595
        Fix the rampant WebProcess crashing because we're trying to install the WebProcess shim
        into QTKitServer when we launch it.

        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::ProcessLauncher::launchProcess): This is only happening on SnowLeopard, so put
          SnowLeopard build guards around the shim install path.

2011-05-17  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r86668.
        http://trac.webkit.org/changeset/86668
        https://bugs.webkit.org/show_bug.cgi?id=61001

        It made 52 tests crash on Qt WK2 bot (Requested by Ossy on
        #webkit).

        * UIProcess/API/qt/qgraphicswkview.cpp:
        * UIProcess/API/qt/qgraphicswkview.h:
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPagePrivate::createDrawingAreaProxy):

2011-05-17  Brian Weinstein  <bweinstein@apple.com>

        Build fix after r86717.

        * UIProcess/API/C/win/WKView.h: Add a forward declaration of IDropTarget

2011-05-17  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        WebKit2: Needs API to set a custom drop target
        https://bugs.webkit.org/show_bug.cgi?id=60991
        <rdar://problem/9090868>
        
        Add API to set a custom drop target on a WKView.

        * UIProcess/API/C/win/WKView.cpp:
        (WKViewSetCustomDropTarget): Call through to WebView::setCustomDropTarget.
        * UIProcess/API/C/win/WKView.h:
        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::setCustomDropTarget): Revoke the current drop target, and register the
            custom one.
        * UIProcess/win/WebView.h:

2011-05-17  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Add API to determine if a frame has any form elements without going to javascript
        https://bugs.webkit.org/show_bug.cgi?id=60999

        * WebProcess/InjectedBundle/API/c/WKBundleFrame.cpp:
        (WKBundleFrameContainsAnyFormElements):
        * WebProcess/InjectedBundle/API/c/WKBundleFramePrivate.h:
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::containsAnyFormElements):
        * WebProcess/WebPage/WebFrame.h:
        Add WKBundleFrameContainsAnyFormElements which does a walk of the document to determine
        if there are any form elements.

2011-05-17  Andreas Kling  <kling@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt][WK2] Initial support for favicons.
        https://bugs.webkit.org/show_bug.cgi?id=58937

        Add the following API to QWKContext:

        - void setIconDatabasePath(QString)
        - void iconChangedForPageURL(QUrl) [signal]
        - QIcon iconForPageURL(QUrl)

        This is mostly analogous to the QWebSettings/QWebFrame icon API we had in WebKit1.

        * UIProcess/API/qt/ClientImpl.h: Added WKIconDatabaseClient methods.

        * UIProcess/API/qt/ClientImpl.cpp:
        (toQWKContext): Helper to cast from "void* clientInfo" to a QWKContext*.
        (qt_wk_didChangeIconForPageURL): Emits QWKContext::iconChangedForPageURL(QUrl).
        (qt_wk_didRemoveAllIcons): Stub.

        * UIProcess/API/qt/qwkcontext.h:
        * UIProcess/API/qt/qwkcontext_p.h:
        * UIProcess/API/qt/qwkcontext.cpp:
        (QWKContextPrivate::QWKContextPrivate): Set up and register a WKIconDatabaseClient.
        (QWKContext::QWKContext): Minor refactor to avoid code duplication in constructors.
        (QWKContext::setIconDatabasePath): Exactly what it sounds like.
        (QWKContext::iconForPageURL): Retrieves the favicon for a given page URL as a QIcon.

        * WebKit2API.pri: Add WKIconDatabase.cpp and WKIconDatabase.h to build.

2011-05-17  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        Part 4 of <rdar://problem/8814289> and https://bugs.webkit.org/show_bug.cgi?id=60595
        Mac WebKit2 WebProcess needs a shim to make prompts appear to be from the UIProcess

        This patch actually hooks up the shim to the WebProcess shim callbacks, which messages these
        4 calls up to the UIProcess and returns the result.

        Note that this patch uncovered the fact that CoreIPC can't sync message out from a secondary thread,
        so I filed https://bugs.webkit.org/show_bug.cgi?id=60975 as a followup to allow that.

        * Shared/mac/SecItemResponseData.cpp:
        (WebKit::SecItemResponseData::SecItemResponseData): Reorder the constructor arguments to be 
          a little cleaner.
        * Shared/mac/SecItemResponseData.h:

        Call the shim callbacks for each method:
        * WebProcess/mac/WebProcessShim.mm:
        (WebKit::shimSecItemCopyMatching):
        (WebKit::shimSecItemAdd):
        (WebKit::shimSecItemUpdate):
        (WebKit::shimSecItemDelete):

        Implement the shim callbacks, which each marshall to the main thread, which then calls out to CoreIPC:
        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::WebSecItemCopyMatchingMainThread):
        (WebKit::WebSecItemCopyMatching):
        (WebKit::WebSecItemAddOnMainThread):
        (WebKit::WebSecItemAdd):
        (WebKit::WebSecItemUpdateOnMainThread):
        (WebKit::WebSecItemUpdate):
        (WebKit::WebSecItemDeleteOnMainThread):
        (WebKit::WebSecItemDelete):

        Add the 4 messages and their implementations in the UIProcess:
        * UIProcess/WebProcessProxy.h:
        * UIProcess/WebProcessProxy.messages.in:
        * UIProcess/mac/WebProcessProxyMac.mm: Added.
        (WebKit::WebProcessProxy::secItemCopyMatching):
        (WebKit::WebProcessProxy::secItemAdd):
        (WebKit::WebProcessProxy::secItemUpdate):
        (WebKit::WebProcessProxy::secItemDelete):

        * WebKit2.xcodeproj/project.pbxproj:

2011-05-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Incomplete page painting at dropbox.com
        https://bugs.webkit.org/show_bug.cgi?id=60974
        <rdar://problem/9448213>

        When we're exiting compositing mode and haven't sent an EnterAcceleratedCompositingMode
        message to the UI process, we still need to send the updated bits to the ui process.
        
        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::exitAcceleratedCompositingMode):

2011-05-17  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        Part 3 of <rdar://problem/8814289> and https://bugs.webkit.org/show_bug.cgi?id=60595
        Mac WebKit2 WebProcess needs a shim to make prompts appear to be from the UIProcess

        Add CoreIPC stuff we'll need to marshall the SecItem calls to the UIProcess and back.

        Teach ArgumentCodersCF about CFDateRef, SecKeychainItemRef, and generic CFTypeRefs:
        * Shared/cf/ArgumentCodersCF.cpp:
        (CoreIPC::typeFromCFTypeRef):
        (CoreIPC::encode):
        (CoreIPC::decode):
        * Shared/cf/ArgumentCodersCF.h:

        Serializable object that contains the query CFDictionaryRef and optionally the 
        "attributesToMatch" CFDictionaryRef:
        * Shared/mac/SecItemRequestData.cpp: Added.
        (WebKit::SecItemRequestData::SecItemRequestData):
        (WebKit::SecItemRequestData::encode):
        (WebKit::SecItemRequestData::decode):
        * Shared/mac/SecItemRequestData.h: Added.
        (WebKit::SecItemRequestData::query):
        (WebKit::SecItemRequestData::attributesToMatch):

        Serializable object that returns an OSStatus and optionally a "result object" CFTypeRef:
        * Shared/mac/SecItemResponseData.cpp: Added.
        (WebKit::SecItemResponseData::SecItemResponseData):
        (WebKit::SecItemResponseData::encode):
        (WebKit::SecItemResponseData::decode):
        * Shared/mac/SecItemResponseData.h: Added.
        (WebKit::SecItemResponseData::resultObject):
        (WebKit::SecItemResponseData::resultCode):

        * WebKit2.xcodeproj/project.pbxproj:

2011-05-17  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        Part 2 of <rdar://problem/8814289> and https://bugs.webkit.org/show_bug.cgi?id=60595
        Mac WebKit2 WebProcess needs a shim to make prompts appear to be from the UIProcess

        Hookup some of the methods we plan to shim in the patch, but just have them call through
        to the actual implementations for now.

        Also stub-out the future shimmed versions of the methods.

        * WebProcess/mac/WebProcessShim.h: Add the methods to the shim callbacks.
        * WebProcess/mac/WebProcessShim.mm:
        (WebKit::shimSecItemCopyMatching): Call through to the actual function for now.
        (WebKit::shimSecItemAdd): Ditto.
        (WebKit::shimSecItemUpdate): Ditto.
        (WebKit::shimSecItemDelete): Ditto.
        (WebKit::WebKitWebProcessShimInitialize): Copy over the shim callbacks.
        * WebKit2.xcodeproj/project.pbxproj: Link the shim to required frameworks.
        
        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::WebSecItemCopyMatching): Add placeholders for the future to-be-shimmed functions.
        (WebKit::WebSecItemAdd): Ditto.
        (WebKit::WebSecItemUpdate): Ditto.
        (WebKit::WebSecItemDelete): Ditto.
        (WebKit::WebProcess::initializeShim): Pass along those placeholders to the shim initializer.

2011-05-17  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        Part 1 of <rdar://problem/8814289> and https://bugs.webkit.org/show_bug.cgi?id=60595
        Mac WebKit2 WebProcess needs a shim to make prompts appear to be from the UIProcess

        Add am empty shim for a new WebProcess shim and install it at launch.

        Use the same Shim.xcconfig for both the web and plugin processes:
        * Configurations/PluginProcessShim.xcconfig: Removed.
        * Configurations/Shim.xcconfig: Copied from Configurations/PluginProcessShim.xcconfig.
        * WebKit2.xcodeproj/project.pbxproj:

        * WebProcess/WebProcess.h: Add initializeShim() for Mac-only
        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::WebProcess::initializeShim): Initialize the (empty) shim callbacks.

        * WebProcess/mac/WebProcessMainMac.mm:
        (WebKit::WebProcessMain): Call initializeShim()

        * WebProcess/mac/WebProcessShim.h: Added.
        * WebProcess/mac/WebProcessShim.mm: Added.
        (WebKit::WebKitWebProcessShimInitialize): Empty for now.

        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::ProcessLauncher::launchProcess): Install the Plugin Process shim for plugin processes
          and the WebProcess shim for the web content process.

2011-05-17  John Sullivan  <sullivan@apple.com>

        Reviewed by Adam Roben.

        Loose end from fix for https://bugs.webkit.org/show_bug.cgi?id=60938

        * WebKit2.xcodeproj/project.pbxproj:
        Made new header file "private" instead of "project" so clients can access it.

2011-05-17  Andreas Kling  <kling@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt][WK2] Remove usage of ChunkedUpdateDrawingArea.
        https://bugs.webkit.org/show_bug.cgi?id=60901

        To prepare for the eventual removal of the ChunkedUpdateDrawingArea,
        make QGraphicsWKView's "Simple" backing store type map to DrawingAreaImpl.

        * UIProcess/API/qt/qgraphicswkview.cpp:
        * UIProcess/API/qt/qgraphicswkview.h:
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPagePrivate::createDrawingAreaProxy):

2011-05-16  Martin Robinson  <mrobinson@igalia.com>

        Take another shot at fixing the WinCairo build.

        * Shared/cairo/LayerTreeContextCairo.cpp: Include NotImplemented.h using a framework include.

2011-05-16  Sam Weinig  <sam@webkit.org>

        Reviewed by Jon Honeycutt.

        Add access to process pid in WebKit2 API
        https://bugs.webkit.org/show_bug.cgi?id=60938

        * UIProcess/API/C/mac/WKPagePrivateMac.cpp: Added.
        (WKPageGetProcessIdentifier):
        * UIProcess/API/C/mac/WKPagePrivateMac.h: Added.
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::processIdentifier):
        * UIProcess/WebPageProxy.h:
        * WebKit2.xcodeproj/project.pbxproj:
        Add WKPageGetProcessIdentifier as SPI for the mac.

2011-05-16  Martin Robinson  <mrobinson@igalia.com>

        Add file missing from my previous commit.

        * Shared/cairo/LayerTreeContextCairo.cpp: Added.

2011-05-16  Martin Robinson  <martin.james.robinson@gmail.com>

        Try to fix the WinCairo build after r86612.

        Move the LayerTreeContextGtk.cpp stub to LayerTreeContextCairo.cpp and add
        it to the WinCairo build.

        * GNUmakefile.am: Update the source list.
        * Shared/cairo/LayerTreeContextCairo.cpp: Renamed from Source/WebKit2/Shared/gtk/LayerTreeContextGtk.cpp.
        * win/WebKit2.vcproj: Update the source list.

2011-05-16  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Anders Carlsson.

        [GTK] [WebKit2] Provide a fast version of the backing store for X11
        https://bugs.webkit.org/show_bug.cgi?id=60912

        Instead of allocating the backing store surface directly in WebKit2,
        instantiate the GtkWidgetBackingStore class which abstracts away the
        platform-specific details of maintaining the backing store.

        * UIProcess/BackingStore.h:
        * UIProcess/gtk/BackingStoreGtk.cpp:
        (WebKit::BackingStore::paint): Call into GtkWidgetBackingStore to get the Cairo surface now.
        (WebKit::BackingStore::incorporateUpdate): Ditto.
        (WebKit::BackingStore::scroll): Call into GtkWidgetBackingStore to do the actual backing store scroll.

2011-05-16  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Darin Adler.

        Plug-in hit testing is broken after zooming
        https://bugs.webkit.org/show_bug.cgi?id=60916

        Construct a WebMouseEvent to send to plugin, adjusting values to take pageScaleFactor
        into account. Also adjusted bounds sent to viewGeometryDidChange to take pageScaleFactor
        into account. Both are needed or the plugin will think the mouse positions are outside
        its bounds.

        * Shared/WebEvent.h:
        * Shared/WebMouseEvent.cpp:Add ctor to clone a WebMouseEvent and add a scaleFactor to values
        (WebKit::WebMouseEvent::WebMouseEvent):
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::handleEvent):Adjust mouse coords to take pageScaleFactor into account
        (WebKit::PluginView::viewGeometryDidChange):Adjust bounds to take pageScaleFactor into account

2011-05-16  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Anders Carlsson.

        GTK port of WebKit2 should switch to new DrawingAreaImpl model
        https://bugs.webkit.org/show_bug.cgi?id=59655

        * GNUmakefile.am: Add the files necessary to use the DrawingAreaProxyImpl
        to the source list. The source list also needs the LayerContextTree stubs.
        * Shared/LayerTreeContext.h: This file should not be guarded by
        USE(ACCELERATED_COMPOSITING) as it's needed for the DrawingAreaProxyImpl
        IPC messaging.
        * Shared/gtk/LayerTreeContextGtk.cpp: Added this stub.
        * UIProcess/API/gtk/PageClientImpl.cpp:
        (WebKit::PageClientImpl::createDrawingAreaProxy): Instead of creating the deprecated
        chunked drawing area, create a DrawingAreaProxyImpl.
        (WebKit::PageClientImpl::setViewNeedsDisplay): Here we must now queue a redraw. Previously
        the chunked drawing area was doing this manually. This is the appropriate place though.
        (WebKit::PageClientImpl::scrollView): Add an implementation that just calls into setViewNeedsDisplay.
        * UIProcess/API/gtk/PageClientImpl.h: Added a getter for m_viewWidget.
        (WebKit::PageClientImpl::viewWidget):
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (callDrawingAreaPaintMethod): Added this helper which reduces code duplication between
        GTK+ 2.x and 3.x
        (webkitWebViewBaseExpose): Call the new helper now.
        (webkitWebViewBaseDraw): Ditto.
        * UIProcess/BackingStore.h: Updated to include GTK+ specific types.
        * UIProcess/DrawingAreaProxy.h: Ditto.
        * UIProcess/DrawingAreaProxy.messages.in: Do not the DrawingAreaProxyImpl-specific
         message with USE(ACCELERATED_COMPOSITING).
        * UIProcess/WebPageProxy.cpp: Removed these guards, as DrawingAreProxyImpl is used on all platforms now.
        (WebKit::WebPageProxy::didReceiveMessage): Ditto.
        * UIProcess/WebPageProxy.h: Ditto.
        * UIProcess/gtk/BackingStoreGtk.cpp: Added. This implementation heavily uses Cairo,
        but depends on GTK+/GDK in a few places.
        (WebKit::BackingStore::paint):
        (WebKit::BackingStore::incorporateUpdate):
        (WebKit::BackingStore::scroll):
        * UIProcess/gtk/WebPageProxyGtk.cpp: Added a getting for the viewWidget, which is
        required by BackingStoreGtk. A similar getter exists for Windows and Mac.
        (WebKit::WebPageProxy::viewWidget): Ditto.
        * WebProcess/WebPage/DrawingArea.cpp: Removed these guards as DrawingAreaProxyImpl is used on all platforms now.
        (WebKit::DrawingArea::create): Ditto.
        * WebProcess/WebPage/DrawingArea.h: Ditto.
        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::sendDidUpdateBackingStoreState): Do not guard
        this DrawingAreaProxyImpl-specific message with USE(ACCELERATED_COMPOSITING)
        * WebProcess/WebPage/WebPage.cpp: Removed these guards as DrawingAreaProxyImpl is used on all platforms now.
        (WebKit::WebPage::didReceiveMessage): Ditto.

2011-05-16  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Sam Weinig.

        Sandbox denies Kerberos authentication
        https://bugs.webkit.org/show_bug.cgi?id=60921
        <rdar://problem/9133872>
        
        * WebProcess/com.apple.WebProcess.sb:

2011-05-16  David Kilzer  <ddkilzer@apple.com>

        <http://webkit.org/b/60913> C++ exceptions should not be enabled when building with llvm-gcc-4.2
        <rdar://problem/9446430>

        Reviewed by Mark Rowe.

        * Configurations/Base.xcconfig: Fixed typo.

2011-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        If the root compositing layer changes while we're about to exit compositing mode, make sure to enter compositing mode
        https://bugs.webkit.org/show_bug.cgi?id=60905
        <rdar://problem/9365574>

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::setRootCompositingLayer):
        If we have a layer tree host, but haven't yet sent a EnterAcceleratedCompositingMode message (this can happen
        when quickly going in and out of compositing mode), make sure to schedule a notification when the layer tree host
        does it next flush. This will end up sending the EnterAcceleratedCompositingMode message.

2011-05-13  Jer Noble  <jer.noble@apple.com>

        Reviewed by Simon Fraser.

        Video is blank, controller is misplaced on trailers.apple.com movie in fullscreen (with two screens)
        https://bugs.webkit.org/show_bug.cgi?id=60826

        Emit a notification when moving a CALayer from the WebProcess's main
        layer host to a new context.  This allows listeners to invalidate their
        layers which may not support moving between different CAContexts (as is
        the case with QTMovieLayer).  In order to allow listeners to determine if they
        are affected, the notification will pass the root CALayer in a userInfo
        dictionary.

        In WebFullScreenManagerMac, move from storing a pointer to a non-refcounted
        class (GraphicsLayer) to a retainable class (PlatformLayer).

        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.h:
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::WebFullScreenManagerMac): No need to initialize
            m_fullScreenRootLayer now that it is a RetainPtr<>.
        (WebKit::WebFullScreenManagerMac::setRootFullScreenLayer): Emit a notification
            after either creating or destroying the full screen layer host.
        (WebKit::WebFullScreenManagerMac::beginEnterFullScreenAnimation):
        (WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation):

2011-05-16  Siddharth Mathur  <siddharth.mathur@nokia.com>

        Rubber-stamped by Csaba Osztrogonác.

        [Qt][Wk2][Symbian] Fix build after r86560
        https://bugs.webkit.org/show_bug.cgi?id=60887

        Temporarily fix Symbian build by re-enabling compilation
        of Qt/Gtk common code (as was the case for Symbian before r55875).
        This is a stop gap until the pure Symbian Core IPC and process launching bits land in Bug 55875
        As of this revision, only the native SharedMemory implementation is in trunk.

        * Platform/CoreIPC/Attachment.h: Compile Qt/Gtk common code for Qt-Symbian too
        * Platform/CoreIPC/Connection.h: ditto
        * Platform/SharedMemory.h:       ditto
        * Platform/qt/SharedMemorySymbian.cpp: stub implementations of attachment handling
        (WebKit::SharedMemory::Handle::releaseToAttachment):
        (WebKit::SharedMemory::Handle::adoptFromAttachment):

2011-05-16  Jon Lee  <jonlee@apple.com>

        Reviewed by Simon Fraser.

        Can't horizontally scroll iframes and overflow because wheel events are always accepted
        https://bugs.webkit.org/show_bug.cgi?id=60779

        We keep track of the number of horizontal scrollbars and mouse wheel event handlers in the
        UI process as a means of determining whether horizontal scroll events will be handled
        by the web process.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::willHandleHorizontalScrollEvents): Return true if there is at least
        one wheel event handler
        * UIProcess/WebPageProxy.h: Add new variable to cache the count
        (WebKit::WebPageProxy::numWheelEventHandlersChanged): Sets the count

        The rest just provides all the connections.
        * UIProcess/API/C/WKPage.cpp:
        (WKPageWillHandleHorizontalScrollEvents):
        * UIProcess/API/C/WKPage.h:
        * UIProcess/WebPageProxy.messages.in:
        * WebProcess/InjectedBundle/API/c/WKBundlePage.h:
        * WebProcess/InjectedBundle/InjectedBundlePageUIClient.cpp:
        (WebKit::InjectedBundlePageUIClient::shouldRubberBandInDirection):
        * WebProcess/InjectedBundle/InjectedBundlePageUIClient.h:
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::shouldRubberBandInDirection): Forward to injected bundle UI client
        (WebKit::WebChromeClient::updateCountWheelEventHandlers): Updates the web page proxy
        * WebProcess/WebCoreSupport/WebChromeClient.h:

2011-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        Silverlight: Selection via keyboard selects the entire plugin instead of the contents of a TextBox
        https://bugs.webkit.org/show_bug.cgi?id=60898
        <rdar://problem/9309903>

        Special-case Command-A and always return true, indicating that the plug-in handled the event.
        This matches WebKit1.

        * WebProcess/Plugins/Netscape/mac/NetscapePluginMac.mm:
        (WebKit::NetscapePlugin::platformHandleKeyboardEvent):

2011-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        Short-circuit NPRuntime calls made by Flash during plug-in instantiation
        https://bugs.webkit.org/show_bug.cgi?id=60894
        <rdar://problem/8804681>

        During plug-in instantiation, Flash makes a couple of NPRuntime calls to get the
        URL of the current document as well as the URL of the toplevel document. This leads to
        a bunch of IPC traffic that slows down instantiation.

        Since we know what calls Flash is making and what results are expected, we can handle the
        NPRuntime calls directly in the plug-in process and avoid extra IPC overhead.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::PluginControllerProxy):
        Initialize m_pluginCreationParameters.

        (WebKit::PluginControllerProxy::initialize):
        Set m_pluginCreationParameters to point to the creation parameters right before
        calling Plugin::initialize and restore it back afterwards.

        (WebKit::PluginControllerProxy::tryToShortCircuitInvoke):
        If the plug-in calling NPN_Invoke has the CanShortCircuitSomeNPRuntimeCallsDuringInitialization
        quirk, and we're being initialized, check for the __flash_getWindowLocation and
        __flash_getTopLocation function calls and return the correct values.

        (WebKit::PluginControllerProxy::tryToShortCircuitEvaluate):
        Check if the script string has the definitions of __flash_getWindowLocation or __flash_getTopLocation
        and just ignore them. Note that ignoring them has the effect of not adding them to the window object,
        which could in theory be a backwards compatibility problem if web pages were to assume that these
        functions existed on a page with plug-ins. In practice this is probably not a problem, especially since
        these functions are only used on Mac WebKit.

        * PluginProcess/PluginControllerProxy.h:
        (WebKit::PluginControllerProxy::inInitialize):
        Add helper function.

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::NetscapePluginModule::determineQuirks):
        Add the CanShortCircuitSomeNPRuntimeCallsDuringInitialization quirk for Flash on Mac.

        * Shared/Plugins/PluginQuirks.h:
        Add Mac specific CanShortCircuitSomeNPRuntimeCallsDuringInitialization quirk.

2011-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam Roben.

        Add a returnValue parameter to tryToShortCircuitInvoke
        https://bugs.webkit.org/show_bug.cgi?id=60891

        tryToShortCircuitInvoke needs to be able to indicate that an invoke
        call failed. Add a returnValue parameter and have the real return value
        indicate whether tryToShortCircuitInvoke did short-circuit the invoke or not.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::tryToShortCircuitInvoke):
        * PluginProcess/PluginControllerProxy.h:
        * WebProcess/Plugins/Netscape/NetscapeBrowserFuncs.cpp:
        (WebKit::NPN_Invoke):
        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::tryToShortCircuitInvoke):
        * WebProcess/Plugins/Netscape/NetscapePlugin.h:
        * WebProcess/Plugins/PluginController.h:
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::tryToShortCircuitInvoke):
        * WebProcess/Plugins/PluginView.h:

2011-05-16  Siddharth Mathur  <siddharth.mathur@nokia.com>

        Reviewed by Csaba Osztrogonác.

        [Qt][Wk2][Symbian] Fix build after r86560
        https://bugs.webkit.org/show_bug.cgi?id=60887

        * Platform/CoreIPC/ArgumentDecoder.cpp:
        (CoreIPC::ArgumentDecoder::~ArgumentDecoder): guard Unix and Gtk code with USE(UNIX_DOMAIN_SOCKETS)
        * Platform/CoreIPC/ArgumentEncoder.cpp:
        (CoreIPC::ArgumentEncoder::~ArgumentEncoder): ditto

2011-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam Roben.

        Add the ability for a plug-in controller to short-circuit calls to NPN_Invoke
        https://bugs.webkit.org/show_bug.cgi?id=60886

        Make it possible for a plug-in controller to intercept calls to NPN_Invoke, which
        will be useful for avoiding sync IPC messages during instantiation.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::evaluate):
        Call tryToShortCircuitEvaluate. If it returns true, we don't need to call back to
        the web process to ask it to evaluate the script string.

        (WebKit::PluginControllerProxy::tryToShortCircuitInvoke):
        (WebKit::PluginControllerProxy::tryToShortCircuitEvaluate):
        Always return false for now.

        * WebProcess/Plugins/Netscape/NetscapeBrowserFuncs.cpp:
        (WebKit::NPN_Invoke):
        Get the plug-in and call tryToShortCircuitInvoke.

        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::tryToShortCircuitInvoke):
        Call the plug-in controller.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::tryToShortCircuitInvoke):
        Always return false here, since there's no need to short-circuit calls
        for plug-ins that live in the web process.

2011-05-16  Siddharth Mathur  <siddharth.mathur@nokia.com>

        Reviewed by Laszlo Gombos.

        [Qt][WK2][Symbian] Shared memory implementation for Symbian
        https://bugs.webkit.org/show_bug.cgi?id=55875

        Use global chunks for sharing data between processes.
        This is an initial implementation. An outstanding issue
        is the correct way to close() the chunk in the SharedMemory d'tor
        without triggering a delete by the kernel when the ref-count
        temporarily goes to zero.

        * Platform/SharedMemory.h: platform specific handle and chunk name
        * Platform/qt/SharedMemorySymbian.cpp: Added. Native Symbian OS implementation
        using RChunk.CreateGlobal() for named chunks. The chunk name is serialized
        and sent over the IPC channel and opened by the remote process using
        RChunk.OpenGlobal().

        (WebKit::SharedMemory::Handle::Handle):
        (WebKit::SharedMemory::Handle::~Handle):
        (WebKit::SharedMemory::Handle::isNull):
        (WebKit::SharedMemory::Handle::encode):
        (WebKit::SharedMemory::Handle::decode):
        (WebKit::SharedMemory::create):
        (WebKit::SharedMemory::~SharedMemory):
        (WebKit::SharedMemory::createHandle):
        (WebKit::SharedMemory::systemPageSize):
        * Platform/unix/SharedMemoryUnix.cpp: Exclude Qt-Symbian using HAVE(UNIX_DOMAIN_SOCKETS)
        * WebKit2.pro: Add SharedMemorySymbian.cpp

2011-05-16  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix WebKit2 GTK build after r86489.

        * GNUmakefile.am: Add PluginProcess/PluginCreationParameters.cpp
        and PluginProcess/PluginCreationParameters.h to compilation.

2011-05-16  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Enable building GTK port with ENABLE_PLUGIN_PROCESS=1
        https://bugs.webkit.org/show_bug.cgi?id=58223

        * GNUmakefile.am: Add new files to compilation.
        * PluginProcess/gtk/PluginControllerProxyGtk.cpp: Added.
        (WebKit::PluginControllerProxy::platformInitialize):
        (WebKit::PluginControllerProxy::platformDestroy):
        (WebKit::PluginControllerProxy::platformGeometryDidChange):
        * PluginProcess/gtk/PluginProcessGtk.cpp: Added.
        (WebKit::PluginProcess::platformInitialize):
        * UIProcess/Plugins/gtk/PluginProcessProxyGtk.cpp: Added.
        (WebKit::PluginProcessProxy::platformInitializePluginProcess):
        * WebProcess/Plugins/Netscape/gtk/PluginProxyGtk.cpp: Added.
        (WebKit::PluginProxy::needsBackingStore):

2011-05-16  Adam Barth  <abarth@webkit.org>

        Attempt to fix the Qt build.  (Strict PassOwnPtr fix.)

        * Shared/qt/ShareableBitmapQt.cpp:
        (WebKit::ShareableBitmap::createGraphicsContext):

2011-05-15  Michael Saboff  <msaboff@apple.com>

        Reviewed by Geoffrey Garen.

        Suboptimal lifetime of BackingStore objects in DrawingAreaProxyImpl
        https://bugs.webkit.org/show_bug.cgi?id=60864

        Implemented reuse of BackingStore's in 
        DrawingAreaProxyImpl::didUpdateBackingStoreState when the size needed
        matches the size of the existing BackingStore.
        Also reduced the discardBackingStoreTimer from 5 to 2 seconds.
        These changes reduces memory usage up to 10MB on memory tests.

        * UIProcess/DrawingAreaProxyImpl.cpp:
        (WebKit::DrawingAreaProxyImpl::didUpdateBackingStoreState):
        (WebKit::DrawingAreaProxyImpl::discardBackingStoreSoon):

2011-05-15  Anders Carlsson  <andersca@apple.com>

        Reviewed by Maciej Stachowiak.

        Pass the window NPObject identifier in the plug-in creation parameters
        https://bugs.webkit.org/show_bug.cgi?id=60865

        This avoids a synchronous call when the plug-in wants to get the NPObject that
        corresponds to the window.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::initialize):
        Change this to take the PluginCreationParameters. Initialize the window NPObject.

        (WebKit::PluginControllerProxy::windowScriptNPObject):
        Just return the window NPObject; it's already been initialized.

        * PluginProcess/PluginControllerProxy.h:
        * PluginProcess/PluginCreationParameters.cpp:
        (WebKit::PluginCreationParameters::PluginCreationParameters):
        (WebKit::PluginCreationParameters::encode):
        (WebKit::PluginCreationParameters::decode):
        * PluginProcess/PluginCreationParameters.h:
        Add the window NPObject ID.

        * PluginProcess/WebProcessConnection.cpp:
        (WebKit::WebProcessConnection::createPlugin):
        Pass the creation parameters to PluginControllerProxy::initialize.

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::initialize):
        Initialize the window NPObject ID.

        * WebProcess/Plugins/PluginProxy.messages.in:
        Remove the GetWindowScriptNPObject message.

2011-05-15  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoffrey Garen.

        Pass the document URL and toplevel document URL when creating a plug-in
        https://bugs.webkit.org/show_bug.cgi?id=60863

        This is the first of a series of patches intended to reduce the IPC traffic
        during plug-in instantiation.

        * WebProcess/Plugins/Plugin.cpp:
        (WebKit::Plugin::Parameters::encode):
        Encode the URLs.

        (WebKit::Plugin::Parameters::decode):
        Decode the URLs.

        * WebProcess/Plugins/Plugin.h:
        Add the document and toplevel document URLs.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::createPlugin):
        Initialize the document and toplevel document URLs.

2011-05-13  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoffrey Garen.

        Make GC validation more aggressive
        https://bugs.webkit.org/show_bug.cgi?id=60802

        Add GC_VALIDATION calls to all the JSNPObject methods.

        * WebProcess/Plugins/Netscape/JSNPObject.cpp:
        (WebKit::JSNPObject::invalidate):
        (WebKit::JSNPObject::callMethod):
        (WebKit::JSNPObject::callObject):
        (WebKit::JSNPObject::callConstructor):
        (WebKit::JSNPObject::getCallData):
        (WebKit::JSNPObject::getConstructData):
        (WebKit::JSNPObject::getOwnPropertySlot):
        (WebKit::JSNPObject::getOwnPropertyDescriptor):
        (WebKit::JSNPObject::put):
        (WebKit::JSNPObject::getOwnPropertyNames):
        (WebKit::JSNPObject::propertyGetter):
        (WebKit::JSNPObject::methodGetter):

2011-05-13  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoffrey Garen.

        Make GC validation more aggressive
        https://bugs.webkit.org/show_bug.cgi?id=60802

        Add GC_VALIDATION calls to all the JSNPObject methods.

        * WebProcess/Plugins/Netscape/JSNPObject.cpp:
        (WebKit::JSNPObject::invalidate):
        (WebKit::JSNPObject::callMethod):
        (WebKit::JSNPObject::callObject):
        (WebKit::JSNPObject::callConstructor):
        (WebKit::JSNPObject::getCallData):
        (WebKit::JSNPObject::getConstructData):
        (WebKit::JSNPObject::getOwnPropertySlot):
        (WebKit::JSNPObject::getOwnPropertyDescriptor):
        (WebKit::JSNPObject::put):
        (WebKit::JSNPObject::getOwnPropertyNames):
        (WebKit::JSNPObject::propertyGetter):
        (WebKit::JSNPObject::methodGetter):

2011-05-14  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Sam Weinig.

        WebKit2: Smart cut&paste is broken
        https://bugs.webkit.org/show_bug.cgi?id=60840
        <rdar://problem/9439927>

        * UIProcess/mac/TextCheckerMac.mm: (WebKit::TextChecker::isSmartInsertDeleteEnabled):
        Match WK1 - this default defaults to YES if not present.

2011-05-14  Dan Bernstein  <mitz@apple.com>

        Reviewed by Alice Liu.

        WKView does not draw after forced repaint before the first update
        https://bugs.webkit.org/show_bug.cgi?id=60845

        * UIProcess/DrawingAreaProxy.h:
        (WebKit::DrawingAreaProxy::waitForBackingStoreUpdateOnNextPaint): Added.
        * UIProcess/DrawingAreaProxyImpl.cpp:
        (WebKit::DrawingAreaProxyImpl::waitForBackingStoreUpdateOnNextPaint): Set m_hasReceivedFirstUpdate
        to true, ensuring that paint() will wait for an update if needed.
        * UIProcess/DrawingAreaProxyImpl.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::forceRepaint): Call DrawingAreaProxy::waitForBackingStoreUpdateOnNextPaint().

2011-05-14  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Document the WantsMozillaUserAgent quirk and make it Windows specific
        https://bugs.webkit.org/show_bug.cgi?id=60843

        * Shared/Plugins/PluginQuirks.h:
        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::userAgent):

2011-05-14  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Consolidate plug-in creation parameters to a single struct
        https://bugs.webkit.org/show_bug.cgi?id=60839

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::create):
        (WebKit::PluginControllerProxy::PluginControllerProxy):
        * PluginProcess/PluginControllerProxy.h:
        * PluginProcess/PluginCreationParameters.cpp: Added.
        (WebKit::PluginCreationParameters::PluginCreationParameters):
        (WebKit::PluginCreationParameters::encode):
        (WebKit::PluginCreationParameters::decode):
        * PluginProcess/PluginCreationParameters.h: Added.
        * PluginProcess/WebProcessConnection.cpp:
        (WebKit::WebProcessConnection::createPlugin):
        * PluginProcess/WebProcessConnection.h:
        * PluginProcess/WebProcessConnection.messages.in:
        * Scripts/webkit2/messages.py:
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::initialize):

2011-05-14  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        NPP_URLNotify is not called if a URL passed to NPN_GetURLNotify fails to load
        https://bugs.webkit.org/show_bug.cgi?id=60823
        <rdar://problem/9430386>

        If a plug-in stream fails to load before it's been started, we won't destroy the stream.

        * WebProcess/Plugins/Netscape/NetscapePluginStream.cpp:
        (WebKit::NetscapePluginStream::stop):
        Call notifyAndDestroyStream which will call NPP_URLNotify if necessary, and also destroy the stream.

        (WebKit::NetscapePluginStream::notifyAndDestroyStream):
        Pass the request URL to NPP_URLNotify, matching other browsers.

2011-05-14  Jer Noble  <jer.noble@apple.com>

        Reviewed by Simon Fraser.

        Flashing window frame and graphical glitches after exiting full screen mode.
        https://bugs.webkit.org/show_bug.cgi?id=60825

        A layer-backed WebView throws an exception when moved from a layer-backed parent view
        to a non-layer-backed one, so make the WebView a child of the content view, instead of
        the animation view.  There is an unrelated fix in beganExitFullScreen, which was calling
        finishedExitFullScreenAnimation: instead of finishedEnterFullScreenAnimation: when 
        notifications come out of order.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]): Add the _webView
            to the full screen window's content view, instead of the _animationView.
        (-[WKFullScreenWindowController beganExitFullScreenAnimation]): Call 
            finishedEnterFullScreenAnimation: instead of finishedExitFullScreenAnimation:.
        (-[WKFullScreenWindowController enterAcceleratedCompositingMode:WebKit::]): Add the
            _layerHostingView to the contentView, instead of the animationView.

2011-05-14  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed, rolling out r86469 and r86471, because they made hundreds tests crash on Qt.

        Make GC validation more aggressive
        https://bugs.webkit.org/show_bug.cgi?id=60802

        * WebProcess/Plugins/Netscape/JSNPObject.cpp:
        (WebKit::JSNPObject::invalidate):
        (WebKit::JSNPObject::callMethod):
        (WebKit::JSNPObject::callObject):
        (WebKit::JSNPObject::callConstructor):
        (WebKit::JSNPObject::getCallData):
        (WebKit::JSNPObject::getConstructData):
        (WebKit::JSNPObject::getOwnPropertySlot):
        (WebKit::JSNPObject::getOwnPropertyDescriptor):
        (WebKit::JSNPObject::put):
        (WebKit::JSNPObject::getOwnPropertyNames):
        (WebKit::JSNPObject::propertyGetter):
        (WebKit::JSNPObject::methodGetter):

2011-05-14  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r86476.
        http://trac.webkit.org/changeset/86476
        https://bugs.webkit.org/show_bug.cgi?id=60832

        It made plugins/get-url-notify-with-url-that-fails-to-
        load.html crash on GTK (Requested by Ossy on #webkit).

        * WebProcess/Plugins/Netscape/NetscapePluginStream.cpp:
        (WebKit::NetscapePluginStream::stop):
        (WebKit::NetscapePluginStream::notifyAndDestroyStream):

2011-05-13  Enrica Casucci  <enrica@apple.com>

        Reviewed by Darin Adler and Brian Weinstein.

        REGRESSION (WK2): Can't drag and drop a link or image from Safari to Desktop
        https://bugs.webkit.org/show_bug.cgi?id=60819
        <rdar://problem/9370689>

        To support drag-and-drop to the desktop and other windows applications,
        we need to support the fileDescriptor and fileContentZero clipboard formats.
        This patch adds the support for serializing these types across the process boundary.

        * Platform/CoreIPC/Arguments.h: Added support for messages with 10 arguments.
        (CoreIPC::Arguments10::Arguments10):
        (CoreIPC::Arguments10::encode):
        (CoreIPC::Arguments10::decode):
        (CoreIPC::In):
        (CoreIPC::Out):
        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC::callMemberFunction): Added support for memebers with 10 arguments.
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::startDragDrop):
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * WebProcess/WebCoreSupport/win/WebDragClientWin.cpp:
        (WebKit::WebDragClient::startDrag):

2011-05-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        NPP_URLNotify is not called if a URL passed to NPN_GetURLNotify fails to load
        https://bugs.webkit.org/show_bug.cgi?id=60823
        <rdar://problem/9430386>

        If a plug-in stream fails to load before it's been started, we won't destroy the stream.

        * WebProcess/Plugins/Netscape/NetscapePluginStream.cpp:
        (WebKit::NetscapePluginStream::stop):
        Call notifyAndDestroyStream which will call NPP_URLNotify if necessary, and also destroy the stream.

        (WebKit::NetscapePluginStream::notifyAndDestroyStream):
        Pass the request URL to NPP_URLNotify, matching other browsers.

2011-05-13  Michael Saboff  <msaboff@apple.com>

        Reviewed by Geoffrey Garen.

        Backing store may not get discarded due to stopped timer
        https://bugs.webkit.org/show_bug.cgi?id=60816

        Changed the backing store timer to restart if it has been stopped.
        The evaluation is done when the view's state is changed.
        This change appears to be worth ~3MB (one backing store worth)
        during memory tests.

        * UIProcess/DrawingAreaProxyImpl.cpp:
        (WebKit::DrawingAreaProxyImpl::discardBackingStoreSoon):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::viewStateDidChange):

2011-05-13  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoffrey Garen.

        Make GC validation more aggressive
        https://bugs.webkit.org/show_bug.cgi?id=60802

        Add GC_VALIDATION calls to all the JSNPObject methods.

        * WebProcess/Plugins/Netscape/JSNPObject.cpp:
        (WebKit::JSNPObject::invalidate):
        (WebKit::JSNPObject::callMethod):
        (WebKit::JSNPObject::callObject):
        (WebKit::JSNPObject::callConstructor):
        (WebKit::JSNPObject::getCallData):
        (WebKit::JSNPObject::getConstructData):
        (WebKit::JSNPObject::getOwnPropertySlot):
        (WebKit::JSNPObject::getOwnPropertyDescriptor):
        (WebKit::JSNPObject::put):
        (WebKit::JSNPObject::getOwnPropertyNames):
        (WebKit::JSNPObject::propertyGetter):
        (WebKit::JSNPObject::methodGetter):

2011-05-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        NPN_GetURL with a javascript: URL doesn't send back the result in the stream
        https://bugs.webkit.org/show_bug.cgi?id=60810

        In NetscapePluginStream::sendJavaScriptStream, we were incorrectly passing the result URL
        to the stream, instead of the result. Also, store the request URL in the NetscapePluginStream object
        to avoid sending it over the wire.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::didEvaluateJavaScript):
        * PluginProcess/PluginControllerProxy.h:
        * PluginProcess/PluginControllerProxy.messages.in:
        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::loadURL):
        (WebKit::NetscapePlugin::didEvaluateJavaScript):
        (WebKit::NetscapePlugin::manualStreamDidReceiveResponse):
        * WebProcess/Plugins/Netscape/NetscapePlugin.h:
        * WebProcess/Plugins/Netscape/NetscapePluginStream.cpp:
        (WebKit::NetscapePluginStream::NetscapePluginStream):
        (WebKit::NetscapePluginStream::sendJavaScriptStream):
        * WebProcess/Plugins/Netscape/NetscapePluginStream.h:
        (WebKit::NetscapePluginStream::create):
        * WebProcess/Plugins/Plugin.h:
        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::didEvaluateJavaScript):
        * WebProcess/Plugins/PluginProxy.h:
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::performJavaScriptURLRequest):

2011-05-13  Jeff Miller  <jeffm@apple.com>

        Reviewed by Darin Adler.

        Make some page() member functions const
        https://bugs.webkit.org/show_bug.cgi?id=60794

        * UIProcess/ChunkedUpdateDrawingAreaProxy.h: Make page() const.
        * UIProcess/WebFrameProxy.h:
        (WebKit::WebFrameProxy::page): Make page() const.
        * UIProcess/WebInspectorProxy.h:
        (WebKit::WebInspectorProxy::page): Make page() const.
        * UIProcess/gtk/ChunkedUpdateDrawingAreaProxyGtk.cpp:
        (WebKit::ChunkedUpdateDrawingAreaProxy::page): Make page() const.
        * UIProcess/mac/ChunkedUpdateDrawingAreaProxyMac.mm:
        (WebKit::ChunkedUpdateDrawingAreaProxy::page): Make page() const.
        * UIProcess/qt/ChunkedUpdateDrawingAreaProxyQt.cpp:
        (WebKit::ChunkedUpdateDrawingAreaProxy::page): Make page() const.
        * UIProcess/win/ChunkedUpdateDrawingAreaProxyWin.cpp:
        (WebKit::ChunkedUpdateDrawingAreaProxy::page): Make page() const.

2011-05-13  Adam Roben  <aroben@apple.com>

        Load plugins in the order they're found

        Fixes <http://webkit.org/b/60788> <rdar://problem/9435787> REGRESSION (r69790): WebKit2
        doesn't prefer plugins in the additional plugins directory

        Reviewed by Anders Carlsson.

        * UIProcess/Plugins/PluginInfoStore.cpp:
        (WebKit::addFromVector):
        Changed to use a ListHashSet instead of a HashSet to store the plugin paths.

2011-05-13  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Prune #includes from FrameView.h (Part 2)
        https://bugs.webkit.org/show_bug.cgi?id=60748

        - Update files that were depending on FrameView.h #including Frame.h or
          Page.h.

        * WebProcess/Plugins/PluginView.cpp:
        * WebProcess/WebCoreSupport/mac/WebDragClientMac.mm:
        * WebProcess/WebPage/WebContextMenu.cpp:
        * WebProcess/WebPage/mac/AccessibilityWebPageObject.mm:

2011-05-13  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Eric Seidel.

        [GTK] Share the GTK+ key binding code between WebKit1 and WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=59765

        Use the new KeyBindingTranslator class from WebCore/platform/gtk. With this utility
        class we can now share the code with WebKit2.

        * UIProcess/API/gtk/PageClientImpl.cpp:
        (WebKit::PageClientImpl::PageClientImpl): No longer need to initialize keybinding code.
        (WebKit::PageClientImpl::getEditorCommandsForKeyEvent): Use the new utility class.
        * UIProcess/API/gtk/PageClientImpl.h: Remove unnecessary members. Add utility class member.

2011-05-12  Pratik Solanki  <psolanki@apple.com>

        Reviewed by Antti Koivisto.

        Part of WebCore should use CFNetwork-based loader on Mac
        https://bugs.webkit.org/show_bug.cgi?id=51836

        Use CFRunLoop when using CFNetwork.

        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::platformInitialize):

2011-05-12  Sam Weinig  <sam@webkit.org>

        Reviewed by Gavin Barraclough.

        WebProcess sandbox denies file:/// accesses after you navigate to a nonexistent file
        <rdar://problem/9427752>
        https://bugs.webkit.org/show_bug.cgi?id=60745

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::SandboxExtensionTracker::didStartProvisionalLoad):
        Don't attempt to re-use a non-existent committed sandbox extension. This can
        happen when the previous load was file: url, but did not require an extension,
        such as an error page.

2011-05-12  Jia Pu  <jpu@apple.com>

        Reviewed by Darin Adler.

        Regression caused by changeset 86281
        https://bugs.webkit.org/show_bug.cgi?id=60712
        <rdar://problem/9427970>

        Removed the condition variable. [NSSpellChecker dismissCorrectionIndicatorForView:] is blocking.
        So handleAcceptedReplacement() triggered by dismissInternal() will return before dismissInternal()
        returns. So we don't need to use the condition to coordinate between these two function. In fact,
        all callbacks are delivered on main thread. We don't really need any locking here.

        Since now we don't have distinction between dismiss() and dismissSoon(). dismissSoon() has
        been removed.

        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::dismissCorrectionPanelSoon):
        * UIProcess/mac/CorrectionPanel.h:
        * UIProcess/mac/CorrectionPanel.mm:
        (WebKit::CorrectionPanel::CorrectionPanel):
        (WebKit::CorrectionPanel::show):
        (WebKit::CorrectionPanel::dismiss):
        (WebKit::CorrectionPanel::dismissInternal):
        (WebKit::CorrectionPanel::handleAcceptedReplacement):

2011-05-12  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        WebKit2: Implement plugin quirk for Mozilla user agent for older Flash
        https://bugs.webkit.org/show_bug.cgi?id=60726
        <rdar://problem/8470824>
        
        Implement the quirk for versions of Flash before v10 that only request windowless plugins
        if we use a Mozilla user agent.

        * Shared/Plugins/Netscape/win/NetscapePluginModuleWin.cpp:
        (WebKit::NetscapePluginModule::determineQuirks): If we have a plugin that handles the
            "application/x-shockwave-flash" MIME type with a version less than 10, tell it to use
            the Mozilla user agent.
        * Shared/Plugins/PluginQuirks.h:
        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::userAgent): Add an early return if the plugin uses the Mozilla user
            agent.
        * win/WebKit2.vcproj: Add PluginQuirks.h.

2011-05-12  Anders Carlsson  <andersca@apple.com>

        Reviewed by Simon Fraser.

        PluginView::invalidateRect doesn't work for transformed plug-ins
        https://bugs.webkit.org/show_bug.cgi?id=60727
        <rdar://problem/9331244>

        Ask the RenderObject to repaint the plug-in instead of using invalidateContentsAndWindow.
        This matches what we do in WebKit1.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::invalidateRect):

2011-05-12  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Darin Adler.

        [Windows WebKit2] Use cookies set in WebKit1
        https://bugs.webkit.org/show_bug.cgi?id=60274

        Properly handle the case where there is no serialized default storage session by not trying
        to encode or decode 0, while still making sure to decode any valid storage session.

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::WebProcessCreationParameters):
        (WebKit::WebProcessCreationParameters::encode):
        Only encode the storage session if there is one to encode.
        (WebKit::WebProcessCreationParameters::decode):
        Only decode the storage session there is one to decode.
        * Shared/WebProcessCreationParameters.h:

2011-05-11  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Anders Carlsson.

        After relaunching an unresponsive web process, web page stops responding to mouse movement
        https://bugs.webkit.org/show_bug.cgi?id=60669
        <rdar://problem/9409934>

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::processDidCrash): Set m_processingMouseMoveEvent to false when the WebProcess
            crashes.

2011-05-10  Tony Gentilcore  <tonyg@chromium.org>

        Reviewed by Darin Adler.

        Perform some forward declarations suggested by include-what-you-use
        https://bugs.webkit.org/show_bug.cgi?id=60545

        * WebProcess/WebPage/mac/WebPageMac.mm:

2011-05-12  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        Fix the build with ENABLE_PLUGIN_PROCESS
        https://bugs.webkit.org/show_bug.cgi?id=60628

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::initialize): Move the call to
        pluginController->isAcceleratedCompositingEnabled() to a #ifdef block.
        * WebProcess/Plugins/PluginProxy.h: Add include for <WebCore/IntRect.h>.

2011-05-11  Damian Kaleta  <dkaleta@apple.com>

        Reviewed by Brady Eidson.

        Need a new API that will try to restore the scrollbars' position, when navigating in the back/forward history
        https://bugs.webkit.org/show_bug.cgi?id=60674

        * UIProcess/API/C/WKPage.cpp:
        (WKPageTryRestoreScrollPosition):
        * UIProcess/API/C/WKPage.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::tryRestoreScrollPosition):
        * UIProcess/WebPageProxy.h:
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::tryRestoreScrollPosition):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:

2011-05-11  Sam Weinig  <sam@webkit.org>

        Reviewed by Gavin Barraclough.

        WebKit2 doesn't build on Mac with strict PassOwnPtr
        https://bugs.webkit.org/show_bug.cgi?id=60655

        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC::handleMessageDelayed):
        Add explicit adoptPtr to indicate that the constructor is taking ownership.

2011-05-11  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Steve Falkenburg.

        [Windows WebKit2] Use cookies set in WebKit1
        https://bugs.webkit.org/show_bug.cgi?id=60274

        Share the default storage session between the UI and Web Processes.

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode):
        Only encode the session parameter if it is valid.
        (WebKit::WebProcessCreationParameters::decode):
        Don't try to decode a null session data. 
        * Shared/WebProcessCreationParameters.h:
        Add a parameter for a serialized default storage session, used only on Windows.

        * Shared/win/WebCoreArgumentCodersWin.cpp:
        (CoreIPC::decodeResourceRequest):
        Make sure to set the current storage session on any requests used by the Web
        Process before CFNetwork has to do anything with them, in order for CFNetwork to avoid
        doing anything with the Web Process's default storage session.

        * UIProcess/win/WebContextWin.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):
        Serialize the default storage session in the UI Process and add it to the
        WebProcessCreationParameters.

        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::cachedResponseForURL):
        Use the cache associated with the current storage session and make sure the request has the
        current storage session set on it before doing anything with it.

        * WebProcess/win/WebProcessWin.cpp:
        (WebKit::WebProcess::platformSetCacheModel):
        Use the default storage session.
        (WebKit::WebProcess::platformClearResourceCaches):
        Ditto.
        (WebKit::WebProcess::platformInitializeWebProcess):
        Deserialize the default storage session passed in by the UI Process and hand it to the
        ResourceHandle.

2011-05-11  Jia Pu  <jpu@apple.com>

        Reviewed by Darin Adler.

        CorrectionPanel sometimes hangs in dismissSoon().
        https://bugs.webkit.org/show_bug.cgi?id=60599
        <rdar://problem/9313628>

        Make sure dismissSoon() won't wait indefinitely if handleAcceptedReplacement() sets m_resultForSynchronousDismissal
        to nil. Added a designated variable m_isDismissing, instead of piggy-backing m_resultForSynchronousDismissal,
        for condition checking.

        * UIProcess/mac/CorrectionPanel.h:
        * UIProcess/mac/CorrectionPanel.mm:
        (WebKit::CorrectionPanel::CorrectionPanel):
        (WebKit::CorrectionPanel::show):
        (WebKit::CorrectionPanel::dismissSoon):
        (WebKit::CorrectionPanel::dismissInternal):
        (WebKit::CorrectionPanel::handleAcceptedReplacement):

2011-05-11  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r86255.
        http://trac.webkit.org/changeset/86255
        https://bugs.webkit.org/show_bug.cgi?id=60660

        REGRESSION (r86255): Lots of tests crashing in
        CFWriteStreamCreateWithAllocatedBuffers on Windows 7 Release
        (WebKit2 Tests) (Requested by aroben on #webkit).

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode):
        (WebKit::WebProcessCreationParameters::decode):
        * Shared/WebProcessCreationParameters.h:
        * Shared/win/WebCoreArgumentCodersWin.cpp:
        (CoreIPC::decodeResourceRequest):
        * UIProcess/win/WebContextWin.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):
        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::cachedResponseForURL):
        * WebProcess/win/WebProcessWin.cpp:
        (WebKit::WebProcess::platformSetCacheModel):
        (WebKit::WebProcess::platformClearResourceCaches):
        (WebKit::WebProcess::platformInitializeWebProcess):

2011-05-11  Adam Roben  <aroben@apple.com>

        Don't notify the plugin when a targeted javascript: URL request completes

        This matches Mozilla and WebKit1.

        Fixes <http://webkit.org/b/60568> <rdar://problem/8610657> REGRESSION (WebKit2): Flash
        plugin doesn't appear on a hanes.com page

        Test: plugins/get-targeted-javascript-url.html

        Reviewed by Anders Carlsson.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::performJavaScriptURLRequest): Don't call back to the plugin if the
        request had a target.

2011-05-11  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Steve Falkenburg.

        [Windows WebKit2] Use cookies set in WebKit1
        https://bugs.webkit.org/show_bug.cgi?id=60274

        Share the default storage session between the UI and Web Processes.

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode):
        (WebKit::WebProcessCreationParameters::decode):
        * Shared/WebProcessCreationParameters.h:
        Add a parameter for a serialized default storage session, used only on Windows.

        * Shared/win/WebCoreArgumentCodersWin.cpp:
        (CoreIPC::decodeResourceRequest):
        Make sure to set the current storage session on any requests used by the Web
        Process before CFNetwork has to do anything with them, in order for CFNetwork to avoid
        doing anything with the Web Process's default storage session.

        * UIProcess/win/WebContextWin.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):
        Serialize the default storage session in the UI Process and add it to the
        WebProcessCreationParameters.

        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::cachedResponseForURL):
        Use the cache associated with the current storage session and make sure the request has the
        current storage session set on it before doing anything with it.

        * WebProcess/win/WebProcessWin.cpp:
        (WebKit::WebProcess::platformSetCacheModel):
        Use the default storage session.
        (WebKit::WebProcess::platformClearResourceCaches):
        Ditto.
        (WebKit::WebProcess::platformInitializeWebProcess):
        Deserialize the default storage session passed in by the UI Process and hand it to the
        ResourceHandle.

2011-05-11  Sam Weinig  <sam@webkit.org>

        Reviewed by Adam Roben.

        WebKit2 should tell app that is unresponsive in more cases
        <rdar://problem/9110151>
        https://bugs.webkit.org/show_bug.cgi?id=60608

        * UIProcess/DrawingAreaProxyImpl.cpp:
        (WebKit::DrawingAreaProxyImpl::didUpdateBackingStoreState):
        (WebKit::DrawingAreaProxyImpl::sendUpdateBackingStoreState):
        Invoke the responsiveness time when forcing a backing store update
        to catch the cases of activating tabs, resizing the window, etc.

2011-05-11  Martin Robinson  <mrobinson@igalia.com>

        Try to fix the WinCairo build.

        * Shared/ShareableBitmap.h: Correctly include RefPtrCairo here and
        guard it with USE(CAIRO) instead of PLATFORM(CAIRO).

2011-05-11  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.

        <https://bugs.webkit.org/show_bug.cgi?id=60631>
        <rdar://problem/9420520>
        
        WebKit2 doesn't clear the pendingAPIRequestURL on in-page anchor navigation [60631]

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didSameDocumentNavigationForFrame):
        Call clearPendingAPIRequestURL().

2011-05-11  Adam Roben  <aroben@apple.com>

        Turn on strict PassOwnPtr on Windows

        Fixes <http://webkit.org/b/60632> Windows should build with strict PassOwnPtr enabled

        Reviewed by Adam Barth.

        * WebProcess/FullScreen/win/WebFullScreenManagerWin.cpp:
        (WebKit::WebFullScreenManagerWin::setRootFullScreenLayer): Use nullptr instead of 0.

2011-05-11  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Darin Adler.

        [WebKit2] exceededDatabaseQuota function on WKPageUIClient needs to provide information
        about the usage for both the origin overall and the database in question.
        https://bugs.webkit.org/show_bug.cgi?id=60573

        Add the currentOriginUsage parameter.

        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC::callMemberFunction):
        * UIProcess/API/C/WKPage.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::exceededDatabaseQuota):
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * UIProcess/WebUIClient.cpp:
        (WebKit::WebUIClient::exceededDatabaseQuota):
        * UIProcess/WebUIClient.h:
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::exceededDatabaseQuota):

2011-05-10  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoffrey Garen.

        Assertion failure in JSC::Structure::typeInfo when reloading weather.com video page
        https://bugs.webkit.org/show_bug.cgi?id=60580

        The plugin object map was incorrect trying to implement a weak map itself using
        destructors.  Switch to a WeakGCMap and the problem is fixed.

        * WebProcess/Plugins/Netscape/JSNPObject.cpp:
        (WebKit::JSNPObject::~JSNPObject):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.cpp:
        (WebKit::NPRuntimeObjectMap::getOrCreateJSObject):
        (WebKit::NPRuntimeObjectMap::invalidate):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.h:

2011-05-10  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Yet more quarantine related sandbox denial when downloading files
        <rdar://problem/9397494>

        * WebProcess/com.apple.WebProcess.sb:

2011-05-10  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        WebKit2: Coalesced wheel events should be saved to hand back to the client on unhandled return
        https://bugs.webkit.org/show_bug.cgi?id=60584

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::handleWheelEvent):
        (WebKit::canCoalesce):
        (WebKit::coalesce):
        (WebKit::coalescedWheelEvent):
        (WebKit::WebPageProxy::didReceiveEvent):
        (WebKit::WebPageProxy::processDidCrash):
        Reworks coalescing/merging code to happen on didReceiveEvent rather than in
        handleWheelEvent. This means we now store the pending events in a queue, and
        pull them out when we can.

        * UIProcess/WebPageProxy.h:
        Change single event containers to contain all pending/merged/coalesced events
        and remove unused flag.

2011-05-09  Jeremy Noble  <jer.noble@apple.com>

        Reviewed by Darin Adler.

        WebKit2: Cancelling full screen before animation completes leads to full screen window staying up.
        https://bugs.webkit.org/show_bug.cgi?id=60531

        Remove the (unused) _isAnimating ivar and replace it with two ivars: _isEnteringFullScreen and 
        _isExitingFullScreen.  These will ensure each is only called once per full screen request, and
        that if one exit/enter request interrupts another, that the required functions are called in 
        order.

        * UIProcess/mac/WKFullScreenWindowController.h:
        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController enterFullScreen:]): Removed _isAnimating.
        (-[WKFullScreenWindowController exitFullScreen]): Ditto.
        (-[WKFullScreenWindowController beganEnterFullScreenAnimation]): Gate on _isEnteringFullScreen. Check _isExitingFullScreen
            and call [self finishedExitFullScreenAnimation:] if necessary.
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]): Gate on _isEnteringFullScreen.
        (-[WKFullScreenWindowController beganExitFullScreenAnimation]): Gate on _isExitingFullScreen. Check _isEnteringFullScreen
            and call [self finishedEnterFullScreenAnimation:] if necessary.
        (-[WKFullScreenWindowController finishedExitFullScreenAnimation:]): Gate on _isExitingFullScreen.

2011-05-10  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=60582
        Crash switching overlay/non-overlay scrollbar preference still possible
        -and corresponding-
        <rdar://problem/9323983>

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface):

2011-05-10  Jeff Miller  <jeffm@apple.com>

        Reviewed by Anders Carlsson.

        WebKit2: Windows clients need to know if the page overlay is installed
        https://bugs.webkit.org/show_bug.cgi?id=60562
        <rdar://problem/8940164>
        
        Until we move all the UI for find on page into WebKit on Windows (specifically, drawing the find bouncy),
        WebKit clients need to know whether WebKit is drawing the page overlay or not.  Keep track of this in
        the WebPageProxy in the UI process and provide a WebKit2 API to retrieve this information.

        * UIProcess/API/C/win/WKView.cpp:
        (WKViewIsPageOverlayInstalled): Added.
        * UIProcess/API/C/win/WKView.h: Added WKViewIsPageOverlayInstalled().
        
        * UIProcess/PageClient.h: Added didInstallOrUninstallPageOverlay().
        * UIProcess/WebPageProxy.h: Added didInstallOrUninstallPageOverlay().
        * UIProcess/WebPageProxy.messages.in: Added DidInstallOrUninstallPageOverlay.
        * UIProcess/win/WebPageProxyWin.cpp:
        (WebKit::WebPageProxy::didInstallOrUninstallPageOverlay): Added.
        
        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::WebView): Initialize m_pageOverlayInstalled.
        (WebKit::WebView::didInstallOrUninstallPageOverlay): Added.
        * UIProcess/win/WebView.h: Added didInstallOrUninstallPageOverlay() and m_pageOverlayInstalled.
        (WebKit::WebView::pageOverlayInstalled): Added.
        
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::installPageOverlay): Send message to UI process to tell it the page overlay is installed.
        (WebKit::WebPage::uninstallPageOverlay): Send message to UI process to tell it the page overlay is uninstalled.

2011-05-10  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam Roben.

        Remove incorrect ASSERTs from CoreIPC::Connection::processIncomingSyncReply
        https://bugs.webkit.org/show_bug.cgi?id=60567
        <rdar://problem/9377845>

        It is possible to receive an incoming sync reply that is for a request we don't know about.
        This could happen if the sync message send timed out for example.

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::processIncomingSyncReply):

2011-05-05  Brent Fulgham  <bfulgham@webkit.org> and Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Anders Carlsson.

        [Cairo][WebKit2] Add an implementation of ShareableBitmap for Cairo
        https://bugs.webkit.org/show_bug.cgi?id=60293

        * GNUmakefile.am: Remove ShareableBitmapGtk in favor of ShareableBitmapCairo.
        * Shared/ShareableBitmap.h: Added a couple Cairo-specific declarations.
        * Shared/cairo/ShareableBitmapCairo.cpp:
        (WebKit::ShareableBitmap::createGraphicsContext): Added.
        (WebKit::ShareableBitmap::paint): Added.
        (WebKit::ShareableBitmap::createCairoSurface): Added.
        (WebKit::ShareableBitmap::releaseSurfaceData): Added.

2011-05-10  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Extra sign in required to view video on MobileMe Gallery album
        https://bugs.webkit.org/show_bug.cgi?id=60560

        Implement NPN_GetAuthenticationInfo.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::getAuthenticationInfo):
        Send a GetAuthenticationInfo message to the web process.

        * PluginProcess/PluginControllerProxy.h:
        * WebProcess/Plugins/Netscape/NetscapeBrowserFuncs.cpp:
        (WebKit::initializeProtectionSpace):
        Initialize a WebCore::ProtectionSpace object from NPAPI parameters.

        (WebKit::NPN_GetAuthenticationInfo):
        Make a ProtectionSpace object and then call NetscapePlugin::getAuthenticationInfo. 
        Finally, copy the username/password and pass them back to the plug-in.

        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::getAuthenticationInfo):
        Call the plug-in controller.

        * WebProcess/Plugins/PluginController.h:
        Add getAuthenticationInfo pure virtual member function.

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::getAuthenticationInfo):
        Call the real plug-in controller's getAuthenticationInfo member function.

        * WebProcess/Plugins/PluginProxy.messages.in:
        Add GetAuthenticationInfo message.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::getAuthenticationInfo):
        Try to get the authentication info from the credential storage. Failing that,
        get it from the persistent credential storage.

2011-05-10  Adam Roben  <aroben@apple.com>

        Use FontSmoothingLevelWindows by default on Windows

        Fixes <http://webkit.org/b/60557> REGRESSION (r86077): Web Inspector uses CG font rendering
        in WebKit2 on Windows

        Reviewed by Darin Adler.

        * Shared/WebPreferencesStore.h: Added and deployed a new DEFAULT_WEBKIT_FONT_SMOOTHING_LEVEL
        macro to let Windows have a different default font smoothing level from other platforms.

        * UIProcess/API/C/WKPreferencesPrivate.h: Updated the comment about the default font
        smoothing level.

2011-05-06  Tony Gentilcore  <tonyg@chromium.org>

        Reviewed by Darin Adler.

        Fix some unnecessary includes in headers
        https://bugs.webkit.org/show_bug.cgi?id=60388

        * WebProcess/FullScreen/WebFullScreenManager.cpp:

2011-05-09  Jeremy Noble  <jer.noble@apple.com>

        Reviewed by Darin Adler.

        Command-~/Exposé to another window while <video> is in full screen, breaks Safari, eventually leading to crash
        https://bugs.webkit.org/show_bug.cgi?id=60496

        When animating into and out of full screen, order out and back in the original webView window,
        disabling animations when necessary. The beganExitFullScreenAnimation method was targeting the wrong window,
        as the webView is hosted in the full screen window when we ask for it's parent window.

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]):
        (-[WKFullScreenWindowController beganExitFullScreenAnimation]):

2011-05-09  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        A WKView with plug-ins paints white when first moved into a window
        https://bugs.webkit.org/show_bug.cgi?id=60511

        The UI process’s wait for DidUpdateBackingStoreState would always time out because the Web process
        was blocked on a synchronous message the UI process trying to get the connections for plug-ins in
        the view. This is avoided by deferring the call to Page::setCanStartMedia().

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage): Initialize the new m_setCanStartMediaTimer.
        (WebKit::WebPage::setCanStartMediaTimerFired): Added. Calls setCanStartMedia(true) when the timer
        fires.
        (WebKit::WebPage::setIsInWindow): When going out of a window, stop the timer. When going into a
        window, start it.
        * WebProcess/WebPage/WebPage.h:

2011-05-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Crash when sending a sync message to a crashed web process
        https://bugs.webkit.org/show_bug.cgi?id=60514
        <rdar://problem/9281270>

        Change WebProcessProxy::sendSync to return false if there's no connection.

        Audit all WebProcessProxy::sendSync call sites to initialize reply parameters.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::firstRectForCharacterInSelectedRange):
        (WebKit::WebPageProxy::getSelectedText):
        (WebKit::WebPageProxy::gestureWillBegin):
        * UIProcess/WebProcessProxy.h:
        (WebKit::WebProcessProxy::sendSync):
        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::insertText):
        (WebKit::WebPageProxy::getMarkedRange):
        (WebKit::WebPageProxy::getSelectedRange):
        (WebKit::WebPageProxy::characterIndexForPoint):
        (WebKit::WebPageProxy::executeKeypressCommands):
        (WebKit::WebPageProxy::writeSelectionToPasteboard):
        (WebKit::WebPageProxy::readSelectionFromPasteboard):

2011-05-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Create a plug-in's MIME types preferences plist if it doesn't exist.
        https://bugs.webkit.org/show_bug.cgi?id=57204
        <rdar://problem/9195048>

        Spawn a plug-in process and let it create the plist. For now, we'll do this on the
        main thread since it's a rare one-time computation and we have an API function,
        WKFrameCanShowMIMEType, which would have to block anyway.

        * PluginProcess/mac/PluginProcessMainMac.mm:
        (WebKit::PluginProcessMain):
        If -createPluginMIMETypesPreferences is one of the command line argument keys,
        the plug-in path will be the argument value. Call NetscapePluginModule::createPluginMIMETypesPreferences
        to create the preferences file and then exit.

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::contentsOfPropertyListAtURL):
        Move code to read a property list out into a helper function.

        (WebKit::getMIMETypesFromPluginBundle):
        If there's no property list file, try to create one.

        (WebKit::NetscapePluginModule::createPluginMIMETypesPreferences):
        Load the plug-in, find the BP_CreatePluginMIMETypesPreferences and call it.

        * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
        (WebKit::PluginProcessProxy::createPropertyListFile):
        Spawn a plug-in process and pass the -createPluginMIMETypesPreferences flag to it and then wait
        for it to exit.

2011-05-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Move EnvironmentVariables out into its own .cpp file
        https://bugs.webkit.org/show_bug.cgi?id=60507

        * UIProcess/Launcher/mac/EnvironmentVariables.cpp: Added.
        (WebKit::EnvironmentVariables::EnvironmentVariables):
        (WebKit::EnvironmentVariables::~EnvironmentVariables):
        (WebKit::EnvironmentVariables::set):
        (WebKit::EnvironmentVariables::get):
        (WebKit::EnvironmentVariables::appendValue):
        (WebKit::EnvironmentVariables::valueIfVariableHasName):
        (WebKit::EnvironmentVariables::createStringForVariable):
        (WebKit::EnvironmentVariables::copyEnvironmentVariables):
        * UIProcess/Launcher/mac/EnvironmentVariables.h: Added.
        (WebKit::EnvironmentVariables::environmentPointer):
        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        * WebKit2.xcodeproj/project.pbxproj:

2011-05-09  Adam Roben  <aroben@apple.com>

        Always set the font rendering mode based on preference values

        WebPage::platformInitialize and WebPage::platformPreferencesDidChange were fighting over the
        font rendering mode. The platformInitialize code predates preference-based font rendering
        mode support, and is now redundant and incorrect.

        Fixes <http://webkit.org/b/60494> WebKit2 uses GDI text instead of CG text when
        FontSmoothing preference is set to kWKFontSmoothingLevelNoSubpixelAntiAliasing in a .plist
        on disk

        Reviewed by Sam Weinig.

        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::WebPage::platformInitialize): Removed code to set the font rendering mode.
        platformPreferencesDidChange will take care of this for us.

2011-05-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by John Sullivan.

        Clean up NetscapePluginModule::getPluginInfo
        https://bugs.webkit.org/show_bug.cgi?id=60486

        Make all 'get' functions take a PluginInfoStore::Plugin reference, since getPluginInfoFromPropertyLists
        is going to need it to know the path and plug-in architecture.

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::getPluginArchitecture):
        (WebKit::getPluginInfoFromPropertyLists):
        (WebKit::getPluginInfoFromCarbonResources):
        (WebKit::NetscapePluginModule::getPluginInfo):

2011-05-09  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/9005982> REGRESSION (r85780): Flash of white when a WKView with composited content moves on-screen
        https://bugs.webkit.org/show_bug.cgi?id=60488

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::sendDidUpdateBackingStoreState): Update m_compositingAccordingToProxyMessages,
        since the DidUpdateBackingStoreState message also changes the compositing state in the proxy.

2011-05-09  Benjamin Poulain  <benjamin.poulain@nokia.com>

        Reviewed by Andreas Kling.

        Build fix for WebKit 2 on Qt

        Qt treats warnings as errors so it does not build with unused variables. This patch removed two unused variable in WebKit 2.

        * UIProcess/TiledDrawingAreaProxy.cpp:
        (WebKit::TiledDrawingAreaProxy::createTiles):
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::~PluginView):

2011-05-07  Dan Bernstein  <mitz@apple.com>

        Reviewed by Timothy Hatcher.

        <rdar://problem/9365358> REGRESSION (WebKit2): When clicking in the page, Find overlay fades out instead of disappearing immediately

        * WebProcess/WebPage/FindController.cpp:
        (WebKit::FindController::hideFindUI): Do not fade out the overlay.

2011-05-07  Dan Bernstein  <mitz@apple.com>

        Avoid copying a header file into the WebKit2 framework wrapper.

        * WebKit2.xcodeproj/project.pbxproj: Corrected the target membership of HTTPCookieAcceptPolicy.h.

2011-05-07  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r86016.
        http://trac.webkit.org/changeset/86016
        https://bugs.webkit.org/show_bug.cgi?id=60445

        caused crashes on the WK2 Windows bots (Requested by
        jessieberlin on #webkit).

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode):
        (WebKit::WebProcessCreationParameters::decode):
        * Shared/WebProcessCreationParameters.h:
        * Shared/win/WebCoreArgumentCodersWin.cpp:
        (CoreIPC::decodeResourceRequest):
        * UIProcess/win/WebContextWin.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):
        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::cachedResponseForURL):
        * WebProcess/win/WebProcessWin.cpp:
        (WebKit::WebProcess::platformSetCacheModel):
        (WebKit::WebProcess::platformClearResourceCaches):
        (WebKit::WebProcess::platformInitializeWebProcess):

2011-05-07  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Steve Falkenburg.

        [Windows WebKit2] Use cookies set in WebKit1
        https://bugs.webkit.org/show_bug.cgi?id=60274

        Share the default storage session between the UI and Web Processes.

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode):
        (WebKit::WebProcessCreationParameters::decode):
        * Shared/WebProcessCreationParameters.h:
        Add a parameter for a serialized default storage session, used only on Windows.

        * Shared/win/WebCoreArgumentCodersWin.cpp:
        (CoreIPC::decodeResourceRequest):
        Make sure to set the current storage session on any requests used by the Web
        Process before CFNetwork has to do anything with them, in order for CFNetwork to avoid
        doing anything with the Web Process's default storage session.

        * UIProcess/win/WebContextWin.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):
        Serialize the default storage session in the UI Process and add it to the
        WebProcessCreationParameters.

        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::cachedResponseForURL):
        Use the cache associated with the current storage session and make sure the request has the
        current storage session set on it before doing anything with it.

        * WebProcess/win/WebProcessWin.cpp:
        (WebKit::WebProcess::platformSetCacheModel):
        Use the default storage session.
        (WebKit::WebProcess::platformClearResourceCaches):
        Ditto.
        (WebKit::WebProcess::platformInitializeWebProcess):
        Deserialize the default storage session passed in by the UI Process and hand it to the
        ResourceHandle.

2011-05-07  Keith Kyzivat  <keith.kyzivat@nokia.com>

        Reviewed by Adam Roben.

        [Qt] Webkit2 PLUGIN_ARCHITECTURE(UNSUPPORTED) configuration broken by r85961
        https://bugs.webkit.org/show_bug.cgi?id=60420

        * WebProcess/Plugins/Netscape/NetscapePluginNone.cpp:
        (WebKit::NetscapePlugin::platformVisibilityDidChange):

2011-05-06  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] [WebKit2] WebView::windowToScreen needs an implementation
        https://bugs.webkit.org/show_bug.cgi?id=55960

        Add an implementation of PageClient::windowToScreen for GTK+ WebKit2 using
        the newly abstracted widget to screen coordinate translation code in WebCore.

        * UIProcess/API/gtk/PageClientImpl.cpp:
        (WebKit::PageClientImpl::windowToScreen): Added implementation.

2011-05-06  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Simplify the PluginInfoStore interface
        https://bugs.webkit.org/show_bug.cgi?id=60406

        Just expose a single API for getting a list of plug-ins from the info store,
        PluginInfoStore::plugins and remove PluginInfoStore::getPlugins and PluginInfoStore::getPluginPaths.

        Also, change the WebContext::pluginInfoStore() getter to return a reference.

        * UIProcess/Plugins/PluginInfoStore.cpp:
        (WebKit::PluginInfoStore::plugins):
        * UIProcess/Plugins/PluginInfoStore.h:
        * UIProcess/Plugins/PluginProcessManager.cpp:
        (WebKit::PluginProcessManager::getPluginProcessConnection):
        * UIProcess/Plugins/PluginProcessManager.h:
        * UIProcess/Plugins/WebPluginSiteDataManager.cpp:
        (WebKit::WebPluginSiteDataManager::GetSitesWithDataState::GetSitesWithDataState):
        (WebKit::WebPluginSiteDataManager::ClearSiteDataState::ClearSiteDataState):
        (WebKit::WebPluginSiteDataManager::getSitesWithData):
        (WebKit::WebPluginSiteDataManager::clearSiteData):
        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::getPlugins):
        (WebKit::WebContext::getPluginPath):
        * UIProcess/WebContext.h:
        (WebKit::WebContext::pluginInfoStore):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::canShowMIMEType):

2011-05-06  Anders Carlsson  <andersca@apple.com>

        Windows build fix.

        * UIProcess/Plugins/win/PluginInfoStoreWin.cpp:
        (WebKit::PluginInfoStore::shouldUsePlugin):

2011-05-06  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Make more PluginInfoStore member functions static
        https://bugs.webkit.org/show_bug.cgi?id=60401

        This is a first step towards making PluginInfoStore thread safe.

        * UIProcess/Plugins/PluginInfoStore.cpp:
        (WebKit::PluginInfoStore::loadPluginsIfNecessary):
        (WebKit::PluginInfoStore::loadPlugin):
        * UIProcess/Plugins/PluginInfoStore.h:
        * UIProcess/Plugins/mac/PluginInfoStoreMac.mm:
        (WebKit::PluginInfoStore::shouldUsePlugin):
        * UIProcess/Plugins/unix/PluginInfoStoreUnix.cpp:
        (WebKit::PluginInfoStore::shouldUsePlugin):
        * UIProcess/Plugins/win/PluginInfoStoreWin.cpp:
        (WebKit::PluginInfoStore::shouldUsePlugin):

2011-05-06  Adam Roben  <aroben@apple.com>

        Mac build fix

        * WebProcess/Plugins/Netscape/mac/NetscapePluginMac.mm: Added a
        missing #import.

2011-05-06  Adam Roben  <aroben@apple.com>

        Show/hide windowed plugins according to the plugin element's visibility CSS property

        Fixes <http://webkit.org/b/60285> <rdar://problem/9152400> REGRESSION (WebKit2): A white
        rectangle covers up important UI elements when composing a new message at mail.yahoo.com
        with BrowserPlus! plug-in installed

        Reviewed by Anders Carlsson.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::isPluginVisible):
        * PluginProcess/PluginControllerProxy.h:
        Stubbed out.

        * Shared/win/WindowGeometry.cpp:
        (WebKit::WindowGeometry::WindowGeometry):
        (WebKit::WindowGeometry::encode):
        (WebKit::WindowGeometry::decode):
        * Shared/win/WindowGeometry.h:
        Added visible member.

        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::updateChildWindowGeometries): Show or hide the window as specified in the
        geometry.

        * WebProcess/Plugins/Netscape/NetscapePlugin.cpp:
        (WebKit::NetscapePlugin::visibilityDidChange):
        * WebProcess/Plugins/Netscape/NetscapePlugin.h:
        Added. Calls through to platform-specific code.

        * WebProcess/Plugins/Netscape/mac/NetscapePluginMac.mm:
        (WebKit::NetscapePlugin::platformVisibilityDidChange):
        * WebProcess/Plugins/Netscape/x11/NetscapePluginX11.cpp:
        (WebKit::NetscapePlugin::platformVisibilityDidChange):
        Stubbed out.

        * WebProcess/Plugins/Netscape/win/NetscapePluginWin.cpp:
        (WebKit::NetscapePlugin::platformGeometryDidChange): Moved most logic from here to
        scheduleWindowedGeometryUpdate.
        (WebKit::NetscapePlugin::platformVisibilityDidChange): Added. Calls through to
        scheduleWindowedGeometryUpdate.
        (WebKit::NetscapePlugin::scheduleWindowedGeometryUpdate): Added. Code came from
        platformGeometryDidChange. Now also records whether the plugin element is visible.

        * WebProcess/Plugins/Plugin.h: Added visibilityDidChange.

        * WebProcess/Plugins/PluginController.h: Added isPluginVisible.

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::visibilityDidChange):
        * WebProcess/Plugins/PluginProxy.h:
        Stubbed out.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::show):
        (WebKit::PluginView::hide):
        Added. These Widget overrides were based on WebCore's PluginView class.

        (WebKit::PluginView::viewVisibilityDidChange): Added. Similar to viewGeometryDidChange.
        Calls down to the plugin if it's been initialized.
        (WebKit::PluginView::isPluginVisible): Added. Just calls up to the Widget base class.

        * WebProcess/Plugins/PluginView.h: Updated for PluginController changes.

2011-05-06  Adam Roben  <aroben@apple.com>

        Add a WindowGeometry struct for use in the ScheduleChildWindowGeometryUpdate message

        This will make it easier to add more info to this message in the future (like whether the
        window is visible).

        Fixes <http://webkit.org/b/60374> Adding parameters to ScheduleChildWindowGeometryUpdate
        message is tedious

        Reviewed by Anders Carlsson.

        * Scripts/webkit2/messages.py:
        (struct_or_class): Added WindowGeometry to the list of structs.

        * Shared/win/WindowGeometry.cpp: Added.
        * Shared/win/WindowGeometry.h: Added.

        * win/WebKit2.vcproj: Added new files.

        * UIProcess/PageClient.h:
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * UIProcess/win/WebPageProxyWin.cpp:
        (WebKit::WebPageProxy::scheduleChildWindowGeometryUpdate):
        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::scheduleChildWindowGeometryUpdate):
        (WebKit::WebView::updateChildWindowGeometries):
        * UIProcess/win/WebView.h:
        * WebProcess/Plugins/Netscape/win/NetscapePluginWin.cpp:
        (WebKit::NetscapePlugin::platformGeometryDidChange):
        * WebProcess/Plugins/PluginController.h:
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::scheduleWindowedPluginGeometryUpdate):
        * WebProcess/Plugins/PluginView.h:
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::WebPage::scheduleChildWindowGeometryUpdate):
        Changed to use WindowGeometry.

2011-05-06  David Kilzer  <ddkilzer@apple.com>

        Remove unused GCC_ENABLE_FIX_AND_CONTINUE and ZERO_LINK settings

        Reviewed by Jon Honeycutt.

        This fixes an Xcode 4 warning about using obsolete settings.

        * WebKit2.xcodeproj/project.pbxproj: Removed
        GCC_ENABLE_FIX_AND_CONTINUE and ZERO_LINK settings.

2011-05-06  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Implement NetscapePlugin::platformPaint for GTK platform
        https://bugs.webkit.org/show_bug.cgi?id=60368

        * WebProcess/Plugins/Netscape/x11/NetscapePluginX11.cpp:
        (WebKit::NetscapePlugin::platformPaint):

2011-05-06  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        Share PluginInfoStore implementation between Qt and GTK ports
        https://bugs.webkit.org/show_bug.cgi?id=60366

        * GNUmakefile.am:
        * UIProcess/Plugins/gtk/PluginInfoStoreGtk.cpp: Removed.
        * UIProcess/Plugins/unix/PluginInfoStoreUnix.cpp: Renamed from Source/WebKit2/UIProcess/Plugins/qt/PluginInfoStoreQt.cpp.
        (WebKit::PluginInfoStore::pluginsDirectories):
        (WebKit::PluginInfoStore::pluginPathsInDirectory):
        (WebKit::PluginInfoStore::individualPluginPaths):
        (WebKit::PluginInfoStore::getPluginInfo):
        (WebKit::PluginInfoStore::shouldUsePlugin):
        * WebKit2.pro:

2011-05-06  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix WebKit2 GTK build after r85860.

        * UIProcess/API/gtk/PageClientImpl.h: Fix typo.

2011-05-05  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Dimitri Glazkov.

        Implement LayoutTestController::pseudoShadowId()
        https://bugs.webkit.org/show_bug.cgi?id=60034

        * WebProcess/InjectedBundle/API/c/WKBundleNodeHandle.cpp:
        (WKBundleNodeHandleShadowPseudoId):
        * WebProcess/InjectedBundle/API/c/WKBundleNodeHandlePrivate.h:
        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp:
        (WebKit::InjectedBundleNodeHandle::elementRemoveShadowRoot):
        (WebKit::InjectedBundleNodeHandle::elementShadowPseudoId):
        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.h:

2011-05-05  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        REGRESSION (r85689): Unresponsive timer firing when closing background tabs
        <rdar://problem/9385988>
        https://bugs.webkit.org/show_bug.cgi?id=60325

        When calling WKPageTryClose(), if the page close succeeded, the notification to stop
        the responsiveness timer would be dropped because the page was closed by the time it
        got to the UIProcess.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::closePage):
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        Add parameter to closePage stipulating whether or not to stop the responsiveness timer.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::tryClose):
        (WebKit::WebPage::sendClose):
        Instead of sending a StopResponsivenessTimer message after sending the ClosePage message,
        add a bit to the ClosePage message.

2011-05-05  Dan Bernstein  <mitz@apple.com>

        Reviewed by Simon Fraser.

        WebKit2 part of <rdar://problem/9155590> Broken animation in iAd producer

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface): Initialize wkExecutableWasLinkedOnOrBeforeSnowLeopard.

2011-05-05  Keith Kyzivat  <keith.kyzivat@nokia.com>

        Reviewed by Laszlo Gombos.

        [Qt] [WK2] Add method to disable plugins under WK2
        https://bugs.webkit.org/show_bug.cgi?id=57796

        * config.h: Allow PLUGIN_ARCHITECTURE_UNSUPPORTED to be defined on build command line

2011-05-05  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        When an underlay surface is active, paint normal web contents in a transparency layer
        https://bugs.webkit.org/show_bug.cgi?id=60296

        In order for the page contents to correctly blend with the underlay, the page contents
        needs to be painted in a transparency layer.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::drawRect):

2011-05-05  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Timothy Hatcher.

        WebKit2: Docking Web Inspector doesn't respect maximum inspector size
        https://bugs.webkit.org/show_bug.cgi?id=60294
        <rdar://problem/9388518>
        
        Before we place the inspector and the inspected views, make sure that we have constrained the height
        of the docked inspector. Putting the code here covers both when the inspector is initially attached 
        and when a window with the docked inspector is resized.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::inspectedViewFrameDidChange): Constrain the height before laying out the views.
        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::onWebViewWindowPosChangingEvent): Ditto.

2011-05-05  Chang Shu  <cshu@webkit.org>

        Reviewed by Andreas Kling.

        [Qt][WK2] Support PageGroup in QGraphicsWKView/QWKPage constructors
        https://bugs.webkit.org/show_bug.cgi?id=59638

        Added private constructors for class QGraphicsWKView and QWKPage to support
        WKPageGroupRef.

        * UIProcess/API/qt/qgraphicswkview.cpp:
        (QGraphicsWKView::QGraphicsWKView):
        (QGraphicsWKView::~QGraphicsWKView):
        (QGraphicsWKView::init):
        * UIProcess/API/qt/qgraphicswkview.h:
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPagePrivate::QWKPagePrivate):
        (QWKPage::QWKPage):
        (QWKPage::~QWKPage):
        (QWKPage::init):
        * UIProcess/API/qt/qwkpage.h:
        * UIProcess/API/qt/qwkpage_p.h:

2011-05-05  Brent Fulgham  <bfulgham@webkit.org>

        [WinCairo] Unreviewed build fix.

        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::WebPage::cachedResponseDataForURL): Stub out
        implementation for cURL networking case.

2011-05-05  Jeff Miller  <jeffm@apple.com>

        Reviewed by Darin Adler.

        Add didNotHandleWheelEvent callback to WKPageUIClient
        https://bugs.webkit.org/show_bug.cgi?id=60203
        
        Remove Windows-specific WebPageProxy::wheelEventNotHandled() member function and use
        didNotHandleWheelEvent callback in WKPageUIClient instead.  It turns out that just
        resending the wheel event to the parent window doesn't provide the client with enough context
        to know that WebKit has already attempted to handle the event.

        * UIProcess/API/C/WKPage.h: Added WKPageDidNotHandleWheelEventCallback typedef and didNotHandleWheelEvent to WKPageUIClient.

        * UIProcess/API/gtk/PageClientImpl.cpp:
        (WebKit::PageClientImpl::didNotHandleWheelEvent): Added, but not implemented.
        * UIProcess/API/gtk/PageClientImpl.h: Added didNotHandleWheelEvent().
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPage::QWKPage):Stubbed out didNotHandleWheelEvent callback.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didReceiveEvent): Call didNotHandleWheelEvent in WKPageUIClient if wheel event is not handled.
        * UIProcess/WebPageProxy.h: Removed wheelEventNotHandled().
        
        * UIProcess/WebUIClient.cpp:
        (WebKit::WebUIClient::implementsDidNotHandleWheelEvent): Added.
        (WebKit::WebUIClient::didNotHandleWheelEvent): Added.
        * UIProcess/WebUIClient.h: Added implementsDidNotHandleWheelEvent() and didNotHandleWheelEvent().

        * UIProcess/win/WebPageProxyWin.cpp: Removed wheelEventNotHandled().

2011-05-05  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Return correct GTK version for NPNVToolkit
        https://bugs.webkit.org/show_bug.cgi?id=60275

        * WebProcess/Plugins/Netscape/NetscapeBrowserFuncs.cpp:
        (WebKit::NPN_GetValue): Return always 2 for NPNVToolkit in GTK
        platform.

2011-05-05  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Make native events code more consistent
        https://bugs.webkit.org/show_bug.cgi?id=60258

        Make all other native events code follow the current keyboard
        events approach: use a GOwnPtr for the native event, and use
        const GdkEvent* in the API. We need to implement the copy
        constructors for native events to copy the gdk events with
        gdk_event_copy().

        * Shared/NativeWebMouseEvent.h:
        (WebKit::NativeWebMouseEvent::nativeEvent):
        * Shared/NativeWebWheelEvent.h:
        (WebKit::NativeWebWheelEvent::nativeEvent):
        * Shared/gtk/NativeWebKeyboardEventGtk.cpp:
        (WebKit::NativeWebKeyboardEvent::NativeWebKeyboardEvent):
        * Shared/gtk/NativeWebMouseEventGtk.cpp:
        (WebKit::NativeWebMouseEvent::NativeWebMouseEvent):
        * Shared/gtk/NativeWebWheelEventGtk.cpp:
        (WebKit::NativeWebWheelEvent::NativeWebWheelEvent):
        * Shared/gtk/WebEventFactory.cpp:
        (WebKit::buttonForEvent):
        (WebKit::WebEventFactory::createWebMouseEvent):
        (WebKit::WebEventFactory::createWebWheelEvent):
        (WebKit::WebEventFactory::createWebKeyboardEvent):
        * Shared/gtk/WebEventFactory.h:
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseScrollEvent):

2011-05-05  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Module::load() should return true when g_module_open() returns a valid pointer
        https://bugs.webkit.org/show_bug.cgi?id=60261

        * Platform/gtk/ModuleGtk.cpp:
        (WebKit::Module::load):

2011-05-05  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix WebKit2 GTK build after r85808.

        * Shared/NativeWebWheelEvent.h:
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseScrollEvent):

2011-05-04  Cris Neckar  <cdn@chromium.org>

        Reviewed by Adam Barth.

        Expose WebView directly through ChromeClient.
        https://bugs.webkit.org/show_bug.cgi?id=49902

        * WebProcess/WebCoreSupport/WebChromeClient.h:
        (WebKit::WebChromeClient::webView):

2011-05-04  Jeff Miller  <jeffm@apple.com>

        Reviewed by Darin Adler.

        Send unhandled wheel events to parent window on Windows
        https://bugs.webkit.org/show_bug.cgi?id=60220

        Keep track of wheel events using NativeWebWheelEvent instead of WebWheelEvent in WebPageProxy
        so we can send the native event to the parent window if WebKit doesn't handle it.

        * UIProcess/API/mac/WKView.mm: Use NativeWebWheelEvent instead of WebWheelEvent.

        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPagePrivate::wheelEvent): Use NativeWebWheelEvent instead of WebWheelEvent.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::WebPageProxy): Removed initialization of obsolete m_processingWheelEvent member variable.
        (WebKit::coalesceWheelEvents): Use NativeWebWheelEvent instead of WebWheelEvent and add a note that this won't work if we ever enable MERGE_WHEEL_EVENTS. 
        (WebKit::WebPageProxy::handleWheelEvent): Use NativeWebWheelEvent instead of WebWheelEvent, keep track of the current event in m_currentlyProcessedWheelEvent.
        (WebKit::WebPageProxy::didReceiveEvent): Call wheelEventNotHandled() on Windows if wheel event is not handled.
        (WebKit::WebPageProxy::processDidCrash): Clear out m_currentlyProcessedWheelEvent.
        * UIProcess/WebPageProxy.h: Change handleWheelEvent() to take a NativeWebWheelEvent, added wheelEventNotHandled() on Windows, remove m_processingWheelEvent, add m_currentlyProcessedWheelEvent.

        * UIProcess/win/WebPageProxyWin.cpp:
        (WebKit::WebPageProxy::wheelEventNotHandled): Added.
        
        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::onWheelEvent): Use NativeWebWheelEvent instead of WebWheelEvent.

2011-05-04  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        Add bundle API for making a page paint as the background of another page
        https://bugs.webkit.org/show_bug.cgi?id=60227

        * WebProcess/InjectedBundle/API/c/WKBundlePage.cpp:
        (WKBundlePageSetUnderlayPage):
        Call WebPage::setUnderlayPage.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::close):
        Null out the underlay page.

        (WebKit::WebPage::layoutIfNeeded):
        Layout the underlay page if necessary.

        (WebKit::WebPage::drawRect):
        Draw the underlay page.

2011-05-04  Siddharth Mathur  <siddharth.mathur@nokia.com>

        Reviewed by Laszlo Gombos.

        [Qt][Wk2][Symbian] Capabilities for Qt MiniBrowser and QtWebProcess on Symbian
        https://bugs.webkit.org/show_bug.cgi?id=59462

        * WebProcess.pro: Add Symbian OS capabilities to web process executable. Also enable
        data paging flag and prevent application's icon from showing up in the application grid. 

2011-05-04  Adam Roben  <aroben@apple.com>

        Clip and reposition windowed plugins when the UI process paints

        This ensures that their geometry updates in sync with the rest of the page.

        Most of this patch is just plumbing the scheduleWindowedPluginGeometryUpdate and
        scheduleChildWindowGeometryUpdate calls through from NetscapePlugin all the way over to
        WebView. I've tried to call out the other parts below.

        Fixes <http://webkit.org/b/60210> <rdar://problem/8483441> REGRESSION (WebKit2): Windowed
        plugins don't scroll at the same speed as the rest of the page

        Reviewed by Darin Adler and Anders Carlsson.

        * UIProcess/PageClient.h:
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * UIProcess/win/WebPageProxyWin.cpp:
        (WebKit::WebPageProxy::scheduleChildWindowGeometryUpdate):
        Added plumbing.

        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::onPaintEvent): Update child windows before painting so that they will stay
        in sync with the rest of the page.
        (WebKit::WebView::scheduleChildWindowGeometryUpdate): Add this update information to the
        set of geometries to update on the next paint.
        (WebKit::setWindowRegion): Moved this helper function here from NetscapePluginWin.cpp.
        (WebKit::WebView::updateChildWindowGeometries): Update the size, position, and clip rects of
        all the child windows with scheduled geometry updates.

        * UIProcess/win/WebView.h: Added new members to track and update child window geometries.

        * WebProcess/Plugins/Netscape/win/NetscapePluginWin.cpp:
        (WebKit::NetscapePlugin::platformPostInitialize): Don't show the window immediately. Let the
        UI process take care of it.
        (WebKit::NetscapePlugin::platformGeometryDidChange): Don't update the window's position or
        clip rect. Let the UI process take care of it.

        * WebProcess/Plugins/PluginController.h:
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::scheduleWindowedPluginGeometryUpdate):
        * WebProcess/Plugins/PluginView.h:
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::WebPage::scheduleChildWindowGeometryUpdate):
        Added plumbing.

2011-05-04  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam Roben.

        WKView on Windows has no equivalent of Mac's -[WKView setDraws[Transparent]Background:]
        https://bugs.webkit.org/show_bug.cgi?id=52009
        <rdar://problem/8829746>

        Add and implement WKViewSetDrawsTransparentBackground on windows.

        * UIProcess/API/C/win/WKView.cpp:
        (WKViewSetDrawsTransparentBackground):
        (WKViewDrawsTransparentBackground):
        Call through to the WebPageProxy object.

        * UIProcess/API/C/win/WKView.h:
        * UIProcess/win/WebView.cpp:
        (WebKit::drawPageBackground):
        Don't fill the rect with white if WebPageProxy::drawsBackground() or 
        WebPageProxy::drawsTransparentBackground() returns false. Because of limitations in Win32,
        both drawsBackground and drawsTransparentBackground are pretty much equivalent.

        (WebKit::WebView::paint):
        Pass the WebPageProxy object to drawPageBackground.

2011-05-04  Tao Bai  <michaelbai@chromium.org>

        Reviewed by David Kilzer.

        Populate touch-icon url to FrameLoaderClient
        https://bugs.webkit.org/show_bug.cgi?id=59143

        Respected the change of FrameLoaderClient.
        Added WebIconURL and WebIconType responding the new IconURL and IconType.
        Supported to get the multiple icon urls.

        * Configurations/FeatureDefines.xcconfig:
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::dispatchDidChangeIcons):
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.h:

2011-05-04  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Can't save a link from "Save Linked File to Download" popup menu
        https://bugs.webkit.org/show_bug.cgi?id=60190
        <rdar://problem/9367927>

        Make sure that suggestedFilenameForResourceWithURL and resourceDataForFrame both look
        in the cache if the resource can't be found in the current web page. This matches WebKit1.

        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::suggestedFilenameForResourceWithURL):
        Call WebPage::cachedSuggestedFilenameForURL if we can't find a resource in the page.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::resourceDataForFrame):
        Move code out from getResourceDataFromFrame.

        (WebKit::WebPage::getResourceDataFromFrame):
        Call resourceDataForFrame first and then cachedResponseDataForURL.

        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/gtk/WebPageGtk.cpp:
        (WebKit::WebPage::platformHasLocalDataForURL):
        (WebKit::WebPage::cachedResponseMIMETypeForURL):
        (WebKit::WebPage::platformCanHandleRequest):
        (WebKit::WebPage::cachedSuggestedFilenameForURL):
        (WebKit::WebPage::cachedResponseDataForURL):
        Add stubs.

        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::cachedResponseForURL):
        Add helper function.

        (WebKit::WebPage::cachedSuggestedFilenameForURL):
        (WebKit::WebPage::cachedResponseMIMETypeForURL):
        (WebKit::WebPage::cachedResponseDataForURL):
        Call helper function.

        * WebProcess/WebPage/qt/WebPageQt.cpp:
        (WebKit::WebPage::platformHasLocalDataForURL):
        (WebKit::WebPage::cachedResponseMIMETypeForURL):
        (WebKit::WebPage::platformCanHandleRequest):
        (WebKit::WebPage::cachedSuggestedFilenameForURL):
        (WebKit::WebPage::cachedResponseDataForURL):
        Add stubs.
        
        * WebProcess/WebPage/win/WebPageWin.cpp:
        (WebKit::cachedResponseForURL):
        Add helper function.

        (WebKit::WebPage::platformHasLocalDataForURL):
        (WebKit::WebPage::cachedResponseMIMETypeForURL):
        (WebKit::WebPage::cachedSuggestedFilenameForURL):
        (WebKit::WebPage::cachedResponseDataForURL):
        Call helper function.

2011-05-04  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Anders Carlsson.

        WebKit2 flashes if entering and exiting compositing rapidly
        https://bugs.webkit.org/show_bug.cgi?id=60198
        
        If a page enters then immediately leaves compositing mode, the
        DrawingAreaImpl would send a message to the UI process that it
        had entered compositing even after all the layers had been torn
        down. Fix this by never sending the 'enter' message if we're
        waiting for the 'exit' timer to fire.
        
        Also fix an assertion in the UI process caused by sending mismatched
        'enter' and 'leave' messages by keeping track of which messages
        we've sent.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::DrawingAreaImpl):
        (WebKit::DrawingAreaImpl::layerHostDidFlushLayers):
        (WebKit::DrawingAreaImpl::exitAcceleratedCompositingMode):
        (WebKit::DrawingAreaImpl::exitAcceleratedCompositingModeSoon):
        * WebProcess/WebPage/DrawingAreaImpl.h:
        (WebKit::DrawingAreaImpl::exitAcceleratedCompositingModePending):

2011-05-04  Jeff Miller  <jeffm@apple.com>

        Fix typo in svn property in r85756.

        * Shared/mac/NativeWebWheelEventMac.mm: Added property svn:eol-style. Removed property snv:eol-style.

2011-05-04  Jeff Miller  <jeffm@apple.com>

        Reviewed by Darin Adler.

        Add NativeWebWheelEvent class
        https://bugs.webkit.org/show_bug.cgi?id=60182
        
        This will be needed soon when we start notifying the UI process that a mouse wheel event wasn't handled by WebKit.

        * GNUmakefile.am: Added NativeWebWheelEventGtk.cpp and NativeWebWheelEvent.h.
        * Shared/NativeWebWheelEvent.h: Added.
        (WebKit::NativeWebWheelEvent::nativeEvent): Added.
        * Shared/gtk/NativeWebWheelEventGtk.cpp: Added.
        (WebKit::NativeWebWheelEvent::NativeWebWheelEvent): Added.
        * Shared/mac/NativeWebWheelEventMac.mm: Added.
        (WebKit::NativeWebWheelEvent::NativeWebWheelEvent): Added.
        * Shared/qt/NativeWebWheelEventQt.cpp: Added.
        (WebKit::NativeWebWheelEvent::NativeWebWheelEvent): Added.
        * Shared/win/NativeWebWheelEventWin.cpp: Added.
        (WebKit::NativeWebWheelEvent::NativeWebWheelEvent):Added.
        * WebKit2.pro: Added NativeWebWheelEventQt.cpp and NativeWebWheelEvent.h.
        * WebKit2.xcodeproj/project.pbxproj: Added NativeWebWheelEventMac.mm and NativeWebWheelEvent.h.
        * win/WebKit2.vcproj: Added NativeWebWheelEventWin.cpp and NativeWebWheelEvent.h.

2011-05-04  Siddharth Mathur  <siddharth.mathur@nokia.com>

        Reviewed by Anders Carlsson.

        ArgumentDecoder should use aligned memory for its internal copy of data
        https://bugs.webkit.org/show_bug.cgi?id=59960 

        Since we check for memory alignment when unpacking primitive types from the buffer,
        insure alignment of the base address.
        As uint64_t is the largest type we use in Argument encoder/decoder, use 8 byte alignment. 

        * Platform/CoreIPC/ArgumentDecoder.cpp:
        (CoreIPC::ArgumentDecoder::~ArgumentDecoder): free m_alignedBase
        (CoreIPC::roundUpToAlignment): move this up in the source file
        (CoreIPC::ArgumentDecoder::initialize): m_buffer is now guaranteed sizeof(uint64_t) aligned
        * Platform/CoreIPC/ArgumentDecoder.h: add m_alignedBase member which needs to be freed in d'tor

2011-05-04  Adam Roben  <aroben@apple.com>

        Make ShareableBitmap::makeCGImageCopy use a copy-on-write copy on Windows when possible

        Fixes <http://webkit.org/b/57269> <rdar://problem/9198788> REGRESSION (r82151): Every WKView
        paint now makes an extra copy of the painted bits

        Reviewed by Anders Carlsson.

        * Platform/SharedMemory.h:
        * Platform/win/SharedMemoryWin.cpp:
        (WebKit::SharedMemory::createCopyOnWriteCopy):
        Added this new function. Creates a copy-on-write copy of the first |size| bytes of the
        original SharedMemory.

        * Shared/ShareableBitmap.h: Added createCGImage helper function.

        * Shared/cg/ShareableBitmapCG.cpp:
        (WebKit::ShareableBitmap::makeCGImageCopy): Don't compile this version of this function on
        Windows; we'll provide our own implementation since CGBitmapContextCreateImage isn't smart
        enough to make a copy-on-write copy on Windows.
        (WebKit::ShareableBitmap::makeCGImage): Moved some code from here...
        (WebKit::ShareableBitmap::createCGImage): ...to this new function.

        * Shared/cg/win/ShareableBitmapCGWin.cpp: Added.
        (WebKit::derefSharedMemory): This function is called when the CGDataProvider is finalized.
        All we have to do is deref the SharedMemory that was backing the CGDataProvider.
        (WebKit::ShareableBitmap::makeCGImageCopy): Create a copy-on-write copy of the image data
        when possible. We use the copy-on-write copy to back this ShareableBitmap from here on out,
        and use the original SharedMemory to back the CGImage. This should prevent future
        modifications to the ShareableBitmap from affecting the CGImage. If we can't make a
        copy-on-write copy, we fall back to just copying the data normally.

        * win/WebKit2.vcproj: Added ShareableBitmapCGWin.cpp.

2011-05-04  Adam Roben  <aroben@apple.com>

        Let transparent windowless plugins draw into a graphics context with an alpha channel

        Fixes <http://webkit.org/b/57647> <rdar://problem/9168462> Flash plugins with
        wmode=transparent have black (instead of transparent) background in WebKit2 on Windows

        I had trouble writing a test case for this, so I split that task out into
        <http://webkit.org/b/60169>.

        Reviewed by Sam Weinig.

        * WebProcess/Plugins/Netscape/win/NetscapePluginWin.cpp:
        (WebKit::NetscapePlugin::platformPaint): Give the graphics context an alpha channel if this
        is a transparent windowless plugin.

2011-05-03  Adam Roben  <aroben@apple.com>

        Remove WebPageProxy::setDrawingArea

        It is unused. It also does a useless equality comparison between OwnPtrs; if they are equal,
        we've already lost.

        Reviewed by Anders Carlsson and Antti Koivisto.

        * UIProcess/WebPageProxy.cpp:
        * UIProcess/WebPageProxy.h:
        Removed setDrawingArea.

        (WebKit::WebPageProxy::drawingArea):
        (WebKit::WebPageProxy::backForwardList):
        Made these functions const while I was at it.

2011-05-03  Pratik Solanki  <psolanki@apple.com>

        Reviewed by Antti Koivisto.

        Part of WebCore should use CFNetwork-based loader on Mac
        https://bugs.webkit.org/show_bug.cgi?id=51836

        Merge the conflicting definitions of WebCore::privateBrowsingCookieStorage() into one.

        * WebProcess/Cookies/cf/WebCookieManagerCFNet.cpp:
        (WebKit::WebCookieManager::platformSetHTTPCookieAcceptPolicy):

2011-05-02  Jer Noble  <jer.noble@apple.com>

        Reviewed by Adam Roben.

        Implement FULLSCREEN_API on Windows, Part 3: WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=59845

        Implement a similar full screen mode to WebKit; Re-use the same
        full screen window class used in WebKit in the new WebFullScreenController.
        No animations (yet), so many of the stubs remain unimplemented.

        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::onKeyEvent): Handle VK_ESCAPE and cancel full screen
            mode if caught.
        (WebKit::WebView::fullScreenController): Lazily instantiate m_fullScreenController.
        (WebKit::WebView::fullScreenClientWindow): Added accessor.
        (WebKit::WebView::fullScreenClientParentWindow): Ditto.
        (WebKit::WebView::fullScreenClientSetParentWindow): Ditto.
        (WebKit::WebView::fullScreenClientWillEnterFullScreen): Pass through to WebFullScreenManagerProxy.
        (WebKit::WebView::fullScreenClientDidEnterFullScreen): Ditto.
        (WebKit::WebView::fullScreenClientWillExitFullScreen): Ditto.
        (WebKit::WebView::fullScreenClientDidExitFullScreen): Ditto.
        * UIProcess/win/WebView.h:
        * UIProcess/win/WebFullScreenManagerProxyWin.cpp:
        (WebKit::WebFullScreenManagerProxy::enterFullScreen): Pass through to 
            WebFullScreenController.
        (WebKit::WebFullScreenManagerProxy::exitFullScreen): Ditto.
        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::WebView):
        (WebKit::WebView::onKeyEvent): Handle the escape key and exit
           full screen mode when detected.
        (WebKit::WebView::fullScreenWindowController): Added.
        * UIProcess/win/WebView.h:
        * WebProcess/FullScreen/win/WebFullScreenManagerWin.cpp:
        (WebKit::WebFullScreenManagerWin::~WebFullScreenManagerWin):
        (WebKit::WebFullScreenManagerWin::setRootFullScreenLayer): Host the root
            full screen layer if it gets detached.
        * WebProcess/FullScreen/win/WebFullScreenManagerWin.h:
        * win/WebKit2.vcproj:

2011-05-03  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=60087 and <rdar://problem/9373182>
        WK2 Icon Database should provide access to all image representations in the icon.

        Expose a CFArrayRef of CGImageRefs as API for CG platforms:
        * UIProcess/API/C/cg/WKIconDatabaseCG.cpp:
        (WKIconDatabaseTryCopyCGImageArrayForURL):
        * UIProcess/API/C/cg/WKIconDatabaseCG.h:

2011-05-03  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        WebKit2 should treat API calls that start/stop loads as user gestures for responsiveness timer
        https://bugs.webkit.org/show_bug.cgi?id=60083

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::reattachToWebProcessWithItem):
        (WebKit::WebPageProxy::tryClose):
        (WebKit::WebPageProxy::loadURL):
        (WebKit::WebPageProxy::loadURLRequest):
        (WebKit::WebPageProxy::loadHTMLString):
        (WebKit::WebPageProxy::loadAlternateHTMLString):
        (WebKit::WebPageProxy::loadPlainTextString):
        (WebKit::WebPageProxy::stopLoading):
        (WebKit::WebPageProxy::reload):
        (WebKit::WebPageProxy::goForward):
        (WebKit::WebPageProxy::goBack):
        (WebKit::WebPageProxy::goToBackForwardItem):
        Start responsiveness timer for load start/stop and close.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::SendStopResponsivenessTimer::SendStopResponsivenessTimer):
        (WebKit::SendStopResponsivenessTimer::~SendStopResponsivenessTimer):
        Add simple RAII class to ensure the StopResponsivenessTimer is called.

        (WebKit::WebPage::tryClose):
        (WebKit::WebPage::loadURLRequest):
        (WebKit::WebPage::loadData):
        (WebKit::WebPage::stopLoading):
        (WebKit::WebPage::reload):
        (WebKit::WebPage::goForward):
        (WebKit::WebPage::goBack):
        (WebKit::WebPage::goToBackForwardItem):
        Sends a message back to the UIProcess to indicate the WebProcess
        is still responsive.

2011-05-03  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/9250444> Enter key doesn't work in a web text field (but Return key does)

        No test at this time because the WebKit2 eventSender doesn't use this code path.

        * Shared/mac/WebEventFactory.mm:
        (WebKit::WebEventFactory::createWebKeyboardEvent): Copied the code to special-case certain
        keys from the corresponding Mac WebKit1 code path.

2011-05-03  Jeff Miller  <jeffm@apple.com>

        Reviewed by Darin Adler.

        Unreachable URL is lost when canceling load of a new page
        https://bugs.webkit.org/show_bug.cgi?id=60057
        <rdar://problem/9049135>
        
        When setting the unreachable URL in the WebFrameProxy, keep track of any previous unreachable URL
        so we can restore it if the page load fails.

        * UIProcess/WebFrameProxy.cpp:
        (WebKit::WebFrameProxy::didFailProvisionalLoad): Restore m_unreachableURL to previous value.
        (WebKit::WebFrameProxy::setUnreachableURL): Keep track of previous unreachable URL in m_lastUnreachableURL.
        * UIProcess/WebFrameProxy.h: Moved setUnreachableURL() implementation to .cpp file, added m_lastUnreachableURL.

2011-05-03  Adam Roben  <aroben@apple.com>

        Fix most strict PassOwnPtr violations on Windows

        Fixes <http://webkit.org/b/60025> Windows should (almost) build with strict PassOwnPtr
        enabled

        Reviewed by Anders Carlsson.

        * Platform/CoreIPC/win/ConnectionWin.cpp:
        (CoreIPC::Connection::writeEventHandler): Use nullptr.

2011-05-03  Julien Chaffraix  <jchaffraix@codeaurora.org>

        Reviewed by Dimitri Glazkov.

        Element:shadowRoot & Element::ensureShadowRoot should return ShadowRoot*
        https://bugs.webkit.org/show_bug.cgi?id=58703

        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp: Added #include for ShadowRoot.h.

2011-05-03  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        More quarantine related sandbox denial when downloading files
        <rdar://problem/9362626>

        * WebProcess/com.apple.WebProcess.sb:

2011-05-02  Adam Roben  <aroben@apple.com>

        Take advantage of implicit conversion from nullptr_t to PassOwnPtr

        Fixes <http://webkit.org/b/59964> Implicit conversion from std::nullptr_t to PassOwnPtr
        doesn't work, but should

        Reviewed by Adam Barth.

        * Platform/CoreIPC/Connection.cpp:
        * UIProcess/qt/WebContextMenuProxyQt.cpp:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        * WebProcess/WebPage/DrawingArea.cpp:

2011-05-03  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Eric Seidel.

        [GTK] Build webkit1 even when webkit2 is enabled
        https://bugs.webkit.org/show_bug.cgi?id=59695

        * GNUmakefile.am:

2011-05-02  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Andreas Kling.

        [Qt] White screen displays when using MiniBrowser with DrawingAreaImpl
        https://bugs.webkit.org/show_bug.cgi?id=60003

        When using DrawingAreaImpl, we need to properly pass the viewSize to the WebPage.
        Otherwise, the dirty rect will always be empty and we will not draw.

        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPagePrivate::viewSize):

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Fix crash that was introduced in r85515.

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::dispatchSyncMessage):
        If didReceiveSyncMessage returns ManualReply, the client took ownership of the reply
        encoder so we must leak it to avoid a double-free.

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        The web process locks up when the plug-in process crashes
        https://bugs.webkit.org/show_bug.cgi?id=59999
        <rdar://problem/8889303>

        Add a hash map from plug-in paths to CoreIPC connections to PluginProcessConnectionManager.
        Add PluginProcessConnectionManager::pluginProcessCrashed and make it look up the corresponding
        CoreIPC connection and call postConnectionDidCloseOnConnectionWorkQueue on it.

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::postConnectionDidCloseOnConnectionWorkQueue):
        * Platform/CoreIPC/Connection.h:
        * WebProcess/Plugins/PluginProcessConnectionManager.cpp:
        (WebKit::PluginProcessConnectionManager::getPluginProcessConnection):
        (WebKit::PluginProcessConnectionManager::removePluginProcessConnection):
        (WebKit::PluginProcessConnectionManager::pluginProcessCrashed):
        * WebProcess/Plugins/PluginProcessConnectionManager.h:
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::pluginProcessCrashed):

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Try to fix Windows build.

        * Scripts/webkit2/messages.py:
        * Scripts/webkit2/messages_unittest.py:

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        Dispatch the PluginProcessCrashed on the connection work queue
        https://bugs.webkit.org/show_bug.cgi?id=59996

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::initialize):
        Add the web process as a queue client.

        (WebKit::WebProcess::terminate):
        Remove the web process as a queue client.

        (WebKit::WebProcess::willProcessMessageOnClientRunLoop):
        Try calling willProcessWebProcessMessageOnClientRunLoop.

        * WebProcess/WebProcess.messages.in:
        Add the DispatchOnConnectionQueue attribute to PluginProcessCrashed.

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Send a PluginProcessCrashed message to all web processes when a plug-in crashes
        https://bugs.webkit.org/show_bug.cgi?id=59994

        * UIProcess/Plugins/PluginProcessProxy.cpp:
        (WebKit::PluginProcessProxy::didClose):
        Iterate over all contexts and send PluginProcessCrashed to all web processes in each context.

        (WebKit::PluginProcessProxy::didFinishLaunching):
        Call setShouldCloseConnectionOnMachExceptions on the CoreIPC connection.

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::pluginProcessCrashed):
        Add empty stub.

        * WebProcess/WebProcess.messages.in:
        Add message.

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Simon Fraser.

        Plug-in not completely repainted after a crash
        https://bugs.webkit.org/show_bug.cgi?id=59991

        Call Widget::invalidate().

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::pluginProcessCrashed):

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Make PluginProcessConnectionManager a member of WebProcess
        https://bugs.webkit.org/show_bug.cgi?id=59989

        * WebProcess/Plugins/PluginProcessConnectionManager.cpp:
        * WebProcess/Plugins/PluginProcessConnectionManager.h:
        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::initialize):
        * WebProcess/WebProcess.h:
        (WebKit::WebProcess::pluginProcessConnectionManager):

2011-05-02  Mark Rowe  <mrowe@apple.com>

        Reviewed by Brady Eidson.

        <rdar://problem/9371289> WebKit2 can persist an invalid current back/forward item index when URLs are filtered from back/forward list

        * UIProcess/cf/WebBackForwardListCF.cpp:
        (WebKit::WebBackForwardList::createCFDictionaryRepresentation): We need to update the current index to account for filtered items
        for all items before the current item in the array.

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam Roben.

        Handle DispatchOnConnectionQueue for asynchronous messages
        https://bugs.webkit.org/show_bug.cgi?id=59959

        If any asynchronous messages have the DispatchOnConnectionQueue attribute, 
        create a new willProcess{Receiver}MessageOnClientRunLoop.

        * Scripts/webkit2/messages.py:
        - Fix a regex bug where we would only parse attributes on synchronous messages.
        - Collect messages with the dispatch_on_connection_queue flag set. We only handle
          asynchronous messages currently; sync message support will be added when/if the
          need arises.

        * Scripts/webkit2/messages_unittest.py:
        Update test.

2011-05-02  Adam Barth  <abarth@webkit.org>

        Reviewed by David Levin.

        PLATFORM(MAC) should (almost!) build with strict PassOwnPtr
        https://bugs.webkit.org/show_bug.cgi?id=59924

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::sendSyncMessage):
        (CoreIPC::Connection::waitForSyncReply):
        (CoreIPC::Connection::dispatchSyncMessage):
        * Platform/CoreIPC/Connection.h:
        (CoreIPC::Connection::Message::releaseArguments):
            - The memory management for this class is very strange.  I wrote a
              large comment.  Hopefully a kind soul will come by and fix it.
        * Shared/Plugins/Netscape/NetscapePluginModule.cpp:
        (WebKit::NetscapePluginModule::unload):
        * UIProcess/API/mac/WKView.mm:
        (-[WKView _setFindIndicator:fadeOut:]):
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::setRootFullScreenLayer):
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::toStringVector):
        * WebProcess/Plugins/Netscape/NetscapePluginStream.cpp:
        (WebKit::NetscapePluginStream::stop):
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        (WebKit::WebInspectorFrontendClient::WebInspectorFrontendClient):
        * WebProcess/WebPage/DrawingArea.cpp:
        (WebKit::DrawingArea::create):

2011-04-29  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser.

        Pages with accelerated compositing do not redraw unless scrolled
        https://bugs.webkit.org/show_bug.cgi?id=59851

        Added a setNeedDisplay on the non-composited content layer after
        the size is changed so it paints the full size of the layer. Called
        only for the areas newly exposed, if any.

        * WebProcess/WebPage/ca/LayerTreeHostCA.cpp:
        (WebKit::LayerTreeHostCA::sizeDidChange):

2011-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam Roben.

        Need a way to handle CoreIPC messages on the connection work queue
        https://bugs.webkit.org/show_bug.cgi?id=59954

        Add a Connection::QueueClient abstract class. This class has a single pure virtual
        member function, willProcessMessageOnClientRunLoop which should return true if the message 
        should be forwarded to the next Connection::QueueClient in the list or Connection::Client's 
        run loop for processing and false otherwise. Users of Connection can use addQueueClient to
        add clients and all messages will be dispatched  to the queue clients first.

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::addQueueClient):
        (CoreIPC::Connection::removeQueueClient):
        (CoreIPC::Connection::processIncomingMessage):
        * Platform/CoreIPC/Connection.h:
        (CoreIPC::Connection::QueueClient::~QueueClient):

2011-05-02  Jeff Miller  <jeffm@apple.com>

        Reviewed by Adam Roben.

        WebKit2 thinks the web process is unresponsive when a plugin displays a context menu
        https://bugs.webkit.org/show_bug.cgi?id=59124
        <rdar://problem/9318600>
        
        This is the Windows version of <https://bugs.webkit.org/show_bug.cgi?id=58943>.

        Since we have no control over how long a plugin will take to handle an event, we need
        to tell the UI process to stop its responsive timer when we're about to send an event
        to the plugin. The downside of doing this is that if the plugin does become unresponsive,
        the user won't know this immediately until they click on the web page again.  At that point,
        if the web process is unresponsive because of a hung plugin, the responsiveness timer will fire.
        
        We're only doing this on Windows currently when running plugins in the web process (Anders fixed
        bug 58943 in a different way when running plugins in a separate plugin process on the Mac).

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::willSendEventToPlugin): Added, not used when running plugins in a separate process.
        * PluginProcess/PluginControllerProxy.h: Added willSendEventToPlugin().

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::stopResponsivenessTimer): Added.
        * UIProcess/WebPageProxy.h: Added stopResponsivenessTimer().
        * UIProcess/WebPageProxy.messages.in: Added StopResponsivenessTimer message.

        * WebProcess/Plugins/Netscape/win/NetscapePluginWin.cpp:
        (WebKit::NetscapePlugin::platformPaint): Tell our controller when we're about to send an event to the plugin.
        (WebKit::NetscapePlugin::platformHandleMouseEvent): Ditto.
        (WebKit::NetscapePlugin::platformHandleMouseEnterEvent): Ditto.
        (WebKit::NetscapePlugin::platformHandleMouseLeaveEvent): Ditto.

        * WebProcess/Plugins/PluginController.h: Added willSendEventToPlugin().
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::willSendEventToPlugin): Added, tell the UI process to stop its responsiveness timer.
        * WebProcess/Plugins/PluginView.h: Added willSendEventToPlugin().

2011-04-29  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Maciej Stachowiak.

        Plug-in failed to initialize message should be called when Java fails to initialize
        https://bugs.webkit.org/show_bug.cgi?id=59856
        
        To match the WebKit1 behavior, WebKit2 should dispatch the plug-in failed
        to initialize message when we can't instantiate the Java plug-in.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::createJavaAppletWidget):

2011-05-02  Sam Weinig  <sam@webkit.org>

        Reviewed by Adam Barth.

        Prune some #includes from DOMWindow.h
        https://bugs.webkit.org/show_bug.cgi?id=59907

        * WebProcess/WebPage/WebFrame.cpp:
        Add now missing SecurityOrigin.h #include.

2011-04-29  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Dan Bernstein.

        WebKit2: Crash closing tab with docked Web Inspector
        https://bugs.webkit.org/show_bug.cgi?id=59914
        <rdar://problem/9359672>
        
        When a tab is closed with a docked inspector, invalidate called platformClose, which
        didn't do the tear down that is needed, but is called when we close the web inspector explcitly.
        One part of tear down we weren't doing is removing ourselves as a WindowMessageBrodcaster listener
        on the inspected web view, and this can cause crashes.
        
        This patch also renames platformClose to platformDidClose, to be clearer about when the function
        is called.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::invalidate): Call didClose instead of platformClose.
        (WebKit::WebInspectorProxy::didClose): Call platformDidClose instead of platformClose.
        * UIProcess/WebInspectorProxy.h:
        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::platformDidClose): Renamed from platformClose.
        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::platformDidClose): Ditto.
        * UIProcess/gtk/WebInspectorGtk.cpp:
        (WebKit::WebInspectorProxy::platformDidClose): Ditto.
        * UIProcess/qt/WebInspectorProxyQt.cpp:
        (WebKit::WebInspectorProxy::platformDidClose): Ditto.

2011-05-01  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Prune some unnecessary #includes
        https://bugs.webkit.org/show_bug.cgi?id=59895

        Start getting rid of unnecessary #includes and forward declares.

        * WebProcess/Plugins/PluginView.cpp:
        * WebProcess/WebPage/WebPage.cpp:

2011-05-01  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Unreviewed buildfix after r85434.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::startDragDrop):
        * UIProcess/win/ChunkedUpdateDrawingAreaProxyWin.cpp:
        (WebKit::ChunkedUpdateDrawingAreaProxy::ensureBackingStore):
        (WebKit::ChunkedUpdateDrawingAreaProxy::drawUpdateChunkIntoBackingStore):
        * WebProcess/WebCoreSupport/win/WebDragClientWin.cpp:
        (WebKit::WebDragClient::startDrag):
        * WebProcess/WebPage/win/ChunkedUpdateDrawingAreaWin.cpp:
        (WebKit::ChunkedUpdateDrawingArea::paintIntoUpdateChunk):

2011-05-01  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Can't open document from skydrive.com in Microsoft Word
        https://bugs.webkit.org/show_bug.cgi?id=59891
        <rdar://problem/9354285>

        Add the AllowHalfBakedQuickDrawSupport quirk for the SharePoint plug-in.

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::NetscapePluginModule::determineQuirks):

2011-05-01  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Don't try to create a backing store for a 0x0 plug-in
        https://bugs.webkit.org/show_bug.cgi?id=59887

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::geometryDidChange):

2011-05-01  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        Sandbox violation by WebProcess for DownloadAssessment.plist
        https://bugs.webkit.org/show_bug.cgi?id=59879
        <rdar://problem/9326041>

        * WebProcess/com.apple.WebProcess.sb:
        Allow reading ~/Library/Preferences/com.apple.DownloadAssessment.plist

2011-05-01  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        Remove unnecessary keychain and CoreAudio debris from WebProcess sandbox
        https://bugs.webkit.org/show_bug.cgi?id=59873

        These rules have been obsoleted by <rdar://problem/9301520> and
        <rdar://problem/9181468>.

        * WebProcess/com.apple.WebProcess.sb:

2011-05-01  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        Simplify WebProcess sandbox with homedir-relative path filters.
        https://bugs.webkit.org/show_bug.cgi?id=59872

        * WebProcess/com.apple.WebProcess.sb:

2011-05-01  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        On-demand VPN support for sandboxed WebProcess.
        <rdar://problem/8994181>

        * WebProcess/com.apple.WebProcess.sb:

2011-04-30  Ivan Krstić  <ike@apple.com>

        Reviewed by Sam Weinig.

        Reindent WebProcess sandbox to standard scheme style
        https://bugs.webkit.org/show_bug.cgi?id=59870

        * WebProcess/com.apple.WebProcess.sb:

2011-04-28  Jer Noble  <jer.noble@apple.com>

        Reviewed by Jon Honeycutt.

        Implement FULLSCREEN_API on Windows, Part 1: Stubs
        https://bugs.webkit.org/show_bug.cgi?id=59778

        Add Windows specific stubs for WebKit2 full screen APIs.

        * UIProcess/win/WebFullScreenManagerProxyWin.cpp: Added.
        (WebKit::WebFullScreenManagerProxy::enterFullScreen): Added stub.
        (WebKit::WebFullScreenManagerProxy::exitFullScreen): Added stub.
        (WebKit::WebFullScreenManagerProxy::beganEnterFullScreenAnimation): Added stub.
        (WebKit::WebFullScreenManagerProxy::finishedEnterFullScreenAnimation): Added stub.
        (WebKit::WebFullScreenManagerProxy::beganExitFullScreenAnimation): Added stub.
        (WebKit::WebFullScreenManagerProxy::finishedExitFullScreenAnimation): Added stub.
        (WebKit::WebFullScreenManagerProxy::enterAcceleratedCompositingMode): Added stub.
        (WebKit::WebFullScreenManagerProxy::exitAcceleratedCompositingMode): Added stub.
        (WebKit::WebFullScreenManagerProxy::getFullScreenRect): Added stub.
        * WebProcess/FullScreen/win/WebFullScreenManagerWin.cpp: Added.
        (WebKit::WebFullScreenManager::create): Added. Returns a WebFullScreenManagerWin.
        (WebKit::WebFullScreenManagerWin::create): Added.
        (WebKit::WebFullScreenManagerWin::WebFullScreenManagerWin): Added.
        (WebKit::WebFullScreenManagerWin::~WebFullScreenManagerWin): Added.
        (WebKit::WebFullScreenManagerWin::setRootFullScreenLayer): Added stub.
        (WebKit::WebFullScreenManagerWin::beginEnterFullScreenAnimation): Added stub.
        (WebKit::WebFullScreenManagerWin::beginExitFullScreenAnimation): Added stub.
        * WebProcess/FullScreen/win/WebFullScreenManagerWin.h: Added.
        * win/WebKit2.vcproj: Added new classes.

2011-04-29  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Simon Fraser and Dan Bernstein.

        WebKit2: WebPluginTypeEnabled key is ignored when enumerating plug-ins
        https://bugs.webkit.org/show_bug.cgi?id=59852
        <rdar://problem/9314011>

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::getPluginInfoFromPropertyLists): Do what WebKit1 does (but in CF dialect). And yes,
        I've seen plists with both numbers and booleans used .

2011-04-29  Beth Dakin  <bdakin@apple.com>

        Reviewed by Simon Fraser.

        https://bugs.webkit.org/show_bug.cgi?id=59846
        Scrolling causes rounded bottom window corners to become square
        <rdar://problem/9234239>

        Keep track of the m_windowBottomCornerIntersectionRect in WKView. 
        Invalidate the rect before scrolling. And if the rect is non-zero during a 
        display, mask the corners, then set the rect to zero so that only displays that 
        happen right after a scroll bother to do this.
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::scrollView):
        * UIProcess/API/mac/WKView.mm:
        (-[WKView displayIfNeeded]):
        (-[WKView _cacheWindowBottomCornerRect]):
        * UIProcess/API/mac/WKViewInternal.h:

2011-04-29  Jia Pu  <jpu@apple.com>

        Reviewed by Sam Weinig.

        [Mac] Scrolling WK2 window should dismiss autocorrection panel.
        https://bugs.webkit.org/show_bug.cgi?id=59809
        <rdar://problem/9317410>

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::pageDidScroll): Dimiss autocorrection panel in this function.

2011-04-29  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Dan Bernstein.

        WebKit2: Typing with Input methods still enters Roman characters in Safari search field frequently
        https://bugs.webkit.org/show_bug.cgi?id=59829
        <rdar://problem/9336907>

        This patch regresses behavior somewhat in that inline input isn't discarded when something
        happens in an inactive window. This doesn't work well in shipping Safari either.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _notifyInputContextAboutDiscardedComposition]): Added a method that calls
        -discardMarkedText with a safety check.
        (-[WKView setMarkedText:selectedRange:replacementRange:]): Use it.
        (-[WKView _updateTextInputStateIncludingSecureInputState:]): Use it.
        (-[WKView _resetTextInputState]): Use it.

2011-04-29  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin.

        AX: Remote accessibility should build on snow leopard
        https://bugs.webkit.org/show_bug.cgi?id=59767

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _updateRemoteAccessibilityRegistration:]):
        (-[WKView viewDidMoveToWindow]):
        (-[WKView _setAccessibilityWebProcessToken:]):
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::platformInitialize):
        (WebKit::WebPage::registerUIProcessAccessibilityTokens):
        * WebProcess/mac/WebProcessMainMac.mm:
        (WebKit::WebProcessMain):

2011-04-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Add protection for shared memory failing to allocate
        <rdar://problem/9125287>
        https://bugs.webkit.org/show_bug.cgi?id=59842

        * Platform/mac/SharedMemoryMac.cpp:
        (WebKit::SharedMemory::create):
        Add logging in shared memory failure cases.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::display):
        Guard against ShareableBitmap failing to create a shared memory
        backing.

2011-04-28  Stephanie Lewis  <slewis@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=59776
        <rdar://problem/9287113> REGRESSION: Safari cold/warm launch time 15% to 2x regression
        On the first draw the WebProcess is just going to send us blank bits anyway so don't 
        pause waiting for the update.  Continue drawing a blank window until the WebProcess
        sends us the update.

        * UIProcess/DrawingAreaProxyImpl.cpp:
        (WebKit::DrawingAreaProxyImpl::DrawingAreaProxyImpl):
        (WebKit::DrawingAreaProxyImpl::paint):
        (WebKit::DrawingAreaProxyImpl::didUpdateBackingStoreState):
        (WebKit::DrawingAreaProxyImpl::sendUpdateBackingStoreState):
        * UIProcess/DrawingAreaProxyImpl.h:

2011-04-29  Jon Lee  <jonlee@apple.com>

        Reviewed by mitzpettel.

        REGRESSION (WebKit2): (Mac) Selection is gone after switching tabs (59721)
        <rdar://problem/9327332>
        https://bugs.webkit.org/show_bug.cgi?id=59721

        When resigning first responder status, check to see if we need to maintain an inactive
        selection in the web view. If we don't, we clear the selection.

        This also reverts the change made in 83814, since that was a different attempt to solve this same issue.

        * UIProcess/API/C/WKPage.cpp:
        (WKPageSetMaintainsInactiveSelection): Export setMaintainsInactiveSelection()
        * UIProcess/API/C/WKPage.h:
        * UIProcess/API/mac/WKView.mm:
        (-[WKView resignFirstResponder]): Check and see if we need to maintain the selection in the view prior to resigning.
        If not, we clear the selection
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::clearSelection): Send message across process boundary
        (WebKit::WebPageProxy::setMaintainsInactiveSelection): Sets variable
        * UIProcess/WebPageProxy.h: New member variable to keep track of whether we need to maintain the current selection
        (WebKit::WebPageProxy::maintainsInactiveSelection): Returns variable
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::setFocused): Reverting code to just set the focused bit instead of also clearing the selection
        (WebKit::WebPage::clearSelection):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in: add new ClearSelection() message

2011-04-29  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        Application cache doesn't work due to a sandbox violation
        https://bugs.webkit.org/show_bug.cgi?id=59818
        <rdar://problem/9346971>

        Add a sandbox extension for the application cache directory.

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode):
        (WebKit::WebProcessCreationParameters::decode):
        Encode and decode the sandbox extension handle.

        * Shared/WebProcessCreationParameters.h:
        Add a applicationCacheDirectoryExtensionHandle member.

        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::ensureWebProcess):
        If we have a non-empty application cache directory, create a sandbox extension
        and pass it to the creation parameters.

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::initializeWebProcess):
        Create and consume a sandbox extension.

        * WebProcess/WebProcess.h:
        Add an m_applicationCachePathExtension member variable.

2011-04-29  Dean Jackson  <dino@apple.com>

        Reviewed by Simon Fraser.

        Add ENABLE macro for WebKitAnimation
        https://bugs.webkit.org/show_bug.cgi?id=59729

        Add new feature to toggle WebKit Animation API.

        * Configurations/FeatureDefines.xcconfig:

2011-04-29  Anders Carlsson  <andersca@apple.com>

        Reviewed by Brian Weinstein.

        Crash when closing a tab that is unresponsive
        https://bugs.webkit.org/show_bug.cgi?id=59810
        <rdar://problem/9329133>

        Back out r84643 - there was no rationale for this change, and it's causing crashes.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::close):
        (WebKit::WebPageProxy::processDidCrash):

2011-04-29  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Rename page as pageProxy in WebKitWebViewBase
        https://bugs.webkit.org/show_bug.cgi?id=59790

        To avoid consufion between page client and page proxy. Also rename
        some methods to webkitWebViewBase* for consistency.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseFinalize):
        (webkitWebViewBaseExpose):
        (webkitWebViewBaseDraw):
        (webkitWebViewBaseSizeAllocate):
        (webkitWebViewBaseFocusInEvent):
        (webkitWebViewBaseFocusOutEvent):
        (webkitWebViewBaseKeyPressEvent):
        (webkitWebViewBaseKeyReleaseEvent):
        (webkitWebViewBaseButtonPressEvent):
        (webkitWebViewBaseButtonReleaseEvent):
        (webkitWebViewBaseScrollEvent):
        (webkitWebViewBaseMotionNotifyEvent):
        (webkit_web_view_base_class_init):
        (webkitWebViewBaseCreate):
        (webkitWebViewBaseGetPage):

2011-04-29  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix a crash after r85214.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkit_web_view_base_init): Add line to create the page client
        instance, removed by mistake in r85214.

2011-04-28  David Levin  <levin@chromium.org>

        Reviewed by Adam Barth.

        Remove IMAGE_RESIZER related code.
        https://bugs.webkit.org/show_bug.cgi?id=59735

        * Configurations/FeatureDefines.xcconfig:

2011-04-28  Sam Weinig  <sam@webkit.org>

        Reviewed by Gavin Barraclough.

        Original patch by Austin Jennings.

        <rdar://problem/9350288>
        Update sandbox profile for extension changes

        * WebProcess/com.apple.WebProcess.sb:

2011-04-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        Right-clicking on a Flash movie in an iframe shows the browser context menu
        https://bugs.webkit.org/show_bug.cgi?id=59760
        <rdar://problem/9340541>

        Move context menu event handling out into a separate function. Make sure to call
        EventHandler::sendContextMenuEvent on the event handler belonging to the frame of the
        node that was clicked, and not the main frame.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::handleContextMenuEvent):
        (WebKit::handleMouseEvent):

2011-04-28  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        Remove WML
        https://bugs.webkit.org/show_bug.cgi?id=59678

        Remove WML-related code in WebKit2.

        * Configurations/FeatureDefines.xcconfig:
        * WebProcess/WebPage/WebBackForwardListProxy.cpp:
        * WebProcess/WebPage/WebBackForwardListProxy.h:

2011-04-28  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Anders Carlsson.

        WebKit2: Frequent crashes in acceptsFirstMouse
        https://bugs.webkit.org/show_bug.cgi?id=59746
        <rdar://problem/9281270>

        The crash occurred when connection was null (and it can become null at any time).

        Added checks for the proxy being valid in all sync calls that lacked such.
        WebPageProxy::isValid() is not the same as WebProcessProxy::isValid(), but existing checks
        looked at the former, so I used that.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::firstRectForCharacterInSelectedRange):
        (WebKit::WebPageProxy::getSelectedText):
        (WebKit::WebPageProxy::gestureWillBegin):
        (WebKit::WebPageProxy::createSnapshotOfVisibleContent):
        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::setComposition):
        (WebKit::WebPageProxy::confirmComposition):
        (WebKit::WebPageProxy::confirmCompositionWithoutDisturbingSelection):
        (WebKit::WebPageProxy::insertText):
        (WebKit::WebPageProxy::getMarkedRange):
        (WebKit::WebPageProxy::getSelectedRange):
        (WebKit::WebPageProxy::getAttributedSubstringFromRange):
        (WebKit::WebPageProxy::characterIndexForPoint):
        (WebKit::WebPageProxy::firstRectForCharacterRange):
        (WebKit::WebPageProxy::executeKeypressCommands):
        (WebKit::WebPageProxy::writeSelectionToPasteboard):
        (WebKit::WebPageProxy::readSelectionFromPasteboard):
        (WebKit::WebPageProxy::shouldDelayWindowOrderingForEvent):
        (WebKit::WebPageProxy::acceptsFirstMouse):

2011-04-27  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Timothy Hatcher.

        Mac side of: WebKit2: Support docked mode for Web Inspector
        https://bugs.webkit.org/show_bug.cgi?id=59134
        <rdar://problem/8739005>

        Implement docking of the Web Inspector on Mac. This matches the Windows (WK1 and WK2) closely,
        where the inspector and the inspected view are siblings.

        * UIProcess/API/C/mac: Added.
        * UIProcess/API/C/mac/WKInspectorMac.h: Added.
        * UIProcess/API/mac/PageClientImpl.h:
        (WebKit::PageClientImpl::wkView): Returns the WKView.
        * UIProcess/PageClient.h:
        * UIProcess/WebInspectorProxy.h: The inspected view is now a WebInspectorWKView, so we can override tag.
        * UIProcess/WebPageProxy.h: Added a getter for the WKView.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (-[WebInspectorProxyObjCAdapter inspectedViewFrameDidChange:]): Calls through to WebInspectorProxy::inspectedViewFrameDidChange.
        (-[WebInspectorWKView tag]): Returns a constant defined in WKInspectorMac.h.
        (WebKit::WebInspectorProxy::platformCreateInspectorPage): Create a WebInspectorWKView instead of a WKView.
        (WebKit::WebInspectorProxy::platformClose): Removed a FIXME that isn't needed anymore (we always detach before closing).
        (WebKit::WebInspectorProxy::inspectedViewFrameDidChange): Place our inspector and the inspected view next to each other, assuming the
            bottom of the inspector is at the Y origin.
        (WebKit::WebInspectorProxy::platformAttach): Listen for changes to the inspected view's frame, and move the inspectorView from the
            detached inspector window to the superview of the inspected view (to make the inspector and inspected view siblings).
        (WebKit::WebInspectorProxy::platformDetach): Stop listening for changes to the inspected view's frame, and move the inspectorView
            back to the detached inspector window. We also resize the inspected view to take up the space the inspector took up before
            (assuming the bottom of the inspector was at the Y origin).
        (WebKit::WebInspectorProxy::platformSetAttachedWindowHeight): Resize the inspector's view, and call inspectedViewFrameDidChange (which
            syncs the inspector and the inspected view), and call setNeedsDisplay on both views.
        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::wkView):
        
        * WebKit2.xcodeproj/project.pbxproj: Add a new file.

2011-04-28  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Darin Adler.

        Crash under WKPageCreateSnapshotOfVisibleContent if there is no response from the Web Process
        in the allotted time.
        https://bugs.webkit.org/show_bug.cgi?id=59738

        If the handle is null, don't try to create a ShareableBitmap and then a WebImage out of it.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::createSnapshotOfVisibleContent):

2011-04-28  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Martin Robinson.

        [Gtk] Split JSC and WebCore builds
        https://bugs.webkit.org/show_bug.cgi?id=19428

        Build JavaScriptCore as a libtool shared library instead of a
        private convenience library.

        * GNUmakefile.am: adapt to new name for javascriptcore target.

2011-04-28  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/8773946> and https://bugs.webkit.org/show_bug.cgi?id=59614
        Client certificate authentication in WebKit2

        Project-file stuff:
        * WebKit2.xcodeproj/project.pbxproj:

        Allow WKCredentials to store certificates:
        * UIProcess/Authentication/WebCredential.cpp:
        (WebKit::WebCredential::WebCredential):
        (WebKit::WebCredential::certificateInfo):
        * UIProcess/Authentication/WebCredential.h:
        (WebKit::WebCredential::create):
        * UIProcess/API/C/WKCredential.cpp:
        (WKCredentialCreateWithCertificateInfo):
        * UIProcess/API/C/WKCredential.h:

        Pass the certificate info over the wire to the WebProcess:
        * UIProcess/Authentication/AuthenticationChallengeProxy.cpp:
        (WebKit::AuthenticationChallengeProxy::useCredential): 

        Change the WebProcess to prefer certificate info over basic credentials when responding to a challenge:
        * WebProcess/Authentication/AuthenticationManager.cpp:
        (WebKit::AuthenticationManager::tryUsePlatformCertificateInfoForChallenge): Stub for platforms other than Mac,
          as only Mac can currently respond to challenges with certificates.
        (WebKit::AuthenticationManager::useCredentialForChallenge):
        * WebProcess/Authentication/AuthenticationManager.h:
        * WebProcess/Authentication/AuthenticationManager.messages.in:
        * WebProcess/Authentication/mac: Added.
        * WebProcess/Authentication/mac/AuthenticationManager.mac.mm: Added.
        (WebKit::AuthenticationManager::tryUsePlatformCertificateInfoForChallenge): Recreate the identity and certificate
          chain and respond to the challenge with it.

        Add a newly required #include:
        * UIProcess/API/C/WKAuthenticationChallenge.cpp:
        * UIProcess/Authentication/AuthenticationDecisionListener.cpp:

2011-04-28  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] Click counting logic should be shared between WebKit1 and WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=59715

        Use the GtkClickCounter instead of doing click counting manually. This means that
        the code will now be shared between WebKit1 and WebKit2.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkit_web_view_base_init): Remove private member initialization.
        (webViewButtonPressEvent): Call into GtkClickCounter.

2011-04-28  Martin Robinson  <mrobinson@igalia.com>

        Build fix after r85197.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webViewExpose): Use cr.get() here.
        (webViewDraw): Small clean up.

2011-04-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Sam Weinig.

        [GTK] Remove WKURLCreateWithURL()
        https://bugs.webkit.org/show_bug.cgi?id=59691

        The name is a bit confusing and there's already
        WKURLCreateWithUTF8CString() in the C API.

        * UIProcess/API/C/gtk/WKView.cpp:
        * UIProcess/API/C/gtk/WKView.h:

2011-04-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Make WebKitWebViewBase public in the API
        https://bugs.webkit.org/show_bug.cgi?id=59689

        Add WebKitWebViewBasePrivate.h and move WebKitWebViewBase inernal
        methods to it. Rename get_type() method, since it's part of the
        public API and should follow gtk coding style.

        * GNUmakefile.am: Add WebKitWebViewBasePrivate.h.
        * UIProcess/API/C/gtk/WKView.cpp: Use WebKitWebViewBasePrivate.h.
        * UIProcess/API/gtk/PageClientImpl.cpp: Ditto.
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseFinalize):
        (webkit_web_view_base_init):
        (webViewSizeAllocate):
        (webViewFocusInEvent):
        (webViewFocusOutEvent):
        (webViewKeyPressEvent):
        (webViewKeyReleaseEvent):
        (webkit_web_view_base_class_init):
        * UIProcess/API/gtk/WebKitWebViewBase.h:
        * UIProcess/API/gtk/WebKitWebViewBasePrivate.h: Copied from Source/WebKit2/UIProcess/API/C/gtk/WKView.cpp.
        * UIProcess/gtk/ChunkedUpdateDrawingAreaProxyGtk.cpp: Use WebKitWebViewBasePrivate.h.

2011-04-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Move WebView to UIProcess/API/gtk
        https://bugs.webkit.org/show_bug.cgi?id=59686

        And rename it as PageClientImpl, since it's a page client
        implementation, not a web view.

        * GNUmakefile.am:
        * UIProcess/API/C/gtk/WKView.cpp:
        * UIProcess/API/gtk/PageClientImpl.cpp: Renamed from Source/WebKit2/UIProcess/gtk/WebView.cpp.
        (WebKit::backspaceCallback):
        (WebKit::selectAllCallback):
        (WebKit::cutClipboardCallback):
        (WebKit::copyClipboardCallback):
        (WebKit::pasteClipboardCallback):
        (WebKit::toggleOverwriteCallback):
        (WebKit::popupMenuCallback):
        (WebKit::showHelpCallback):
        (WebKit::deleteFromCursorCallback):
        (WebKit::moveCursorCallback):
        (WebKit::PageClientImpl::PageClientImpl):
        (WebKit::PageClientImpl::~PageClientImpl):
        (WebKit::PageClientImpl::getEditorCommandsForKeyEvent):
        (WebKit::PageClientImpl::createDrawingAreaProxy):
        (WebKit::PageClientImpl::setViewNeedsDisplay):
        (WebKit::PageClientImpl::displayView):
        (WebKit::PageClientImpl::scrollView):
        (WebKit::PageClientImpl::viewSize):
        (WebKit::PageClientImpl::isViewWindowActive):
        (WebKit::PageClientImpl::isViewFocused):
        (WebKit::PageClientImpl::isViewVisible):
        (WebKit::PageClientImpl::isViewInWindow):
        (WebKit::PageClientImpl::PageClientImpl::processDidCrash):
        (WebKit::PageClientImpl::didRelaunchProcess):
        (WebKit::PageClientImpl::takeFocus):
        (WebKit::PageClientImpl::toolTipChanged):
        (WebKit::PageClientImpl::setCursor):
        (WebKit::PageClientImpl::setViewportArguments):
        (WebKit::PageClientImpl::registerEditCommand):
        (WebKit::PageClientImpl::clearAllEditCommands):
        (WebKit::PageClientImpl::canUndoRedo):
        (WebKit::PageClientImpl::executeUndoRedo):
        (WebKit::PageClientImpl::convertToDeviceSpace):
        (WebKit::PageClientImpl::convertToUserSpace):
        (WebKit::PageClientImpl::windowToScreen):
        (WebKit::PageClientImpl::doneWithKeyEvent):
        (WebKit::PageClientImpl::didNotHandleKeyEvent):
        (WebKit::PageClientImpl::createPopupMenuProxy):
        (WebKit::PageClientImpl::createContextMenuProxy):
        (WebKit::PageClientImpl::setFindIndicator):
        (WebKit::PageClientImpl::pageDidEnterAcceleratedCompositing):
        (WebKit::PageClientImpl::pageDidLeaveAcceleratedCompositing):
        (WebKit::PageClientImpl::didCommitLoadForMainFrame):
        (WebKit::PageClientImpl::didFinishLoadingDataForCustomRepresentation):
        (WebKit::PageClientImpl::customRepresentationZoomFactor):
        (WebKit::PageClientImpl::setCustomRepresentationZoomFactor):
        (WebKit::PageClientImpl::pageClosed):
        (WebKit::PageClientImpl::didChangeScrollbarsForMainFrame):
        (WebKit::PageClientImpl::flashBackingStoreUpdates):
        (WebKit::PageClientImpl::findStringInCustomRepresentation):
        (WebKit::PageClientImpl::countStringMatchesInCustomRepresentation):
        * UIProcess/API/gtk/PageClientImpl.h: Renamed from Source/WebKit2/UIProcess/gtk/WebView.h.
        (WebKit::PageClientImpl::create):
        (WebKit::PageClientImpl::addPendingEditorCommand):
        (WebKit::PageClientImpl::userSpaceScaleFactor):
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseInit):
        (webkitWebViewBaseCreate):
        * UIProcess/API/gtk/WebKitWebViewBase.h:
        * UIProcess/gtk/ChunkedUpdateDrawingAreaProxyGtk.cpp:

2011-04-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Use the WebPage object in WebKitWebViewBase
        https://bugs.webkit.org/show_bug.cgi?id=59683

        It simplifies the implementation of the event callbacks. Remove
        also all the methods from the page client that are no longer
        needed.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseInit):
        (webViewExpose):
        (webViewDraw):
        (webViewSizeAllocate):
        (webViewFocusInEvent):
        (webViewFocusOutEvent):
        (webViewKeyPressEvent):
        (webViewKeyReleaseEvent):
        (webViewButtonPressEvent):
        (webViewButtonReleaseEvent):
        (webViewScrollEvent):
        (webViewMotionNotifyEvent):
        * UIProcess/API/gtk/WebKitWebViewBase.h:
        * UIProcess/gtk/WebView.cpp:
        (WebKit::WebView::WebView):
        (WebKit::WebView::createDrawingAreaProxy):
        * UIProcess/gtk/WebView.h:

2011-04-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Create the page client in the view widget
        https://bugs.webkit.org/show_bug.cgi?id=59679

        * UIProcess/API/C/gtk/WKView.cpp:
        (WKViewCreate): Simply create a new view widget and return it.
        (WKViewGetPage): Use webkitWebViewBaseGetPage().
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseFinalize): Use finalize instead of dispose to
        make sure it's called only once, and release the private struct too.
        (webkitWebViewBaseInit): Create the page client.
        (webkitWebViewBaseClassInit): Don't use GObject private data structure.
        (webkitWebViewBaseCreate): New method to create a
        WebKitWebViewBase for a given context and page group.
        (webkitWebViewBaseGetWebViewInstance):
        (webkitWebViewBaseGetPage):
        * UIProcess/API/gtk/WebKitWebViewBase.h:
        * UIProcess/gtk/WebView.cpp:
        (WebKit::WebView::page): Get the page from the view widget.
        (WebKit::WebView::handleFocusInEvent): Ditto.
        (WebKit::WebView::handleFocusOutEvent): Ditto.
        (WebKit::WebView::WebView): Page client is now created with a view widget.
        (WebKit::WebView::paint): Get the page from the view widget.
        (WebKit::WebView::setSize): Ditto.
        (WebKit::WebView::handleKeyboardEvent): Ditto.
        (WebKit::WebView::handleMouseEvent): Ditto.
        (WebKit::WebView::handleWheelEvent): Ditto.
        (WebKit::WebView::close): Ditto.
        (WebKit::WebView::createDrawingAreaProxy): Ditto.
        * UIProcess/gtk/WebView.h:
        (WebKit::WebView::create): The page client will be created as
        private by the view widget, so it doesn't need to be ref counted,
        use PassOwnPtr instead of PassRefPtr.

2011-04-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] PlatformWebView should be the view widget
        https://bugs.webkit.org/show_bug.cgi?id=59676

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseGetPage): Return the page of the view.
        * UIProcess/API/gtk/WebKitWebViewBase.h:
        * UIProcess/ChunkedUpdateDrawingAreaProxy.h: Map PlatformWebView
        to WebKitWebViewBase instead of the page client.
        * UIProcess/gtk/ChunkedUpdateDrawingAreaProxyGtk.cpp:
        (WebKit::ChunkedUpdateDrawingAreaProxy::page): Use the view widget
        directly.
        (WebKit::ChunkedUpdateDrawingAreaProxy::ensureBackingStore): Ditto.
        (WebKit::ChunkedUpdateDrawingAreaProxy::drawUpdateChunkIntoBackingStore): Ditto.
        * UIProcess/gtk/WebView.cpp:
        (WebKit::WebView::createDrawingAreaProxy): Pass the view widget to
        the DrawingAreaProxy constructor instead of the page client.
        * UIProcess/gtk/WebView.h: Remove getWebViewWindow() which is no
        longer needed.

2011-04-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] WKView should be a GtkWidget
        https://bugs.webkit.org/show_bug.cgi?id=59603

        * UIProcess/API/C/gtk/WKAPICastGtk.h: Map WKViewRef to
        WebKitWebViewBase instead of WebView.
        * UIProcess/API/C/gtk/WKView.h: Remove WKViewGetWindow().
        * UIProcess/API/C/gtk/WKView.cpp:
        (WKViewCreate): Return the view instead of the page client.
        (WKViewGetPage): Use WebKitWebViewBase API to get the page client
        containing the page.

2011-04-27  Sam Weinig  <sam@webkit.org>

        Reviewed by Adam Roben.

        WebKit2 needs to notify the client when a plugin fails to initialize
        https://bugs.webkit.org/show_bug.cgi?id=59657

        Add didFailToInitializePlugin client function and call it when a plugin
        fails to initialize.

        * UIProcess/API/C/WKPage.h:
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPage::QWKPage):
        * UIProcess/WebLoaderClient.cpp:
        (WebKit::WebLoaderClient::didFailToInitializePlugin):
        * UIProcess/WebLoaderClient.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didFailToInitializePlugin):
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::initializePlugin):

2011-04-27  Pratik Solanki  <psolanki@apple.com>

        Reviewed by Antti Koivisto.

        Part of WebCore should use CFNetwork-based loader on Mac
        https://bugs.webkit.org/show_bug.cgi?id=51836

        Add PLATFORM(WIN) ifdef around shouldCacheResponse.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.h:

2011-04-27  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Hang if a sync message handler invalidates the connection
        https://bugs.webkit.org/show_bug.cgi?id=59627

        If dispatching incoming messages while waiting for the sync reply caused the connection to be invalidated,
        we need to return early or we'll wait forever.

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::waitForSyncReply):

2011-04-27  Carlos Garcia Campos  <cgarcia@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Move WebViewWidget to UIProcess/API/gtk
        https://bugs.webkit.org/show_bug.cgi?id=59594

        API files should be under the API directory. This view widget will
        be used by both C and gtk high level API, so it has been renamed
        to WebKitWebViewBase.

        * GNUmakefile.am:
        * UIProcess/API/gtk/WebKitWebViewBase.cpp: Renamed from Source/WebKit2/UIProcess/gtk/WebViewWidget.cpp.
        (webkitWebViewBaseRealize):
        (webkitWebViewBaseContainerAdd):
        (webkitWebViewBaseDispose):
        (webkitWebViewBaseInit):
        (webViewExpose):
        (webViewDraw):
        (webViewSizeAllocate):
        (webViewFocusInEvent):
        (webViewFocusOutEvent):
        (webViewKeyPressEvent):
        (webViewKeyReleaseEvent):
        (getEventTime):
        (webViewButtonPressEvent):
        (webViewButtonReleaseEvent):
        (webViewScrollEvent):
        (webViewMotionNotifyEvent):
        (webkitWebViewBaseClassInit):
        (webkitWebViewBaseGetType):
        (webkitWebViewBaseGetWebViewInstance):
        (webkitWebViewBaseSetWebViewInstance):
        (webkitWebViewBaseGetIMContext):
        * UIProcess/API/gtk/WebKitWebViewBase.h: Renamed from Source/WebKit2/UIProcess/gtk/WebViewWidget.h.
        * UIProcess/gtk/WebView.cpp:
        (WebKit::WebView::WebView):

2011-04-26  Chang Shu  <cshu@webkit.org>

        Reviewed by Laszlo Gombos.

        WebKitTestRunner needs layoutTestController.addOriginAccessWhitelistEntry
        https://bugs.webkit.org/show_bug.cgi?id=42544

        Also implemented removeOriginAccessWhitelistEntry and resetOriginAccessWhitelists.

        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleAddOriginAccessWhitelistEntry):
        (WKBundleRemoveOriginAccessWhitelistEntry):
        (WKBundleResetOriginAccessWhitelists):
        * WebProcess/InjectedBundle/API/c/WKBundlePrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::addOriginAccessWhitelistEntry):
        (WebKit::InjectedBundle::removeOriginAccessWhitelistEntry):
        (WebKit::InjectedBundle::resetOriginAccessWhitelists):
        * WebProcess/InjectedBundle/InjectedBundle.h:

2011-04-26  Dan Bernstein  <mitz@apple.com>

        Build fix.

        * Configurations/CompilerVersion.xcconfig:

2011-04-26  Anders Carlsson  <andersca@apple.com>

        Fix 32-bit clang build.

        * PluginProcess/mac/PluginProcessMac.mm:
        (WebKit::windowCoversAnyScreen):
        * UIProcess/API/mac/WKTextInputWindowController.mm:
        (-[WKTextInputPanel init]):
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation):
        * WebProcess/Plugins/Netscape/mac/NetscapePluginMac.mm:
        (WebKit::flipScreenYCoordinate):
        (WebKit::computeFakeWindowBoundsRect):
        * WebProcess/WebPage/mac/AccessibilityWebPageObject.mm:
        (-[AccessibilityWebPageObject accessibilityHitTest:]):

2011-04-26  Sam Weinig  <sam@webkit.org>

        Reviewed by David Hyatt.

        Remove Datagrid from the tree
        https://bugs.webkit.org/show_bug.cgi?id=59543

        * Configurations/FeatureDefines.xcconfig:
        Remove feature.

2011-04-26  Chang Shu  <cshu@webkit.org>

        Reviewed by Laszlo Gombos.

        WebKitTestRunner needs layoutTestController.setAllowFileAccessFromFileURLs
        https://bugs.webkit.org/show_bug.cgi?id=57572

        Remove the unnecessary code that updates preference.

        * Shared/WebPreferencesStore.cpp:
        (WebKit::WebPreferencesStore::decode):
        * Shared/WebPreferencesStore.h:
        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleSetAllowUniversalAccessFromFileURLs):
        * WebProcess/InjectedBundle/API/c/WKBundlePrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::setAllowUniversalAccessFromFileURLs):
        (WebKit::InjectedBundle::setAllowFileAccessFromFileURLs):
        * WebProcess/InjectedBundle/InjectedBundle.h:

2011-04-26  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Steve Falkenburg.

        WebKit2: Docked Inspector doesn't behave well if inspected web view isn't at 0,0
        https://bugs.webkit.org/show_bug.cgi?id=59554
        <rdar://problem/9341188>
        
        Use GetWindowRect and ScreenToClient to properly place our inspector and inspected
        web views instead of using GetClientRect. We need to correctly handle the case where
        the inspected web view isn't at 0, 0.

        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::platformSetAttachedWindowHeight):

2011-04-26  Dan Bernstein  <mitz@apple.com>

        Reviewed by Mark Rowe.

        Choose the compiler based on the Xcode version for Snow Leopard debug builds.

        * Configurations/Base.xcconfig:
        * Configurations/CompilerVersion.xcconfig: Added.

2011-04-26  Balazs Kelemen  <kbalazs@webkit.org>

        Unreviewed build fix.

        * Platform/Region.cpp: Need to include stdio.h for printf
        (at least in my Qt-Linux environment).

2011-04-26  Mihai Parparita  <mihaip@chromium.org>

        Reviewed by Adam Barth.

        Turn off make built-in implicit rules for derived sources makefile
        https://bugs.webkit.org/show_bug.cgi?id=59418

        We don't use any of make's built-in implicit rules, turning them off
        speeds up parsing of the makefile.

        * WebKit2.xcodeproj/project.pbxproj:

2011-04-26  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix WebKit2 GTK build after r84785.

        * UIProcess/gtk/WebInspectorGtk.cpp:
        (WebKit::WebInspectorProxy::platformAttach):
        (WebKit::WebInspectorProxy::platformDetach):
        (WebKit::WebInspectorProxy::platformSetAttachedWindowHeight):

2011-04-26  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix WebKit2 GTK build after r84886

        * Platform/gtk/RunLoopGtk.cpp: Include WorkItem.h

2011-04-25  Adam Barth  <abarth@webkit.org>

        Reviewed by David Levin.

        WebKit2 should play nice with strict OwnPtrs
        https://bugs.webkit.org/show_bug.cgi?id=59426

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::waitForMessage):
            - Lack of OwnPtr in HashMap is sad face.  This code becomes very
              pretty if we could use OwnPtr in HashMap...
        * Platform/RunLoop.cpp:
        (RunLoop::performWork):
        (RunLoop::scheduleWork):
        * Platform/RunLoop.h:
        * Platform/mac/WorkQueueMac.cpp:
        (WorkQueue::executeWorkItem):
        * WebProcess/Plugins/Netscape/NetscapePluginStream.cpp:
        (WebKit::NetscapePluginStream::deliverData):

2011-04-25  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        WebKit2: Should be able to inspect Web Inspector in Debug Builds
        https://bugs.webkit.org/show_bug.cgi?id=59378

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::createInspectorPageGroup): Creates an inspector page group and enables
            developer extras in a debug build.
        (WebKit::WebInspectorProxy::inspectorPageGroup): Calls createInspectorPageGroup.

2011-04-25  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Timothy Hatcher.

        WebKit2: Web Inspector's style sidebar fails to display when inspecting element
        https://bugs.webkit.org/show_bug.cgi?id=58071
        <rdar://problem/9243093>
        
        When creating our WebKit2 inspector views, we were creating them on both Mac and Windows
        with the empty rect for their initial size. Before we sized them correctly, the inspector
        was calling window.innerWidth on them, which returned 0, making the sidebar take up 0 pixels.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::platformCreateInspectorPage): Create the window with the initial window width
            and height.
        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::platformCreateInspectorPage): Ditto.

2011-04-25  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        Windows part of - WebKit2: Support docked mode for Web Inspector
        https://bugs.webkit.org/show_bug.cgi?id=59134
        <rdar://problem/8739005>
        
        Implement attaching and detaching of the Web Inspector on Windows,
        and also support setAttachedWindowHeight when the user changes the height
        of the docked inspector.
        
        This patch doesn't remember whether the user prefers attached or detached, and
        doesn't remember the user's preferred docked height, but that will be a separate
        bug.
        
        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::attach): Set the attached flag and call platform-specific code.
        (WebKit::WebInspectorProxy::detach): Ditto.
        (WebKit::WebInspectorProxy::setAttachedWindowHeight): Call platform-specific code.
        (WebKit::WebInspectorProxy::didClose): Set m_isVisible before calling platformClose. platformClose
            calls detach if the inspector was docked, and detach needs to know whether or not the window is
            visible.
        * UIProcess/WebInspectorProxy.h:
        * UIProcess/WebInspectorProxy.messages.in: Add new messages.
        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::pageClient): Add a getter for the page client.
        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::windowReceivedMessage): Relay WM_WINDOWPOSCHANGING messages from the inspected
            web view to the WebInspectorProxy.
        (WebKit::WebInspectorProxy::onWebViewWindowPosChangingEvent): Resize the inspected web view to behave well
            with the docked inspector.
        (WebKit::WebInspectorProxy::platformClose): If we are attached, detach before destroying.
        (WebKit::WebInspectorProxy::platformAttach): Set the inspector's host window to be the inspected web view's parent
            window, so the inspected web view and the inspector are siblings.
        (WebKit::WebInspectorProxy::platformDetach): Set the inspector's host window to be the standalone inspector window.
        (WebKit::WebInspectorProxy::platformSetAttachedWindowHeight): Size the views.
        * WebProcess/WebCoreSupport/WebInspectorClient.cpp:
        * WebProcess/WebCoreSupport/WebInspectorClient.h:
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        (WebKit::WebInspectorFrontendClient::attachWindow): Call WebInspector::attach.
        (WebKit::WebInspectorFrontendClient::closeWindow): Add a call to the InspectorController to disconnect the inspector frontend
            from the inspector backend. Without this line, when we close the attached inspector, it won't re-open, because the
            inspector controller still thinks there is a frontend. This matches WebKit1's behavior, although it seems like this is
            something WebCore should handle.
        (WebKit::WebInspectorFrontendClient::detachWindow): Call WebInspector::detach.
        (WebKit::WebInspectorFrontendClient::setAttachedWindowHeight): Call WebInspector::setAttachedWindowHeight.
        * UIProcess/DrawingAreaProxyImpl.cpp:
        (WebKit::DrawingAreaImpl::sendUpdateBackingStoreState): Add an early return if the WebPageProxy's viewSize is empty. 
            This can be needed if the inspector takes up the whole view, and it is useful to prevent a possible synchronous message
            from the UIProcess -> WebProcess to update a backing store that isn't visible in the first place.
        * WebProcess/WebPage/WebInspector.cpp:
        (WebKit::WebInspector::attach): Send a message to the UIProcess.
        (WebKit::WebInspector::detach): Ditto.
        (WebKit::WebInspector::setAttachedWindowHeight): Ditto.
        * WebProcess/WebPage/WebInspector.h: Remove some dead code.

2011-04-25  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Alice Liu.

        WebKit2: Web Inspector: Support highlighting page elements
        https://bugs.webkit.org/show_bug.cgi?id=59263
        <rdar://problem/8767659>

        Support highlighting of page elements for the inspector in WebKit2 by
        having the WebInspectorClient be a PageOverlay Client and be responsible
        for calling InspectorController::drawNodeHighlight.

        * WebProcess/WebCoreSupport/WebInspectorClient.cpp:
        (WebKit::WebInspectorClient::highlight): Create our overlay if it hasn't been created,
            or call setNeedsDisplay if it has.
        (WebKit::WebInspectorClient::hideHighlight): Uninstall the page overlay if it exists.
        (WebKit::WebInspectorClient::pageOverlayDestroyed):
        (WebKit::WebInspectorClient::willMoveToWebPage): If it's being destroyed (moving to a null
            WebPage), clear the member variable.
        (WebKit::WebInspectorClient::didMoveToWebPage):
        (WebKit::WebInspectorClient::drawRect): Call InspectorController::drawNodeHighlight.
        (WebKit::WebInspectorClient::mouseEvent):
        * WebProcess/WebCoreSupport/WebInspectorClient.h:
        (WebKit::WebInspectorClient::WebInspectorClient): Add a new member variable.

2011-04-25  Jon Lee  <jonlee@apple.com>

        Reviewed by Maciej Stachowiak.

        Overlay scroller hard to see on pages with dark background (59183)
        https://bugs.webkit.org/show_bug.cgi?id=59183
        <rdar://problem/8975367>

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface): adding method to allow changing style
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::getDocumentBackgroundColor): refactoring to use common code for retrieving background color

2011-04-24  Dan Bernstein  <mitz@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/9329741> Reproducible crash in WebChromeClient::invalidateContentsAndWindow() on simonscat.com
        https://bugs.webkit.org/show_bug.cgi?id=59299

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::invalidateContentsAndWindow): Null-check the document.
        (WebKit::WebChromeClient::invalidateContentsForSlowScroll): Ditto.

2011-04-23  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r84740.
        http://trac.webkit.org/changeset/84740
        https://bugs.webkit.org/show_bug.cgi?id=59290

        change breaks apple internal builds and is incorrect
        (Requested by smfr on #webkit).

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface):

2011-04-22  Jon Lee  <jonlee@apple.com>

        Reviewed by Beth Dakin.

        Overlay scroller hard to see on pages with dark background (59183)
        https://bugs.webkit.org/show_bug.cgi?id=59183
        <rdar://problem/8975367>
        
        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface): adding method to allow changing style

2011-04-22  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Sam Weinig.

        WebKit2: Stop responsiveness timer before calling runOpenPanel
        https://bugs.webkit.org/show_bug.cgi?id=59268
        <rdar://problem/9327944>

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::runOpenPanel): Stop the timer before calling WebUIClient::runOpenPanel,
            because runOpenPanel can spin a nested run loop.

2011-04-22  Chang Shu  <cshu@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        WebKitTestRunner needs layoutTestController.setFrameFlatteningEnabled
        https://bugs.webkit.org/show_bug.cgi?id=42536

        * WebProcess/InjectedBundle/API/c/WKBundle.cpp:
        (WKBundleSetFrameFlatteningEnabled):
        * WebProcess/InjectedBundle/API/c/WKBundlePrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::setFrameFlatteningEnabled):
        * WebProcess/InjectedBundle/InjectedBundle.h:

2011-04-22  Alejandro G. Castro  <alex@igalia.com> and Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] Use the libWebCore.a convenience library when compiling WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=59258

        * GNUmakefile.am: Remove the libWebKit2 convenience library and use the
        libWebCore convenience library when compiling WebKit2. Not only does this
        maintain the CPPFLAGS isolation, it prevents double-compilation of WebCore
        in some cases.

2011-04-19  Jer Noble  <jer.noble@apple.com>

        Reviewed by Daniel Bates.

        Full Screen from within an <iframe> does not cause <iframe> to resize.
        https://bugs.webkit.org/show_bug.cgi?id=58638

        Tests: fullscreen/full-screen-frameset-allowed.html
               fullscreen/full-screen-frameset-not-allowed.html

        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]): Cancel the background animation
            if the full screen animation finishes first.
        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::WebFullScreenManagerMac): m_fullScreenRootLayer was uninitialized.

2011-04-22  Sam Weinig  <sam@webkit.org>

        Reviewed by Brian Weinstein.

        WebKit2: Implement JavaScript unresponsiveness callback
        https://bugs.webkit.org/show_bug.cgi?id=59248

        Add support for suspending JavaScript in response to a callback.

        * UIProcess/API/C/WKPage.h:
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPage::QWKPage):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::shouldInterruptJavaScript):
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * UIProcess/WebUIClient.cpp:
        (WebKit::WebUIClient::shouldInterruptJavaScript):
        * UIProcess/WebUIClient.h:
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::shouldInterruptJavaScript):

2011-04-22  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        Paint the bounding rect of the dirty region instead of individual rectangles when the region
        covers at least 3/4 of its bounds.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::shouldPaintBoundsRect): Use floating point math so that the logic that was supposed to
        achieve this actually works.

2011-04-22  Jer Noble  <jer.noble@apple.com>

        Reviewed by Maciej Stachowiak.

        Crash at WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation + 79
        https://bugs.webkit.org/show_bug.cgi?id=59225

        * WebProcess/FullScreen/mac/WebFullScreenManagerMac.mm:
        (WebKit::WebFullScreenManagerMac::beginEnterFullScreenAnimation): Guard against 
            m_fullScreenRootLayer being NULL.
        (WebKit::WebFullScreenManagerMac::beginExitFullScreenAnimation): Ditto.

2011-04-22  Jer Noble  <jer.noble@apple.com>

        Reviewed by Maciej Stachowiak.

        Allow MediaPlayerPrivateAVFoundation to be disabled via a preference.
        https://bugs.webkit.org/show_bug.cgi?id=59179

        Add API to allow the WebCore Settings preference to be called from the UIProcess.

        * Shared/WebPreferencesStore.h: Added new preference definition macro.
        * UIProcess/API/C/WKPreferences.cpp:
        (WKPreferencesSetAVFoundationEnabled): Added.
        (WKPreferencesGetAVFoundationEnabled): Added.
        * UIProcess/API/C/WKPreferences.h:
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences): Pass new preference along to WebCore
            Settings.

2011-04-22  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Sam Weinig.

        WebKit2: Stop Responsiveness Timer when WebPageProxy closes or WebProcess crashes
        https://bugs.webkit.org/show_bug.cgi?id=59210

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::close): Stop the responsiveness timer.
        (WebKit::WebPageProxy::processDidCrash): Ditto.

2011-04-21  Adam Roben  <aroben@apple.com>

        Give windowless plugins' context menus an owner window in the same thread as the plugin

        In some cases, plugins pass the WKView's HWND to the ::TrackPopupMenu API. ::TrackPopupMenu
        fails in this case because the WKView's HWND is owned by another process/thread. We work
        around this by hooking the ::TrackPopupMenu API and providing our own window that's in the
        same thread as the plugin instead.

        I couldn't figure out how to write a test for this. :-(

        Fixes <http://webkit.org/b/51063> <rdar://problem/8769281> REGRESSION (WebKit2): No context
        menu appears when right-clicking on windowless Flash plugin

        Reviewed by Brian Weinstein, and looked at suspiciously by Jeff Miller.

        * Platform/Module.h: Added installIATHook on Windows.

        * Platform/win/ModuleWin.cpp:
        (WebKit::overwriteReadOnlyMemory): New helper function. Basically a wrapper around memcpy,
        but uses ::VirtualProtect to allow writing to otherwise-read-only memory.
        (WebKit::findFunctionPointerAddress): New helper function. The first overload iterates over
        the imported modules and functions looking for the given one. If found, returns the address
        of the function pointer that is used when calling that function. The second overload calls
        the first, first passing it an enumerator for the image's imported modules, then passing it
        an iterator for the image's delay-loaded modules.
        (WebKit::Module::installIATHook): Added. Finds the address of the function pointer that's
        used when code in this module calls the given function, then overwrites the function pointer
        with the passed-in one. Future calls to the given function made by code in this module
        should then end up calling to the passed-in function instead of the original one.

        * Shared/Plugins/Netscape/NetscapePluginModule.h:
        (WebKit::NetscapePluginModule::module): Added this simple getter.

        * WebProcess/Plugins/Netscape/NetscapePlugin.h: Added some new Windows-only members.

        * WebProcess/Plugins/Netscape/win/NetscapePluginWin.cpp:
        (WebKit::CurrentPluginSetter::CurrentPluginSetter):
        (WebKit::CurrentPluginSetter::~CurrentPluginSetter):
        This RAII class sets/unsets the currentPlugin global.

        (WebKit::registerPluginView): Changed to use instanceHandle() instead of the mysterious
        gInstance.
        (WebKit::NetscapePlugin::platformPostInitialize): For windowless plugins, hook the
        ::TrackPopupMenu API and create a window to be used as the owner for context menus created
        by this plugin. (Also changed the ::CreateWindowExW call for windowed plugins to pass an
        instance handle so that the window will be associated with WebKit.dll instead of
        WebKit2WebProcess.exe. This should have no visible effect, but is more correct.)
        (WebKit::NetscapePlugin::platformDestroy): For windowless plugins, destroy the context menu
        owner window we created above.

        (WebKit::NetscapePlugin::platformPaint):
        (WebKit::NetscapePlugin::platformHandleMouseEvent):
        (WebKit::NetscapePlugin::platformHandleWheelEvent):
        (WebKit::NetscapePlugin::platformSetFocus):
        (WebKit::NetscapePlugin::platformHandleMouseEnterEvent):
        (WebKit::NetscapePlugin::platformHandleMouseLeaveEvent):
        (WebKit::NetscapePlugin::platformHandleKeyboardEvent):
        Set ourselves as the current plugin.

        (WebKit::NetscapePlugin::hookedTrackPopupMenu): Added. This is the function that actually
        gets called when windowless plugins call ::TrackPopupMenu. If the passed-in owner window is
        owned by the current thread, we have nothing to do; ::TrackPopupMenu should work just fine.
        Otherwise, we use the current plugin's context menu owner window as the context menu's
        owner. We also set focus to the new owner window because otherwise weird behavior results
        (e.g., it's possible to scroll the WKView while the context menu is up).

2011-04-21  Adam Roben  <aroben@apple.com>

        Use WebCore's do-nothing window class instead of creating our own

        Fixes <http://webkit.org/b/59102> WebKit has too many dummy window classes

        Reviewed by Anders Carlsson.

        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.cpp:
        (WebKit::createDummyWindow): Less code!

2011-04-22  Balazs Kelemen  <kbalazs@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt][WK2] Cannot play flash with NSPluginWrapper
        https://bugs.webkit.org/show_bug.cgi?id=59125

        * WebProcess/Plugins/Netscape/NetscapeBrowserFuncs.cpp:
        (WebKit::NPN_GetValue): Handle the case when we have been
        called with a null plugin instance.

2011-04-22  Andreas Kling  <andreas.kling@nokia.com>

        Reviewed by Sam Weinig.

        [Qt][WK2] Implement DrawingAreaImpl for Qt.
        https://bugs.webkit.org/show_bug.cgi?id=59171

        * WebKit2.pro: Build files necessary for DrawingAreaImpl.
        * DerivedSources.pro: Build message receivers for DrawingArea and DrawingAreaProxy.

        * Shared/qt/LayerTreeContextQt.cpp:
        (WebKit::LayerTreeContext::LayerTreeContext): Stub.
        (WebKit::LayerTreeContext::~LayerTreeContext): Stub.
        (WebKit::LayerTreeContext::encode): Stub.
        (WebKit::LayerTreeContext::decode): Stub.
        (WebKit::LayerTreeContext::isEmpty): Stub.
        (WebKit::operator==): Stub.

        * Shared/qt/ShareableBitmapQt.cpp:
        (WebKit::ShareableBitmap::paint): Don't translate the painter to accomodate the
        source rect. The rect is already adjusted at the call site.

        * UIProcess/API/qt/qgraphicswkview.h: Add "Impl" to QGraphicsWKView::BackingStoreType.

        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPagePrivate::createDrawingAreaProxy): Create DrawingAreaProxyImpl if requested.
        (QWKPagePrivate::paint): Call the correct paint() method for DrawingAreaProxyImpl,
        since this drawing area will simple ASSERT_NOT_REACHED() in the "normal" paint().

        * WebProcess/WebPage/DrawingArea.cpp:
        (WebKit::DrawingArea::create): Allow creation of DrawingAreaImpl for Qt.

        * UIProcess/BackingStore.h: Add Qt-specific types and backing store.

        * UIProcess/qt/BackingStoreQt.cpp:
        (WebKit::BackingStore::paint): Implemented.
        (WebKit::BackingStore::incorporateUpdate): Implemented.
        (WebKit::BackingStore::scroll): Implemented using QPixmap::scroll().

        * UIProcess/DrawingAreaProxy.h: Enable drawing area message receivers for Qt.
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didReceiveMessage): Ditto.
        * WebProcess/WebPage/DrawingArea.h: Ditto.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::didReceiveMessage): Ditto.

2011-04-22  Jon Honeycutt  <jhoneycutt@apple.com>

        WinCairo build fix. Unreviewed.

        * WebProcess/Downloads/curl/DownloadCurl.cpp:
        (WebKit::Download::useCredential):
        Stubbed.
        (WebKit::Download::continueWithoutCredential):
        Stubbed.
        (WebKit::Download::cancelAuthenticationChallenge):
        Stubbed.

2011-04-21  Jon Honeycutt  <jhoneycutt@apple.com>

        Need to support authentication for downloads in WebKit2 on Windows
        https://bugs.webkit.org/show_bug.cgi?id=59175
        <rdar://problem/9206151>
        <rdar://problem/8958280>

        Reviewed by Maciej Stachowiak.

        * WebProcess/Downloads/Download.cpp:
        Include DownloadAuthenticationClient.h.

        * WebProcess/Downloads/Download.h:
        Declare a function to get or create the authentication client, a member
        var to hold it, and functions that the client can call to use a
        credential, continue without a credential, or cancel an auth challenge.

        * WebProcess/Downloads/DownloadAuthenticationClient.cpp: Added.
        (WebKit::DownloadAuthenticationClient::DownloadAuthenticationClient):
        (WebKit::DownloadAuthenticationClient::receivedCredential):
        Tell the Download to use the credential.
        (WebKit::DownloadAuthenticationClient::receivedRequestToContinueWithoutCredential):
        Tell the Download to continue with credentials.
        (WebKit::DownloadAuthenticationClient::receivedCancellation):
        Tell the Download to cancel the challenge.

        * WebProcess/Downloads/DownloadAuthenticationClient.h: Added.
        (WebKit::DownloadAuthenticationClient::create):
        Return a new DownloadAuthenticationClient.
        (WebKit::DownloadAuthenticationClient::detach):
        Clear the Download.
        (WebKit::DownloadAuthenticationClient::refAuthenticationClient):
        (WebKit::DownloadAuthenticationClient::derefAuthenticationClient):

        * WebProcess/Downloads/cfnet/DownloadCFNet.cpp:
        (WebKit::Download::useCredential):
        Create a CFURLCredentialRef from the WebCore credential, and tell
        CFNetwork to use it for the auth challenge.
        (WebKit::Download::continueWithoutCredential):
        Call CFURLDownloadUseCredential with a null credential.
        (WebKit::Download::cancelAuthenticationChallenge):
        Cancel the download, and clear m_download.
        (WebKit::Download::authenticationClient):
        Create if needed and return a DownloadAuthenticationClient.
        (WebKit::Download::platformInvalidate):
        Detach the DownloadAuthenticationClient.
        (WebKit::didReceiveAuthenticationChallengeCallback):
        Call Download::didReceiveAuthenticationChallenge(), passing a
        WebCore::AuthenticationChallenge with our DownloadAuthenticationClient.
        (WebKit::Download::receivedCredential):
        Get the client from the auth challenge, and call through to it.
        (WebKit::Download::receivedRequestToContinueWithoutCredential):
        Ditto.
        (WebKit::Download::receivedCancellation):
        Ditto.

        * win/WebKit2.vcproj:
        Add new files to project.

2011-04-21  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Maciej Stachowiak.

        Minimize synchronous calls during loading
        https://bugs.webkit.org/show_bug.cgi?id=59169

        <rdar://problem/9320128> REGRESSION(r84526): WK2 windows unresponsive

        * UIProcess/API/mac/WKView.mm:
        (-[WKView resignFirstResponder]):
        (-[WKView _resetTextInputState]):
        Made _resetTextInputState deal with client side state only, letting Editor composition be
        discarded more discriminately.

2011-04-21  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Adam Roben.

        Add a feature define to allow <details> and <summary> to be disabled
        https://bugs.webkit.org/show_bug.cgi?id=59118
        <rdar://problem/9257045>

        * Configurations/FeatureDefines.xcconfig:

2011-04-21  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/9311103>

        Remove unnecessary QTKitServer and Apple Events permissions
        from the WebProcess sandbox.

        * WebProcess/com.apple.WebProcess.sb:

2011-04-21  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/9033535>

        Mute sandbox violations when attempting to read a temporary
        CFNetwork keychain.

        * WebProcess/com.apple.WebProcess.sb:

2011-04-21  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by Sam Weinig.

        Add Frame* to the argument lists of canCopyCut and canPaste
        https://bugs.webkit.org/show_bug.cgi?id=59153

        * WebProcess/WebCoreSupport/WebEditorClient.cpp:
        (WebKit::WebEditorClient::canCopyCut):
        (WebKit::WebEditorClient::canPaste):
        * WebProcess/WebCoreSupport/WebEditorClient.h:

2011-04-21  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/8774116>

        The WebProcess sandbox should only allow access to the
        parts of the Darwin cache directory needed by the Security
        framework.

        * WebProcess/com.apple.WebProcess.sb:

2011-04-21  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/9311053>

        The WebProcess sandbox should not allow opening arbitrary
        IOKit user clients. Restrict to a whitelist required for normal
        WebProcess operation, including sound and accelerated graphics.

        * WebProcess/com.apple.WebProcess.sb:

2011-04-21  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/9311037>

        The WebProcess sandbox should not allow modification of the
        CoreAudio component cache.

        * WebProcess/com.apple.WebProcess.sb:

2011-04-21  Ivan Krstić  <ike@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/9263428>

        The WebProcess sandbox should only allow outbound networking
        to remote destinations and local kernel controls.

        * WebProcess/com.apple.WebProcess.sb:

2011-04-21  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r82052.
        http://trac.webkit.org/changeset/82052
        https://bugs.webkit.org/show_bug.cgi?id=59135

        New full screen api should be opt-in, not opt-out. (Requested
        by jernoble on #webkit).

        * Shared/WebPreferencesStore.h:

2011-04-21  Beth Dakin  <bdakin@apple.com>

        Reviewed by Dan Bernstein.

        https://bugs.webkit.org/show_bug.cgi?id=59048
        Need to track whether overlay scrollbar is currently visible and in lower-
        righthand corner
        -and corresponding-
        <rdar://problem/9211232>

        WebPageProxy now stores an IntRect of the scroller thumb set by WebCore through 
        the client.

        _windowResizeMouseLocationIsInVisibleScrollerThumb tests if the parameter point is 
        inside the cached scroller thumb rect.
        * UIProcess/API/mac/WKView.mm:
        (-[WKView _windowResizeMouseLocationIsInVisibleScrollerThumb:]):

        Client work to cache the rect.
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::WebPageProxy):
        (WebKit::WebPageProxy::close):
        (WebKit::WebPageProxy::processDidCrash):
        (WebKit::WebPageProxy::notifyScrollerThumbIsVisibleInRect):
        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::visibleScrollerThumbRect):
        * UIProcess/WebPageProxy.messages.in:
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::notifyScrollerThumbIsVisibleInRect):
        * WebProcess/WebCoreSupport/WebChromeClient.h:

        New WebSystemInterface is needed by WebCore for this.
        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface):

2011-04-21  Andreas Kling  <andreas.kling@nokia.com>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt][WK2] Emit QWKPage::urlChanged() when navigating within the same document.
        https://bugs.webkit.org/show_bug.cgi?id=59044

        Hook up the didSameDocumentNavigationForFrame callback to QWKPage::urlChanged().

        * UIProcess/API/qt/ClientImpl.cpp:
        (qt_wk_didSameDocumentNavigationForFrame):
        * UIProcess/API/qt/ClientImpl.h:
        * UIProcess/API/qt/qwkpage.cpp:
        (QWKPage::QWKPage):

2011-04-20  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Maciej Stachowiak.

        WebKit2: Unconfirmed inline input session persists after reload
        https://bugs.webkit.org/show_bug.cgi?id=59054
        <rdar://problem/9291086>

        Makes the inline input get properly confirmed or discarded when changing selection,
        navigating to another page, focusing another view in the window, or after a web process
        crash.

        * Shared/EditorState.h: (WebKit::EditorState::EditorState):
        * WebProcess/WebPage/WebPage.cpp: (WebKit::WebPage::editorState):
        Added a variable that Editor sets while processing input method calls. We don't want
        selection changes caused by -setMarkedText: discard the composition!
        
        * UIProcess/PageClient.h:
        * UIProcess/API/mac/PageClientImpl.h:
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::updateTextInputState):
        (WebKit::PageClientImpl::resetTextInputState):
        Extended updateSecureInputState() to potentially confirm the current inline input session.
        Added resetTextInputState, which is to be called when we get out of the current web page.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView resignFirstResponder]): Just call _resetTextInputState instead of dealing with
        input state here.
        (-[WKView _updateSecureInputState]): Use _isFocused to make the code simpler.
        (-[WKView _updateTextInputStateIncludingSecureInputState:]): Confirm the current inline
        input session if selection changed for any other reason but an input method changing the
        composition. We will want to do other work here, like dismissing a dictionary pop-up,
        updating a font panel etc.
        (-[WKView _resetTextInputState]): Added. We don't want secure text input persist after
        navigations, crashes an such, and we also don't want input methods to remember inline input
        state. Relying on selection changed notifications is fragile and insufficient.

        * UIProcess/API/mac/WKViewInternal.h: Added internal functions to keep the build unbroken.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didCommitLoadForFrame): This is the best chance we have to reset input
        state for a new page. This doesn't work well for cached page loads, but WK1 is quite broken
        in that case, too.
        (WebKit::WebPageProxy::editorStateChanged): Moved some logic up to the client, since the
        function now does much more than before.

        * UIProcess/WebPageProxy.h:
        * UIProcess/mac/WebPageProxyMac.mm: (WebKit::WebPageProxy::confirmCompositionWithoutDisturbingSelection):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:
        * WebProcess/WebPage/mac/WebPageMac.mm: (WebKit::WebPage::confirmCompositionWithoutDisturbingSelection):
        Added confirmCompositionWithoutDisturbingSelection(). When we confirm the composition due
        to selection change, we obvisouly don't want the selection to move back.

2011-04-21  Sam Weinig  <sam@webkit.org>

        Reviewed by Simon Fraser.

        Remove warnings from DrawingAreaImpl and related classes
        https://bugs.webkit.org/show_bug.cgi?id=59120

        DrawingAreaImpl is mature enough for others to adopt. Remove warnings.

        * UIProcess/BackingStore.cpp:
        * UIProcess/DrawingAreaProxyImpl.cpp:
        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        * WebProcess/WebPage/LayerTreeHost.cpp:

2011-04-21  Sam Weinig  <sam@webkit.org>

        Reviewed by Simon Fraser.

        Deploy GraphicsContextStateSaver in WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=59116

        * UIProcess/FindIndicator.cpp:
        (WebKit::FindIndicator::draw):
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::paint):
        * WebProcess/WebPage/FindController.cpp:
        (WebKit::FindController::drawRect):
        * WebProcess/WebPage/PageOverlay.cpp:
        (WebKit::PageOverlay::drawRect):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::drawRect):
        (WebKit::WebPage::drawPageOverlay):

2011-04-21  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Sam Weinig.

        WebKit2: Need a way to get a snapshot of the visible contents of a page from the UI Process.
        https://bugs.webkit.org/show_bug.cgi?id=59035

        Added a sync call from the UI Process to the Web Process with comments saying that it should
        be removed as soon as possible.

        * UIProcess/API/C/WKPage.cpp:
        (WKPageVisibleContentsSnapshot):
        * UIProcess/API/C/WKPagePrivate.h:

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::createSnapshotOfVisibleContent):
        * UIProcess/WebPageProxy.h:

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createSnapshotOfVisibleContent):
        Ask the FrameView for the visibleContentRect, and call scaledSnapshotInDocumentCoordinates
        with a scale factor of 1 (which preserves the current scaling of the page - e.g. if the
        page is already zoomed then the snapshot will reflect the zoomed content).
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:

2011-04-20  Dominic Cooney  <dominicc@chromium.org>

        Reviewed by Dimitri Glazkov.

        layoutTestController can create and destroy shadow DOM
        https://bugs.webkit.org/show_bug.cgi?id=59058

        Support for new methods in WK2 WebKitTestRunner.

        * WebProcess/InjectedBundle/API/c/WKBundleNodeHandle.cpp:
        (WKBundleNodeHandleCopyElementEnsureShadowRoot):
        (WKBundleNodeHandleRemoveShadowRoot):
        * WebProcess/InjectedBundle/API/c/WKBundleNodeHandlePrivate.h:
        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp:
        (WebKit::InjectedBundleNodeHandle::elementShadowRoot):
        (WebKit::InjectedBundleNodeHandle::elementEnsureShadowRoot):
        (WebKit::InjectedBundleNodeHandle::elementRemoveShadowRoot):
        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.h:

2011-04-20  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Don't discard backing stores for hung web processes
        https://bugs.webkit.org/show_bug.cgi?id=59039
        <rdar://problem/9237090>

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::viewStateDidChange):
        (WebKit::WebPageProxy::processDidBecomeUnresponsive):
        (WebKit::WebPageProxy::processDidBecomeResponsive):
        Call updateBackingStoreDiscardableState.

        (WebKit::WebPageProxy::updateBackingStoreDiscardableState):
        Never mark the backing store as discardable if the web process is hung

2011-04-20  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Sam Weinig.

        Reproducible crash under WebPageProxy::didReceiveEvent
        https://bugs.webkit.org/show_bug.cgi?id=59036
        <rdar://problem/9252083>

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _resendKeyDownEvent:]): Protect against self-destruction
        when re-dispatching the event.        
        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::createWebPage): Fixed a type mismatch
        I noticed while debugging.

2011-04-20  Timothy Hatcher  <timothy@apple.com>

        Make the Web Insepctor come to the front when a breakpoint is hit.

        <https://webkit.org/b/57480> REGRESSION (WebKit2): Inspector doesn't come to the front when a breakpoint is hit in the debugger
        <rdar://problem/9209472>

        Reviewed by Adam Roben.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::bringToFront): Added. Call platformBringToFront.
        * UIProcess/WebInspectorProxy.h:
        * UIProcess/WebInspectorProxy.messages.in: Added BringToFront.
        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::platformBringToFront): Added. Call orderFront:.
        * UIProcess/win/WebInspectorProxyWin.cpp:
        (WebKit::WebInspectorProxy::platformBringToFront): Added. Call ShowWindow.
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        (WebKit::WebInspectorFrontendClient::bringToFront): Call WebInspector::bringToFront.
        * WebProcess/WebPage/WebInspector.cpp:
        (WebKit::WebInspector::bringToFront): Added. Send WebInspectorProxy::BringToFront message.
        * WebProcess/WebPage/WebInspector.h: Added bringToFront.

2011-04-20  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Adam Roben.

        REGRESSION (WebKit2): CSS animations on pages that use accelerated compositing stop after switching tabs
        https://bugs.webkit.org/show_bug.cgi?id=57868
        
        Subclassed setRootCompositingLayer so it can call ensureAnimationsSubmitted on Win.

        * WebProcess/WebPage/ca/LayerTreeHostCA.h:
            Make setRootCompositingLayer protected so it can be called from subclass
        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.cpp:
            Override setRootCompositingLayer to add call to root layer's
            PlatformCALayer::ensureAnimationsSubmitted method
        * WebProcess/WebPage/ca/win/LayerTreeHostCAWin.h:

2011-04-18  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Dan Bernstein.

        Adopt QTKit API for listing and deleting file in its media cache.
        <rdar://problem/9130029> 

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface): Initialize new functions.

2011-04-20  Alejandro G. Castro  <alex@igalia.com>

        Fixed GTK+ compilation after r84206.

        * GNUmakefile.am:

2011-04-20  Adam Roben  <aroben@apple.com>

        Remove some unnecessary VS junk related to NativeWebMouseEventWin.cpp

        * win/WebKit2.vcproj:

2011-04-20  Balazs Kelemen  <kbalazs@webkit.org>

        Reviewed by Csaba Osztrogonác.

        [Qt] Cleanup includepath adjustment for generated files
        https://bugs.webkit.org/show_bug.cgi?id=58869

        * WebKit2.pri: Add the directory of generated files to the include
        path with absolute path to make it valid in the final build step.

2011-04-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        UI process thinks the page is unresponsive when a plug-in is showing a context menu
        https://bugs.webkit.org/show_bug.cgi?id=58943
        <rdar://problem/9299901>

        Change the HandleMouseEvent message to have a delayed reply and make the PluginControllerProxy
        respond to it immediately, before even passing the event to the plug-in. Since it doesn't matter
        for mouse events whether the plug-in handled them or not we can do this.

        Another solution could have been to make handleMouseEvent an asynchronous message, but that could
        mess up the message ordering so this seemed like the least intrusive change.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::handleMouseEvent):
        * PluginProcess/PluginControllerProxy.h:
        * PluginProcess/PluginControllerProxy.messages.in:

2011-04-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Terminate hung plug-in processes after 45 seconds
        https://bugs.webkit.org/show_bug.cgi?id=58932
        <rdar://problem/8083219>

        * UIProcess/Plugins/PluginProcessManager.cpp:
        (WebKit::PluginProcessManager::pluginSyncMessageSendTimedOut):
        Find the plug-in process proxy and terminate it.

        (WebKit::PluginProcessManager::pluginProcessWithPath):
        Add new helper function.

        (WebKit::PluginProcessManager::getOrCreatePluginProcess):
        Call pluginProcessWithPath.

        * UIProcess/Plugins/PluginProcessProxy.cpp:
        (WebKit::PluginProcessProxy::terminate):
        Terminate the process.

        * UIProcess/Plugins/PluginProcessProxy.h:
        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::pluginSyncMessageSendTimedOut):
        Call PluginProcessManager::pluginSyncMessageSendTimedOut.

        * UIProcess/WebProcessProxy.h:
        * UIProcess/WebProcessProxy.messages.in:
        Add PluginSyncMessageSendTimedOut message.

        * WebProcess/Plugins/PluginProcessConnection.cpp:
        (WebKit::defaultSyncMessageTimeout):
        (WebKit::PluginProcessConnection::PluginProcessConnection):
        Set a sync message timeout on the plug-in process connection.

        (WebKit::PluginProcessConnection::syncMessageSendTimedOut):
        Send a message to the web process proxy.

2011-04-19  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Adele Peterson.

        WebKit2: Merge SelectionState and TextInputState
        https://bugs.webkit.org/show_bug.cgi?id=58919

        Combined TextInputState and EditorState in one structure, which is updated whenever we get
        a chance to. There is no sense to keep possibly stale SelectionState data when we have already
        requested the most recent data synchronously.

        This also simplifies the code, as we don't need to pass the state around in a separate variable.

        * GNUmakefile.am:
        * Scripts/webkit2/messages.py:
        * Shared/EditorState.h: Copied from Source/WebKit2/Shared/SelectionState.h.
        (WebKit::EditorState::EditorState):
        * Shared/SelectionState.h: Removed.
        * Shared/mac/TextInputState.h: Removed.
        * UIProcess/API/mac/PageClientImpl.h:
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::interpretKeyEvent):
        * UIProcess/API/mac/WKView.mm:
        (-[WKView validRequestorForSendType:returnType:]):
        (-[WKView validateUserInterfaceItem:]):
        (-[WKView shouldDelayWindowOrderingForEvent:]):
        (-[WKView doCommandBySelector:]):
        (-[WKView insertText:replacementRange:]):
        (-[WKView _handleStyleKeyEquivalent:]):
        (-[WKView _executeSavedKeypressCommands]):
        (-[WKView inputContext]):
        (-[WKView hasMarkedText]):
        (-[WKView unmarkText]):
        (-[WKView setMarkedText:selectedRange:replacementRange:]):
        (-[WKView attributedSubstringForProposedRange:actualRange:]):
        (-[WKView _interpretKeyEvent:savingCommandsTo:WebCore::]):
        (-[WKView _updateSecureInputState]):
        * UIProcess/API/mac/WKViewInternal.h:
        * UIProcess/PageClient.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::editorStateChanged):
        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::editorState):
        (WebKit::WebPageProxy::hasSelectedRange):
        (WebKit::WebPageProxy::isContentEditable):
        * UIProcess/WebPageProxy.messages.in:
        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::setComposition):
        (WebKit::WebPageProxy::confirmComposition):
        (WebKit::WebPageProxy::insertText):
        (WebKit::WebPageProxy::executeKeypressCommands):
        (WebKit::WebPageProxy::writeSelectionToPasteboard):
        (WebKit::WebPageProxy::readSelectionFromPasteboard):
        (WebKit::WebPageProxy::interpretQueuedKeyEvent):
        * UIProcess/win/WebView.cpp:
        (WebKit::WebView::compositionSelectionChanged):
        (WebKit::WebView::onIMEComposition):
        (WebKit::WebView::onIMEEndComposition):
        (WebKit::WebView::onIMERequestCharPosition):
        (WebKit::WebView::onIMERequest):
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/WebCoreSupport/WebEditorClient.cpp:
        (WebKit::WebEditorClient::respondToChangedSelection):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::editorState):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::handleEditingKeyboardEvent):
        (WebKit::WebPage::setComposition):
        (WebKit::WebPage::confirmComposition):
        (WebKit::WebPage::insertText):
        (WebKit::WebPage::executeKeypressCommands):
        * win/WebKit2.vcproj:

2011-04-19  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Timothy Hatcher.

        100% reproducible crash when right-clicking any element in Web Inspector on any page
        https://bugs.webkit.org/show_bug.cgi?id=58822

        Web Inspector changes selection from JavaScript, and checks in UI process are insufficient
        when selection is changing asynchronously.

        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::writeSelectionToPasteboard): Check that there is a selection, matching WK1
        and UI process side. Perhaps the check should really be in WebCore, but for now, it's a
        WebKit responsibility.
        (WebKit::WebPage::readSelectionFromPasteboard): Same check, for no other reason but consistency.

2011-04-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Add syncMessageSendTimedOut CoreIPC Connection::Client member function
        https://bugs.webkit.org/show_bug.cgi?id=58928

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::waitForSyncReply):
        Call syncMessageSendTimedOut.

        * Platform/CoreIPC/Connection.h:
        Add syncMessageSendTimedOut to Connection::Client.

        * PluginProcess/PluginProcess.cpp:
        * PluginProcess/PluginProcess.h:
        * PluginProcess/WebProcessConnection.cpp:
        * PluginProcess/WebProcessConnection.h:
        * UIProcess/Plugins/PluginProcessProxy.cpp:
        * UIProcess/Plugins/PluginProcessProxy.h:
        * UIProcess/WebProcessProxy.cpp:
        * UIProcess/WebProcessProxy.h:
        * WebProcess/Plugins/PluginProcessConnection.cpp:
        * WebProcess/Plugins/PluginProcessConnection.h:
        * WebProcess/WebProcess.cpp:
        * WebProcess/WebProcess.h:
        Add syncMessageSendTimedOut stubs.

2011-04-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Alexey Proskuryakov.

        Replace the didFailToSendSyncMessage Connection::Client function with a flag
        https://bugs.webkit.org/show_bug.cgi?id=58923

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::Connection):
        Initialize m_shouldExitOnSyncMessageSendFailure to false.

        (CoreIPC::Connection::setShouldExitOnSyncMessageSendFailure):
        Set m_didCloseOnConnectionWorkQueueCallback.

        (CoreIPC::Connection::sendSyncMessage):
        Call didFailToSendSyncMessage if we fail to send the sync message for some reason.

        (CoreIPC::Connection::didFailToSendSyncMessage):
        if m_shouldExitOnSyncMessageSendFailure is true, exit.

        * Platform/CoreIPC/Connection.h:
        Remove didFailToSendSyncMessage from Connection::Client.

        * PluginProcess/PluginProcess.cpp:
        * PluginProcess/PluginProcess.h:
        Remove didFailToSendSyncMessage.

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::initialize):
        * WebProcess/WebProcess.h:
        Remove didFailToSendSyncMessage. Call setShouldExitOnSyncMessageSendFailure on our
        UI process connection.

2011-04-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Add a way to set the default sync message timeout for a CoreIPC connection
        https://bugs.webkit.org/show_bug.cgi?id=58908

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::Connection):
        Initialize m_defaultSyncMessageTimeout.

        (CoreIPC::Connection::setDefaultSyncMessageTimeout):
        Set the m_defaultSyncMessageTimeout member variable.

        (CoreIPC::Connection::waitForSyncReply):
        Handle the timeout being one of our two special magic values.

        * Platform/CoreIPC/Connection.h:
        Add a DefaultTimeout constant and change the NoTimeout constant to be -1.

2011-04-19  Vsevolod Vlasov  <vsevik@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: Rename lengthReceived to encodedDataLength/dataLength
        https://bugs.webkit.org/show_bug.cgi?id=58883

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::dispatchDidReceiveContentLength):
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.h:

2011-04-19  Andreas Kling  <andreas.kling@nokia.com>

        Reviewed by Antonio Gomes.

        WebKit2: Typo fix in WebPopupMenu::Type.
        https://bugs.webkit.org/show_bug.cgi?id=58891

        Fixed a typo, Seperator -> Separator.
        Also removed m_ prefix on an argument variable name.

        * Shared/WebPopupItem.h:
        * UIProcess/mac/WebPopupMenuProxyMac.mm:
        (WebKit::WebPopupMenuProxyMac::populate):
        * WebProcess/WebCoreSupport/WebPopupMenu.cpp:
        (WebKit::WebPopupMenu::populateItems):

2011-04-19  Jon Honeycutt  <jhoneycutt@apple.com>

        WKContextDownloadURLRequest() should return a WKDownloadRef
        https://bugs.webkit.org/show_bug.cgi?id=58867
        Part of <rdar://problem/8931717>

        Reviewed by Steve Falkenburg.

        * UIProcess/API/C/WKContext.cpp:
        (WKContextDownloadURLRequest):
        Return the result of calling WebContext::download().

        * UIProcess/API/C/WKContext.h:
        Updated return type of WKContextDownloadURLRequest().

        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::download):
        Return the DownloadProxy returned by createDownloadProxy().
        (WebKit::WebContext::createDownloadProxy):
        Return the DownloadProxy.

        * UIProcess/WebContext.h:
        Changed return type of download() and createDownloadProxy().

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::receivedPolicyDecision):
        Call the DownloadProxy's downloadID() function to get the ID.

2011-04-18  Jia Pu  <jpu@apple.com>

        Reviewed by Mark Rowe.

        WebKit needs to stop importing <AppKit/NSTextChecker.h>
        https://bugs.webkit.org/show_bug.cgi?id=58798
        <rdar://problem/9294938>

        Use public header <AppKit/NSSpellChecker.h> instead.

        * UIProcess/mac/CorrectionPanel.h:
        * UIProcess/mac/CorrectionPanel.mm:
        (correctionIndicatorType):
        (WebKit::CorrectionPanel::show):
        (WebKit::CorrectionPanel::dismissInternal):
        (WebKit::CorrectionPanel::handleAcceptedReplacement):
        * UIProcess/mac/TextCheckerMac.mm:
        * WebProcess/WebCoreSupport/mac/WebEditorClientMac.mm:

2011-04-05  Jer Noble  <jer.noble@apple.com>

        Reviewed by Sam Weinig.

        WebKit2: WKTR should support WebKit2 full screen APIs
        https://bugs.webkit.org/show_bug.cgi?id=56318

        Add a new WKBundlePage API for Full Screen events, and move some of the implementation
        of WebFullScreenManager into the new InjectedBundlePageFullScreenClient class, so that
        the default behavior can be overridden by a WKBundlePageFullScreenClient.

        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/FullScreen/WebFullScreenManager.cpp:
        (WebKit::WebFullScreenManager::supportsFullScreen): Moved contents into InjectedBundlePageFullScreenClient.
        (WebKit::WebFullScreenManager::enterFullScreenForElement): Ditto.
        (WebKit::WebFullScreenManager::exitFullScreenForElement): Ditto.
